/* DeviceManagerX11.c generated by valac 0.56.17, the Vala compiler
 * generated from DeviceManagerX11.vala, do not modify */

/*
 * Copyright (c) 2019 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 */

#include "wacom.h"
#include <gee.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <glib.h>
#include <gdk/x11/gdkx.h>
#include <stdlib.h>
#include <string.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Xutil.h>
#include <X11/Xregion.h>
#include <X11/extensions/XInput2.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	WACOM_BACKEND_DEVICE_MANAGER_X11_0_PROPERTY,
	WACOM_BACKEND_DEVICE_MANAGER_X11_NUM_PROPERTIES
};
static GParamSpec* wacom_backend_device_manager_x11_properties[WACOM_BACKEND_DEVICE_MANAGER_X11_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _WacomBackendDeviceManagerX11Private {
	GeeHashMap* devices;
};

static gint WacomBackendDeviceManagerX11_private_offset;
static gpointer wacom_backend_device_manager_x11_parent_class = NULL;

static void wacom_backend_device_manager_x11_add_device (WacomBackendDeviceManagerX11* self,
                                                  GdkDevice* gdk_device);
static void _wacom_backend_device_manager_x11_add_device_gdk_seat_device_added (GdkSeat* _sender,
                                                                         GdkDevice* device,
                                                                         gpointer self);
static void wacom_backend_device_manager_x11_remove_device (WacomBackendDeviceManagerX11* self,
                                                     GdkDevice* gdk_device);
static void _wacom_backend_device_manager_x11_remove_device_gdk_seat_device_removed (GdkSeat* _sender,
                                                                              GdkDevice* device,
                                                                              gpointer self);
static gchar* wacom_backend_device_manager_x11_get_xdevice_node (gint id);
static WacomBackendDevice* wacom_backend_device_manager_x11_create_device (GdkDevice* gdk_device,
                                                                    const gchar* device_file);
static WacomBackendDeviceDeviceType wacom_backend_device_manager_x11_get_device_type (GdkDevice* device);
static GeeArrayList* wacom_backend_device_manager_x11_real_list_devices (WacomBackendDeviceManager* base,
                                                                  WacomBackendDeviceDeviceType type);
static WacomBackendDevice* wacom_backend_device_manager_x11_real_lookup_gdk_device (WacomBackendDeviceManager* base,
                                                                             GdkDevice* device);
static void wacom_backend_device_manager_x11_finalize (GObject * obj);
static GType wacom_backend_device_manager_x11_get_type_once (void);

static inline gpointer
wacom_backend_device_manager_x11_get_instance_private (WacomBackendDeviceManagerX11* self)
{
	return G_STRUCT_MEMBER_P (self, WacomBackendDeviceManagerX11_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 26 "../src/Backend/DeviceManagerX11.vala"
	return self ? g_object_ref (self) : NULL;
#line 94 "DeviceManagerX11.c"
}

static void
_wacom_backend_device_manager_x11_add_device_gdk_seat_device_added (GdkSeat* _sender,
                                                                    GdkDevice* device,
                                                                    gpointer self)
{
#line 27 "../src/Backend/DeviceManagerX11.vala"
	wacom_backend_device_manager_x11_add_device ((WacomBackendDeviceManagerX11*) self, device);
#line 104 "DeviceManagerX11.c"
}

static void
_wacom_backend_device_manager_x11_remove_device_gdk_seat_device_removed (GdkSeat* _sender,
                                                                         GdkDevice* device,
                                                                         gpointer self)
{
#line 28 "../src/Backend/DeviceManagerX11.vala"
	wacom_backend_device_manager_x11_remove_device ((WacomBackendDeviceManagerX11*) self, device);
#line 114 "DeviceManagerX11.c"
}

WacomBackendDeviceManagerX11*
wacom_backend_device_manager_x11_construct (GType object_type)
{
	WacomBackendDeviceManagerX11 * self = NULL;
	GeeHashMap* _tmp0_;
	GdkSeat* seat = NULL;
	GdkDisplay* _tmp1_;
	GdkSeat* _tmp2_;
	GdkSeat* _tmp3_;
	GdkSeat* _tmp4_;
	GdkSeat* _tmp5_;
	GList* devices = NULL;
	GdkSeat* _tmp6_;
	GList* _tmp7_;
	GList* _tmp8_;
#line 23 "../src/Backend/DeviceManagerX11.vala"
	self = (WacomBackendDeviceManagerX11*) wacom_backend_device_manager_construct (object_type);
#line 24 "../src/Backend/DeviceManagerX11.vala"
	_tmp0_ = gee_hash_map_new (gdk_device_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, WACOM_BACKEND_TYPE_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 24 "../src/Backend/DeviceManagerX11.vala"
	_g_object_unref0 (self->priv->devices);
#line 24 "../src/Backend/DeviceManagerX11.vala"
	self->priv->devices = _tmp0_;
#line 26 "../src/Backend/DeviceManagerX11.vala"
	_tmp1_ = gdk_display_get_default ();
#line 26 "../src/Backend/DeviceManagerX11.vala"
	_tmp2_ = gdk_display_get_default_seat (_tmp1_);
#line 26 "../src/Backend/DeviceManagerX11.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 26 "../src/Backend/DeviceManagerX11.vala"
	seat = _tmp3_;
#line 27 "../src/Backend/DeviceManagerX11.vala"
	_tmp4_ = seat;
#line 27 "../src/Backend/DeviceManagerX11.vala"
	g_signal_connect_object (_tmp4_, "device-added", (GCallback) _wacom_backend_device_manager_x11_add_device_gdk_seat_device_added, self, 0);
#line 28 "../src/Backend/DeviceManagerX11.vala"
	_tmp5_ = seat;
#line 28 "../src/Backend/DeviceManagerX11.vala"
	g_signal_connect_object (_tmp5_, "device-removed", (GCallback) _wacom_backend_device_manager_x11_remove_device_gdk_seat_device_removed, self, 0);
#line 30 "../src/Backend/DeviceManagerX11.vala"
	_tmp6_ = seat;
#line 30 "../src/Backend/DeviceManagerX11.vala"
	_tmp7_ = gdk_seat_get_devices (_tmp6_, GDK_SEAT_CAPABILITY_ALL);
#line 30 "../src/Backend/DeviceManagerX11.vala"
	devices = _tmp7_;
#line 31 "../src/Backend/DeviceManagerX11.vala"
	_tmp8_ = devices;
#line 164 "DeviceManagerX11.c"
	{
		GList* device_collection = NULL;
		GList* device_it = NULL;
#line 31 "../src/Backend/DeviceManagerX11.vala"
		device_collection = _tmp8_;
#line 31 "../src/Backend/DeviceManagerX11.vala"
		for (device_it = device_collection; device_it != NULL; device_it = device_it->next) {
#line 172 "DeviceManagerX11.c"
			GdkDevice* device = NULL;
#line 31 "../src/Backend/DeviceManagerX11.vala"
			device = (GdkDevice*) device_it->data;
#line 176 "DeviceManagerX11.c"
			{
				GdkDevice* _tmp9_;
#line 32 "../src/Backend/DeviceManagerX11.vala"
				_tmp9_ = device;
#line 32 "../src/Backend/DeviceManagerX11.vala"
				wacom_backend_device_manager_x11_add_device (self, _tmp9_);
#line 183 "DeviceManagerX11.c"
			}
		}
	}
#line 23 "../src/Backend/DeviceManagerX11.vala"
	(devices == NULL) ? NULL : (devices = (g_list_free (devices), NULL));
#line 23 "../src/Backend/DeviceManagerX11.vala"
	_g_object_unref0 (seat);
#line 23 "../src/Backend/DeviceManagerX11.vala"
	return self;
#line 193 "DeviceManagerX11.c"
}

WacomBackendDeviceManagerX11*
wacom_backend_device_manager_x11_new (void)
{
#line 23 "../src/Backend/DeviceManagerX11.vala"
	return wacom_backend_device_manager_x11_construct (WACOM_BACKEND_TYPE_DEVICE_MANAGER_X11);
#line 201 "DeviceManagerX11.c"
}

static void
wacom_backend_device_manager_x11_add_device (WacomBackendDeviceManagerX11* self,
                                             GdkDevice* gdk_device)
{
	gint id = 0;
	gchar* device_file = NULL;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	WacomBackendDevice* device = NULL;
	GeeHashMap* _tmp4_;
	gpointer _tmp5_;
	WacomBackendDevice* _tmp6_;
#line 36 "../src/Backend/DeviceManagerX11.vala"
	g_return_if_fail (self != NULL);
#line 36 "../src/Backend/DeviceManagerX11.vala"
	g_return_if_fail (gdk_device != NULL);
#line 37 "../src/Backend/DeviceManagerX11.vala"
	id = -1;
#line 38 "../src/Backend/DeviceManagerX11.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (gdk_device, gdk_x11_device_xi2_get_type ())) {
#line 224 "DeviceManagerX11.c"
		gint _tmp0_;
		gint _tmp1_;
#line 39 "../src/Backend/DeviceManagerX11.vala"
		g_object_get (G_TYPE_CHECK_INSTANCE_CAST (gdk_device, gdk_x11_device_xi2_get_type (), GdkX11DeviceXI2), "device-id", &_tmp0_, NULL);
#line 39 "../src/Backend/DeviceManagerX11.vala"
		_tmp1_ = _tmp0_;
#line 39 "../src/Backend/DeviceManagerX11.vala"
		id = _tmp1_;
#line 233 "DeviceManagerX11.c"
	}
#line 42 "../src/Backend/DeviceManagerX11.vala"
	if (id == -1) {
#line 43 "../src/Backend/DeviceManagerX11.vala"
		return;
#line 239 "DeviceManagerX11.c"
	}
#line 46 "../src/Backend/DeviceManagerX11.vala"
	_tmp2_ = wacom_backend_device_manager_x11_get_xdevice_node (id);
#line 46 "../src/Backend/DeviceManagerX11.vala"
	device_file = _tmp2_;
#line 47 "../src/Backend/DeviceManagerX11.vala"
	_tmp3_ = device_file;
#line 47 "../src/Backend/DeviceManagerX11.vala"
	if (_tmp3_ == NULL) {
#line 48 "../src/Backend/DeviceManagerX11.vala"
		_g_free0 (device_file);
#line 48 "../src/Backend/DeviceManagerX11.vala"
		return;
#line 253 "DeviceManagerX11.c"
	}
#line 51 "../src/Backend/DeviceManagerX11.vala"
	_tmp4_ = self->priv->devices;
#line 51 "../src/Backend/DeviceManagerX11.vala"
	_tmp5_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp4_, gdk_device);
#line 51 "../src/Backend/DeviceManagerX11.vala"
	device = (WacomBackendDevice*) _tmp5_;
#line 52 "../src/Backend/DeviceManagerX11.vala"
	_tmp6_ = device;
#line 52 "../src/Backend/DeviceManagerX11.vala"
	if (_tmp6_ != NULL) {
#line 265 "DeviceManagerX11.c"
		WacomBackendDevice* _tmp7_;
#line 53 "../src/Backend/DeviceManagerX11.vala"
		_tmp7_ = device;
#line 53 "../src/Backend/DeviceManagerX11.vala"
		g_signal_emit_by_name ((WacomBackendDeviceManager*) self, "device-changed", _tmp7_);
#line 271 "DeviceManagerX11.c"
	} else {
		const gchar* _tmp8_;
		WacomBackendDevice* _tmp9_;
		GeeHashMap* _tmp10_;
		WacomBackendDevice* _tmp11_;
		WacomBackendDevice* _tmp12_;
#line 55 "../src/Backend/DeviceManagerX11.vala"
		_tmp8_ = device_file;
#line 55 "../src/Backend/DeviceManagerX11.vala"
		_tmp9_ = wacom_backend_device_manager_x11_create_device (gdk_device, _tmp8_);
#line 55 "../src/Backend/DeviceManagerX11.vala"
		_g_object_unref0 (device);
#line 55 "../src/Backend/DeviceManagerX11.vala"
		device = _tmp9_;
#line 56 "../src/Backend/DeviceManagerX11.vala"
		_tmp10_ = self->priv->devices;
#line 56 "../src/Backend/DeviceManagerX11.vala"
		_tmp11_ = device;
#line 56 "../src/Backend/DeviceManagerX11.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp10_, gdk_device, _tmp11_);
#line 57 "../src/Backend/DeviceManagerX11.vala"
		_tmp12_ = device;
#line 57 "../src/Backend/DeviceManagerX11.vala"
		g_signal_emit_by_name ((WacomBackendDeviceManager*) self, "device-added", _tmp12_);
#line 296 "DeviceManagerX11.c"
	}
#line 36 "../src/Backend/DeviceManagerX11.vala"
	_g_object_unref0 (device);
#line 36 "../src/Backend/DeviceManagerX11.vala"
	_g_free0 (device_file);
#line 302 "DeviceManagerX11.c"
}

static WacomBackendDevice*
wacom_backend_device_manager_x11_create_device (GdkDevice* gdk_device,
                                                const gchar* device_file)
{
	WacomBackendDevice* device = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	WacomBackendDevice* _tmp5_ = NULL;
	WacomBackendDevice* result;
#line 61 "../src/Backend/DeviceManagerX11.vala"
	g_return_val_if_fail (gdk_device != NULL, NULL);
#line 61 "../src/Backend/DeviceManagerX11.vala"
	g_return_val_if_fail (device_file != NULL, NULL);
#line 62 "../src/Backend/DeviceManagerX11.vala"
	_tmp0_ = g_strdup (device_file);
#line 62 "../src/Backend/DeviceManagerX11.vala"
	_tmp1_ = gdk_device_get_vendor_id (gdk_device);
#line 62 "../src/Backend/DeviceManagerX11.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 62 "../src/Backend/DeviceManagerX11.vala"
	_tmp3_ = gdk_device_get_product_id (gdk_device);
#line 62 "../src/Backend/DeviceManagerX11.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 62 "../src/Backend/DeviceManagerX11.vala"
	_tmp5_ = wacom_backend_device_new ();
#line 62 "../src/Backend/DeviceManagerX11.vala"
	wacom_backend_device_set_device_file (_tmp5_, _tmp0_);
#line 62 "../src/Backend/DeviceManagerX11.vala"
	_g_free0 (_tmp0_);
#line 62 "../src/Backend/DeviceManagerX11.vala"
	wacom_backend_device_set_vendor_id (_tmp5_, _tmp2_);
#line 62 "../src/Backend/DeviceManagerX11.vala"
	_g_free0 (_tmp2_);
#line 62 "../src/Backend/DeviceManagerX11.vala"
	wacom_backend_device_set_product_id (_tmp5_, _tmp4_);
#line 62 "../src/Backend/DeviceManagerX11.vala"
	_g_free0 (_tmp4_);
#line 62 "../src/Backend/DeviceManagerX11.vala"
	wacom_backend_device_set_dev_type (_tmp5_, wacom_backend_device_manager_x11_get_device_type (gdk_device));
#line 62 "../src/Backend/DeviceManagerX11.vala"
	device = _tmp5_;
#line 69 "../src/Backend/DeviceManagerX11.vala"
	result = device;
#line 69 "../src/Backend/DeviceManagerX11.vala"
	return result;
#line 353 "DeviceManagerX11.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 372 "DeviceManagerX11.c"
}

static WacomBackendDeviceDeviceType
wacom_backend_device_manager_x11_get_device_type (GdkDevice* device)
{
	GdkInputSource source = 0;
	WacomBackendDeviceDeviceType result;
#line 72 "../src/Backend/DeviceManagerX11.vala"
	g_return_val_if_fail (device != NULL, 0U);
#line 73 "../src/Backend/DeviceManagerX11.vala"
	source = gdk_device_get_source (device);
#line 74 "../src/Backend/DeviceManagerX11.vala"
	switch (source) {
#line 74 "../src/Backend/DeviceManagerX11.vala"
		case GDK_SOURCE_MOUSE:
#line 74 "../src/Backend/DeviceManagerX11.vala"
		case GDK_SOURCE_TRACKPOINT:
#line 390 "DeviceManagerX11.c"
		{
#line 77 "../src/Backend/DeviceManagerX11.vala"
			result = WACOM_BACKEND_DEVICE_DEVICE_TYPE_MOUSE;
#line 77 "../src/Backend/DeviceManagerX11.vala"
			return result;
#line 396 "DeviceManagerX11.c"
		}
#line 74 "../src/Backend/DeviceManagerX11.vala"
		case GDK_SOURCE_PEN:
#line 400 "DeviceManagerX11.c"
		{
			const gchar* _tmp0_;
			const gchar* _tmp1_;
#line 79 "../src/Backend/DeviceManagerX11.vala"
			_tmp0_ = gdk_device_get_name (device);
#line 79 "../src/Backend/DeviceManagerX11.vala"
			_tmp1_ = _tmp0_;
#line 79 "../src/Backend/DeviceManagerX11.vala"
			if (string_contains (_tmp1_, "pad")) {
#line 80 "../src/Backend/DeviceManagerX11.vala"
				result = WACOM_BACKEND_DEVICE_DEVICE_TYPE_TABLET | WACOM_BACKEND_DEVICE_DEVICE_TYPE_PAD;
#line 80 "../src/Backend/DeviceManagerX11.vala"
				return result;
#line 414 "DeviceManagerX11.c"
			}
#line 83 "../src/Backend/DeviceManagerX11.vala"
			result = WACOM_BACKEND_DEVICE_DEVICE_TYPE_TABLET;
#line 83 "../src/Backend/DeviceManagerX11.vala"
			return result;
#line 420 "DeviceManagerX11.c"
		}
#line 74 "../src/Backend/DeviceManagerX11.vala"
		case GDK_SOURCE_KEYBOARD:
#line 424 "DeviceManagerX11.c"
		{
#line 85 "../src/Backend/DeviceManagerX11.vala"
			result = WACOM_BACKEND_DEVICE_DEVICE_TYPE_KEYBOARD;
#line 85 "../src/Backend/DeviceManagerX11.vala"
			return result;
#line 430 "DeviceManagerX11.c"
		}
#line 74 "../src/Backend/DeviceManagerX11.vala"
		case GDK_SOURCE_TOUCHSCREEN:
#line 434 "DeviceManagerX11.c"
		{
#line 87 "../src/Backend/DeviceManagerX11.vala"
			result = WACOM_BACKEND_DEVICE_DEVICE_TYPE_TOUCHSCREEN;
#line 87 "../src/Backend/DeviceManagerX11.vala"
			return result;
#line 440 "DeviceManagerX11.c"
		}
#line 74 "../src/Backend/DeviceManagerX11.vala"
		case GDK_SOURCE_TOUCHPAD:
#line 444 "DeviceManagerX11.c"
		{
#line 89 "../src/Backend/DeviceManagerX11.vala"
			result = WACOM_BACKEND_DEVICE_DEVICE_TYPE_TOUCHPAD;
#line 89 "../src/Backend/DeviceManagerX11.vala"
			return result;
#line 450 "DeviceManagerX11.c"
		}
#line 74 "../src/Backend/DeviceManagerX11.vala"
		case GDK_SOURCE_TABLET_PAD:
#line 454 "DeviceManagerX11.c"
		{
#line 91 "../src/Backend/DeviceManagerX11.vala"
			result = WACOM_BACKEND_DEVICE_DEVICE_TYPE_TABLET | WACOM_BACKEND_DEVICE_DEVICE_TYPE_PAD;
#line 91 "../src/Backend/DeviceManagerX11.vala"
			return result;
#line 460 "DeviceManagerX11.c"
		}
		default:
		{
#line 93 "../src/Backend/DeviceManagerX11.vala"
			result = 0;
#line 93 "../src/Backend/DeviceManagerX11.vala"
			return result;
#line 468 "DeviceManagerX11.c"
		}
	}
}

static void
wacom_backend_device_manager_x11_remove_device (WacomBackendDeviceManagerX11* self,
                                                GdkDevice* gdk_device)
{
	WacomBackendDevice* device = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	WacomBackendDevice* _tmp2_;
#line 97 "../src/Backend/DeviceManagerX11.vala"
	g_return_if_fail (self != NULL);
#line 97 "../src/Backend/DeviceManagerX11.vala"
	g_return_if_fail (gdk_device != NULL);
#line 98 "../src/Backend/DeviceManagerX11.vala"
	_tmp0_ = self->priv->devices;
#line 98 "../src/Backend/DeviceManagerX11.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, gdk_device);
#line 98 "../src/Backend/DeviceManagerX11.vala"
	device = (WacomBackendDevice*) _tmp1_;
#line 100 "../src/Backend/DeviceManagerX11.vala"
	_tmp2_ = device;
#line 100 "../src/Backend/DeviceManagerX11.vala"
	if (_tmp2_ != NULL) {
#line 495 "DeviceManagerX11.c"
		WacomBackendDevice* _tmp3_;
		GeeHashMap* _tmp4_;
#line 101 "../src/Backend/DeviceManagerX11.vala"
		_tmp3_ = device;
#line 101 "../src/Backend/DeviceManagerX11.vala"
		g_signal_emit_by_name ((WacomBackendDeviceManager*) self, "device-removed", _tmp3_);
#line 102 "../src/Backend/DeviceManagerX11.vala"
		_tmp4_ = self->priv->devices;
#line 102 "../src/Backend/DeviceManagerX11.vala"
		gee_abstract_map_unset ((GeeAbstractMap*) _tmp4_, gdk_device, NULL);
#line 506 "DeviceManagerX11.c"
	}
#line 97 "../src/Backend/DeviceManagerX11.vala"
	_g_object_unref0 (device);
#line 510 "DeviceManagerX11.c"
}

static gchar*
wacom_backend_device_manager_x11_get_xdevice_node (gint id)
{
	GdkDisplay* _tmp0_;
	GdkX11Display* display = NULL;
	GdkDisplay* _tmp1_;
	Atom prop = {0};
	GdkX11Display* _tmp2_;
	Atom act_type = {0};
	gint act_format = 0;
	gulong n_items = 0UL;
	gulong bytes_after = 0UL;
	void* data = NULL;
	GdkX11Display* _tmp3_;
	gint ret = 0;
	GdkX11Display* _tmp4_;
	Display* _tmp5_;
	Atom _tmp6_ = {0};
	gint _tmp7_ = 0;
	gulong _tmp8_ = 0UL;
	gulong _tmp9_ = 0UL;
	void* _tmp10_ = NULL;
	gint _tmp11_;
	GdkX11Display* _tmp13_;
	void* _tmp14_;
	gchar* _tmp15_;
	gchar* result;
#line 107 "../src/Backend/DeviceManagerX11.vala"
	_tmp0_ = gdk_display_get_default ();
#line 107 "../src/Backend/DeviceManagerX11.vala"
	gdk_display_sync (_tmp0_);
#line 109 "../src/Backend/DeviceManagerX11.vala"
	_tmp1_ = gdk_display_get_default ();
#line 109 "../src/Backend/DeviceManagerX11.vala"
	display = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gdk_x11_display_get_type (), GdkX11Display);
#line 110 "../src/Backend/DeviceManagerX11.vala"
	_tmp2_ = display;
#line 110 "../src/Backend/DeviceManagerX11.vala"
	prop = gdk_x11_get_xatom_by_name_for_display (_tmp2_, "Device Node");
#line 117 "../src/Backend/DeviceManagerX11.vala"
	_tmp3_ = display;
#line 117 "../src/Backend/DeviceManagerX11.vala"
	gdk_x11_display_error_trap_push (_tmp3_);
#line 119 "../src/Backend/DeviceManagerX11.vala"
	_tmp4_ = display;
#line 119 "../src/Backend/DeviceManagerX11.vala"
	_tmp5_ = gdk_x11_display_get_xdisplay (_tmp4_);
#line 119 "../src/Backend/DeviceManagerX11.vala"
	_tmp11_ = XIGetProperty (_tmp5_, id, prop, (glong) 0, (glong) 1000, FALSE, (Atom) AnyPropertyType, &_tmp6_, &_tmp7_, &_tmp8_, &_tmp9_, (unsigned char **) (&_tmp10_));
#line 119 "../src/Backend/DeviceManagerX11.vala"
	act_type = _tmp6_;
#line 119 "../src/Backend/DeviceManagerX11.vala"
	act_format = _tmp7_;
#line 119 "../src/Backend/DeviceManagerX11.vala"
	n_items = _tmp8_;
#line 119 "../src/Backend/DeviceManagerX11.vala"
	bytes_after = _tmp9_;
#line 119 "../src/Backend/DeviceManagerX11.vala"
	data = _tmp10_;
#line 119 "../src/Backend/DeviceManagerX11.vala"
	ret = _tmp11_;
#line 134 "../src/Backend/DeviceManagerX11.vala"
	if (ret != Success) {
#line 576 "DeviceManagerX11.c"
		GdkX11Display* _tmp12_;
#line 135 "../src/Backend/DeviceManagerX11.vala"
		_tmp12_ = display;
#line 135 "../src/Backend/DeviceManagerX11.vala"
		gdk_x11_display_error_trap_pop_ignored (_tmp12_);
#line 136 "../src/Backend/DeviceManagerX11.vala"
		result = NULL;
#line 136 "../src/Backend/DeviceManagerX11.vala"
		return result;
#line 586 "DeviceManagerX11.c"
	}
#line 139 "../src/Backend/DeviceManagerX11.vala"
	_tmp13_ = display;
#line 139 "../src/Backend/DeviceManagerX11.vala"
	if (gdk_x11_display_error_trap_pop (_tmp13_) != 0) {
#line 140 "../src/Backend/DeviceManagerX11.vala"
		result = NULL;
#line 140 "../src/Backend/DeviceManagerX11.vala"
		return result;
#line 596 "DeviceManagerX11.c"
	}
#line 143 "../src/Backend/DeviceManagerX11.vala"
	if (n_items == ((gulong) 0)) {
#line 144 "../src/Backend/DeviceManagerX11.vala"
		result = NULL;
#line 144 "../src/Backend/DeviceManagerX11.vala"
		return result;
#line 604 "DeviceManagerX11.c"
	}
#line 147 "../src/Backend/DeviceManagerX11.vala"
	if (act_type != XA_STRING) {
#line 148 "../src/Backend/DeviceManagerX11.vala"
		result = NULL;
#line 148 "../src/Backend/DeviceManagerX11.vala"
		return result;
#line 612 "DeviceManagerX11.c"
	}
#line 151 "../src/Backend/DeviceManagerX11.vala"
	if (act_format != 8) {
#line 152 "../src/Backend/DeviceManagerX11.vala"
		result = NULL;
#line 152 "../src/Backend/DeviceManagerX11.vala"
		return result;
#line 620 "DeviceManagerX11.c"
	}
#line 155 "../src/Backend/DeviceManagerX11.vala"
	_tmp14_ = data;
#line 155 "../src/Backend/DeviceManagerX11.vala"
	_tmp15_ = g_strdup ((const gchar*) _tmp14_);
#line 155 "../src/Backend/DeviceManagerX11.vala"
	result = _tmp15_;
#line 155 "../src/Backend/DeviceManagerX11.vala"
	return result;
#line 630 "DeviceManagerX11.c"
}

static GeeArrayList*
wacom_backend_device_manager_x11_real_list_devices (WacomBackendDeviceManager* base,
                                                    WacomBackendDeviceDeviceType type)
{
	WacomBackendDeviceManagerX11 * self;
	GeeArrayList* _result_ = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* result;
#line 158 "../src/Backend/DeviceManagerX11.vala"
	self = (WacomBackendDeviceManagerX11*) base;
#line 159 "../src/Backend/DeviceManagerX11.vala"
	_tmp0_ = gee_array_list_new (WACOM_BACKEND_TYPE_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 159 "../src/Backend/DeviceManagerX11.vala"
	_result_ = _tmp0_;
#line 647 "DeviceManagerX11.c"
	{
		GeeIterator* _device_it = NULL;
		GeeHashMap* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeCollection* _tmp4_;
		GeeIterator* _tmp5_;
		GeeIterator* _tmp6_;
#line 160 "../src/Backend/DeviceManagerX11.vala"
		_tmp1_ = self->priv->devices;
#line 160 "../src/Backend/DeviceManagerX11.vala"
		_tmp2_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp1_);
#line 160 "../src/Backend/DeviceManagerX11.vala"
		_tmp3_ = _tmp2_;
#line 160 "../src/Backend/DeviceManagerX11.vala"
		_tmp4_ = _tmp3_;
#line 160 "../src/Backend/DeviceManagerX11.vala"
		_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
#line 160 "../src/Backend/DeviceManagerX11.vala"
		_tmp6_ = _tmp5_;
#line 160 "../src/Backend/DeviceManagerX11.vala"
		_g_object_unref0 (_tmp4_);
#line 160 "../src/Backend/DeviceManagerX11.vala"
		_device_it = _tmp6_;
#line 160 "../src/Backend/DeviceManagerX11.vala"
		while (TRUE) {
#line 674 "DeviceManagerX11.c"
			GeeIterator* _tmp7_;
			WacomBackendDevice* device = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
			WacomBackendDevice* _tmp10_;
			WacomBackendDeviceDeviceType _tmp11_;
			WacomBackendDeviceDeviceType _tmp12_;
#line 160 "../src/Backend/DeviceManagerX11.vala"
			_tmp7_ = _device_it;
#line 160 "../src/Backend/DeviceManagerX11.vala"
			if (!gee_iterator_next (_tmp7_)) {
#line 160 "../src/Backend/DeviceManagerX11.vala"
				break;
#line 688 "DeviceManagerX11.c"
			}
#line 160 "../src/Backend/DeviceManagerX11.vala"
			_tmp8_ = _device_it;
#line 160 "../src/Backend/DeviceManagerX11.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 160 "../src/Backend/DeviceManagerX11.vala"
			device = (WacomBackendDevice*) _tmp9_;
#line 161 "../src/Backend/DeviceManagerX11.vala"
			_tmp10_ = device;
#line 161 "../src/Backend/DeviceManagerX11.vala"
			_tmp11_ = wacom_backend_device_get_dev_type (_tmp10_);
#line 161 "../src/Backend/DeviceManagerX11.vala"
			_tmp12_ = _tmp11_;
#line 161 "../src/Backend/DeviceManagerX11.vala"
			if ((_tmp12_ & type) == type) {
#line 704 "DeviceManagerX11.c"
				GeeArrayList* _tmp13_;
				WacomBackendDevice* _tmp14_;
#line 162 "../src/Backend/DeviceManagerX11.vala"
				_tmp13_ = _result_;
#line 162 "../src/Backend/DeviceManagerX11.vala"
				_tmp14_ = device;
#line 162 "../src/Backend/DeviceManagerX11.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp13_, _tmp14_);
#line 713 "DeviceManagerX11.c"
			}
#line 160 "../src/Backend/DeviceManagerX11.vala"
			_g_object_unref0 (device);
#line 717 "DeviceManagerX11.c"
		}
#line 160 "../src/Backend/DeviceManagerX11.vala"
		_g_object_unref0 (_device_it);
#line 721 "DeviceManagerX11.c"
	}
#line 166 "../src/Backend/DeviceManagerX11.vala"
	result = _result_;
#line 166 "../src/Backend/DeviceManagerX11.vala"
	return result;
#line 727 "DeviceManagerX11.c"
}

static WacomBackendDevice*
wacom_backend_device_manager_x11_real_lookup_gdk_device (WacomBackendDeviceManager* base,
                                                         GdkDevice* device)
{
	WacomBackendDeviceManagerX11 * self;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	WacomBackendDevice* result;
#line 169 "../src/Backend/DeviceManagerX11.vala"
	self = (WacomBackendDeviceManagerX11*) base;
#line 169 "../src/Backend/DeviceManagerX11.vala"
	g_return_val_if_fail (device != NULL, NULL);
#line 170 "../src/Backend/DeviceManagerX11.vala"
	_tmp0_ = self->priv->devices;
#line 170 "../src/Backend/DeviceManagerX11.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, device);
#line 170 "../src/Backend/DeviceManagerX11.vala"
	result = (WacomBackendDevice*) _tmp1_;
#line 170 "../src/Backend/DeviceManagerX11.vala"
	return result;
#line 750 "DeviceManagerX11.c"
}

GdkDeviceToolType
wacom_backend_device_manager_x11_get_tool_type (GdkDevice* device)
{
	GdkDeviceToolType tool_type = 0;
	Atom act_type = {0};
	gint act_format = 0;
	gulong n_items = 0UL;
	gulong bytes_after = 0UL;
	void* data = NULL;
	gint id = 0;
	GdkX11Display* display = NULL;
	GdkDisplay* _tmp2_;
	GdkX11Display* _tmp3_;
	GdkX11Display* _tmp4_;
	gint ret = 0;
	GdkX11Display* _tmp5_;
	Display* _tmp6_;
	GdkX11Display* _tmp7_;
	Atom _tmp8_ = {0};
	gint _tmp9_ = 0;
	gulong _tmp10_ = 0UL;
	gulong _tmp11_ = 0UL;
	void* _tmp12_ = NULL;
	gint _tmp13_;
	GdkX11Display* _tmp14_;
	gboolean _tmp15_ = FALSE;
	gboolean _tmp16_ = FALSE;
	Atom device_type = {0};
	void* _tmp17_;
	gchar* name = NULL;
	GdkX11Display* _tmp18_;
	Display* _tmp19_;
	gchar* _tmp20_;
	const gchar* _tmp21_;
	GdkDeviceToolType result;
#line 173 "../src/Backend/DeviceManagerX11.vala"
	g_return_val_if_fail (device != NULL, 0);
#line 174 "../src/Backend/DeviceManagerX11.vala"
	tool_type = GDK_DEVICE_TOOL_TYPE_UNKNOWN;
#line 181 "../src/Backend/DeviceManagerX11.vala"
	id = -1;
#line 182 "../src/Backend/DeviceManagerX11.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (device, gdk_x11_device_xi2_get_type ())) {
#line 796 "DeviceManagerX11.c"
		gint _tmp0_;
		gint _tmp1_;
#line 183 "../src/Backend/DeviceManagerX11.vala"
		g_object_get (G_TYPE_CHECK_INSTANCE_CAST (device, gdk_x11_device_xi2_get_type (), GdkX11DeviceXI2), "device-id", &_tmp0_, NULL);
#line 183 "../src/Backend/DeviceManagerX11.vala"
		_tmp1_ = _tmp0_;
#line 183 "../src/Backend/DeviceManagerX11.vala"
		id = _tmp1_;
#line 805 "DeviceManagerX11.c"
	}
#line 186 "../src/Backend/DeviceManagerX11.vala"
	_tmp2_ = gdk_device_get_display (device);
#line 186 "../src/Backend/DeviceManagerX11.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, gdk_x11_display_get_type ()) ? ((GdkX11Display*) _tmp2_) : NULL);
#line 186 "../src/Backend/DeviceManagerX11.vala"
	display = _tmp3_;
#line 187 "../src/Backend/DeviceManagerX11.vala"
	_tmp4_ = display;
#line 187 "../src/Backend/DeviceManagerX11.vala"
	gdk_x11_display_error_trap_push (_tmp4_);
#line 189 "../src/Backend/DeviceManagerX11.vala"
	_tmp5_ = display;
#line 189 "../src/Backend/DeviceManagerX11.vala"
	_tmp6_ = gdk_x11_display_get_xdisplay (_tmp5_);
#line 189 "../src/Backend/DeviceManagerX11.vala"
	_tmp7_ = display;
#line 189 "../src/Backend/DeviceManagerX11.vala"
	_tmp13_ = XIGetProperty (_tmp6_, id, gdk_x11_get_xatom_by_name_for_display (_tmp7_, "Wacom Tool Type"), (glong) 0, (glong) 1, FALSE, XA_ATOM, &_tmp8_, &_tmp9_, &_tmp10_, &_tmp11_, (unsigned char **) (&_tmp12_));
#line 189 "../src/Backend/DeviceManagerX11.vala"
	act_type = _tmp8_;
#line 189 "../src/Backend/DeviceManagerX11.vala"
	act_format = _tmp9_;
#line 189 "../src/Backend/DeviceManagerX11.vala"
	n_items = _tmp10_;
#line 189 "../src/Backend/DeviceManagerX11.vala"
	bytes_after = _tmp11_;
#line 189 "../src/Backend/DeviceManagerX11.vala"
	data = _tmp12_;
#line 189 "../src/Backend/DeviceManagerX11.vala"
	ret = _tmp13_;
#line 204 "../src/Backend/DeviceManagerX11.vala"
	_tmp14_ = display;
#line 204 "../src/Backend/DeviceManagerX11.vala"
	gdk_x11_display_error_trap_pop_ignored (_tmp14_);
#line 206 "../src/Backend/DeviceManagerX11.vala"
	if (ret != Success) {
#line 207 "../src/Backend/DeviceManagerX11.vala"
		result = tool_type;
#line 207 "../src/Backend/DeviceManagerX11.vala"
		_g_object_unref0 (display);
#line 207 "../src/Backend/DeviceManagerX11.vala"
		return result;
#line 849 "DeviceManagerX11.c"
	}
#line 210 "../src/Backend/DeviceManagerX11.vala"
	if (act_type != XA_ATOM) {
#line 210 "../src/Backend/DeviceManagerX11.vala"
		_tmp16_ = TRUE;
#line 855 "DeviceManagerX11.c"
	} else {
#line 210 "../src/Backend/DeviceManagerX11.vala"
		_tmp16_ = act_format != 32;
#line 859 "DeviceManagerX11.c"
	}
#line 210 "../src/Backend/DeviceManagerX11.vala"
	if (_tmp16_) {
#line 210 "../src/Backend/DeviceManagerX11.vala"
		_tmp15_ = TRUE;
#line 865 "DeviceManagerX11.c"
	} else {
#line 210 "../src/Backend/DeviceManagerX11.vala"
		_tmp15_ = n_items != ((gulong) 1);
#line 869 "DeviceManagerX11.c"
	}
#line 210 "../src/Backend/DeviceManagerX11.vala"
	if (_tmp15_) {
#line 211 "../src/Backend/DeviceManagerX11.vala"
		result = tool_type;
#line 211 "../src/Backend/DeviceManagerX11.vala"
		_g_object_unref0 (display);
#line 211 "../src/Backend/DeviceManagerX11.vala"
		return result;
#line 879 "DeviceManagerX11.c"
	}
#line 215 "../src/Backend/DeviceManagerX11.vala"
	_tmp17_ = data;
#line 215 "../src/Backend/DeviceManagerX11.vala"
	device_type = *((Atom*) _tmp17_);
#line 216 "../src/Backend/DeviceManagerX11.vala"
	if (device_type == ((Atom) 0)) {
#line 217 "../src/Backend/DeviceManagerX11.vala"
		result = tool_type;
#line 217 "../src/Backend/DeviceManagerX11.vala"
		_g_object_unref0 (display);
#line 217 "../src/Backend/DeviceManagerX11.vala"
		return result;
#line 893 "DeviceManagerX11.c"
	}
#line 220 "../src/Backend/DeviceManagerX11.vala"
	_tmp18_ = display;
#line 220 "../src/Backend/DeviceManagerX11.vala"
	_tmp19_ = gdk_x11_display_get_xdisplay (_tmp18_);
#line 220 "../src/Backend/DeviceManagerX11.vala"
	_tmp20_ = XGetAtomName (_tmp19_, device_type);
#line 220 "../src/Backend/DeviceManagerX11.vala"
	name = _tmp20_;
#line 221 "../src/Backend/DeviceManagerX11.vala"
	_tmp21_ = name;
#line 221 "../src/Backend/DeviceManagerX11.vala"
	if (g_strcmp0 (_tmp21_, "STYLUS") == 0) {
#line 222 "../src/Backend/DeviceManagerX11.vala"
		tool_type = GDK_DEVICE_TOOL_TYPE_PEN;
#line 909 "DeviceManagerX11.c"
	} else {
		const gchar* _tmp22_;
#line 223 "../src/Backend/DeviceManagerX11.vala"
		_tmp22_ = name;
#line 223 "../src/Backend/DeviceManagerX11.vala"
		if (g_strcmp0 (_tmp22_, "CURSOR") == 0) {
#line 224 "../src/Backend/DeviceManagerX11.vala"
			tool_type = GDK_DEVICE_TOOL_TYPE_MOUSE;
#line 918 "DeviceManagerX11.c"
		} else {
			const gchar* _tmp23_;
#line 225 "../src/Backend/DeviceManagerX11.vala"
			_tmp23_ = name;
#line 225 "../src/Backend/DeviceManagerX11.vala"
			if (g_strcmp0 (_tmp23_, "ERASER") == 0) {
#line 226 "../src/Backend/DeviceManagerX11.vala"
				tool_type = GDK_DEVICE_TOOL_TYPE_ERASER;
#line 927 "DeviceManagerX11.c"
			}
		}
	}
#line 229 "../src/Backend/DeviceManagerX11.vala"
	result = tool_type;
#line 229 "../src/Backend/DeviceManagerX11.vala"
	_g_free0 (name);
#line 229 "../src/Backend/DeviceManagerX11.vala"
	_g_object_unref0 (display);
#line 229 "../src/Backend/DeviceManagerX11.vala"
	return result;
#line 939 "DeviceManagerX11.c"
}

static void
wacom_backend_device_manager_x11_class_init (WacomBackendDeviceManagerX11Class * klass,
                                             gpointer klass_data)
{
#line 20 "../src/Backend/DeviceManagerX11.vala"
	wacom_backend_device_manager_x11_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/Backend/DeviceManagerX11.vala"
	g_type_class_adjust_private_offset (klass, &WacomBackendDeviceManagerX11_private_offset);
#line 20 "../src/Backend/DeviceManagerX11.vala"
	((WacomBackendDeviceManagerClass *) klass)->list_devices = (GeeArrayList* (*) (WacomBackendDeviceManager*, WacomBackendDeviceDeviceType)) wacom_backend_device_manager_x11_real_list_devices;
#line 20 "../src/Backend/DeviceManagerX11.vala"
	((WacomBackendDeviceManagerClass *) klass)->lookup_gdk_device = (WacomBackendDevice* (*) (WacomBackendDeviceManager*, GdkDevice*)) wacom_backend_device_manager_x11_real_lookup_gdk_device;
#line 20 "../src/Backend/DeviceManagerX11.vala"
	G_OBJECT_CLASS (klass)->finalize = wacom_backend_device_manager_x11_finalize;
#line 956 "DeviceManagerX11.c"
}

static void
wacom_backend_device_manager_x11_instance_init (WacomBackendDeviceManagerX11 * self,
                                                gpointer klass)
{
#line 20 "../src/Backend/DeviceManagerX11.vala"
	self->priv = wacom_backend_device_manager_x11_get_instance_private (self);
#line 21 "../src/Backend/DeviceManagerX11.vala"
	self->priv->devices = NULL;
#line 967 "DeviceManagerX11.c"
}

static void
wacom_backend_device_manager_x11_finalize (GObject * obj)
{
	WacomBackendDeviceManagerX11 * self;
#line 20 "../src/Backend/DeviceManagerX11.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WACOM_BACKEND_TYPE_DEVICE_MANAGER_X11, WacomBackendDeviceManagerX11);
#line 21 "../src/Backend/DeviceManagerX11.vala"
	_g_object_unref0 (self->priv->devices);
#line 20 "../src/Backend/DeviceManagerX11.vala"
	G_OBJECT_CLASS (wacom_backend_device_manager_x11_parent_class)->finalize (obj);
#line 980 "DeviceManagerX11.c"
}

static GType
wacom_backend_device_manager_x11_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WacomBackendDeviceManagerX11Class), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) wacom_backend_device_manager_x11_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WacomBackendDeviceManagerX11), 0, (GInstanceInitFunc) wacom_backend_device_manager_x11_instance_init, NULL };
	GType wacom_backend_device_manager_x11_type_id;
	wacom_backend_device_manager_x11_type_id = g_type_register_static (WACOM_BACKEND_TYPE_DEVICE_MANAGER, "WacomBackendDeviceManagerX11", &g_define_type_info, 0);
	WacomBackendDeviceManagerX11_private_offset = g_type_add_instance_private (wacom_backend_device_manager_x11_type_id, sizeof (WacomBackendDeviceManagerX11Private));
	return wacom_backend_device_manager_x11_type_id;
}

GType
wacom_backend_device_manager_x11_get_type (void)
{
	static volatile gsize wacom_backend_device_manager_x11_type_id__once = 0;
	if (g_once_init_enter (&wacom_backend_device_manager_x11_type_id__once)) {
		GType wacom_backend_device_manager_x11_type_id;
		wacom_backend_device_manager_x11_type_id = wacom_backend_device_manager_x11_get_type_once ();
		g_once_init_leave (&wacom_backend_device_manager_x11_type_id__once, wacom_backend_device_manager_x11_type_id);
	}
	return wacom_backend_device_manager_x11_type_id__once;
}

