/* WacomToolMap.c generated by valac 0.56.17, the Vala compiler
 * generated from WacomToolMap.vala, do not modify */

/*
 * Copyright (c) 2019 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 */

#include "wacom.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <glib-object.h>
#include <libwacom/libwacom.h>
#include <glib/gstdio.h>

#define WACOM_BACKEND_WACOM_TOOL_MAP_GENERIC_STYLUS "Generic"
#define WACOM_BACKEND_WACOM_TOOL_MAP_KEY_TOOL_ID "ID"
#define WACOM_BACKEND_WACOM_TOOL_MAP_KEY_DEVICE_STYLI "Styli"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	WACOM_BACKEND_WACOM_TOOL_MAP_0_PROPERTY,
	WACOM_BACKEND_WACOM_TOOL_MAP_NUM_PROPERTIES
};
static GParamSpec* wacom_backend_wacom_tool_map_properties[WACOM_BACKEND_WACOM_TOOL_MAP_NUM_PROPERTIES];
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _libwacom_database_destroy0(var) ((var == NULL) ? NULL : (var = (libwacom_database_destroy (var), NULL)))
#define _libwacom_destroy0(var) ((var == NULL) ? NULL : (var = (libwacom_destroy (var), NULL)))
#define __vala_WacomError_free_function_address_of0(var) ((var == NULL) ? NULL : (var = (_vala_WacomError_free_function_address_of (var), NULL)))

struct _WacomBackendWacomToolMapPrivate {
	GKeyFile* tablets;
	GKeyFile* tools;
	gchar* tablet_path;
	gchar* tool_path;
	GeeHashMap* tablet_map;
	GeeHashMap* tool_map;
	GeeHashMap* no_serial_tool_map;
};

static gint WacomBackendWacomToolMap_private_offset;
static gpointer wacom_backend_wacom_tool_map_parent_class = NULL;
static WacomDeviceDatabase* wacom_backend_wacom_tool_map_wacom_db;
static WacomDeviceDatabase* wacom_backend_wacom_tool_map_wacom_db = NULL;
static GOnce wacom_backend_wacom_tool_map_instance;
static GOnce wacom_backend_wacom_tool_map_instance = G_ONCE_INIT;

static WacomBackendWacomToolMap* __lambda5_ (void);
static gpointer ___lambda5__gthread_func (gpointer self);
static void wacom_backend_wacom_tool_map_load_keyfiles (WacomBackendWacomToolMap* self);
static void wacom_backend_wacom_tool_map_cache_tools (WacomBackendWacomToolMap* self);
static void wacom_backend_wacom_tool_map_cache_devices (WacomBackendWacomToolMap* self);
static gchar* wacom_backend_wacom_tool_map_get_tool_key (guint64 serial);
static void wacom_backend_wacom_tool_map_keyfile_add_stylus (WacomBackendWacomToolMap* self,
                                                      const gchar* tool_key,
                                                      guint64 id);
static void wacom_backend_wacom_tool_map_keyfile_add_device_stylus (WacomBackendWacomToolMap* self,
                                                             const gchar* device_key,
                                                             const gchar* tool_key);
static void _vala_array_add1 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_WacomError_free_function_address_of (WacomError* self);
static void wacom_backend_wacom_tool_map_finalize (GObject * obj);
static GType wacom_backend_wacom_tool_map_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
wacom_backend_wacom_tool_map_get_instance_private (WacomBackendWacomToolMap* self)
{
	return G_STRUCT_MEMBER_P (self, WacomBackendWacomToolMap_private_offset);
}

static WacomBackendWacomToolMap*
__lambda5_ (void)
{
	WacomBackendWacomToolMap* _tmp0_;
	WacomBackendWacomToolMap* result;
#line 40 "../src/Backend/WacomToolMap.vala"
	_tmp0_ = wacom_backend_wacom_tool_map_new ();
#line 40 "../src/Backend/WacomToolMap.vala"
	result = _tmp0_;
#line 40 "../src/Backend/WacomToolMap.vala"
	return result;
#line 118 "WacomToolMap.c"
}

static gpointer
___lambda5__gthread_func (gpointer self)
{
	gpointer result;
	result = __lambda5_ ();
#line 39 "../src/Backend/WacomToolMap.vala"
	return result;
#line 128 "WacomToolMap.c"
}

WacomBackendWacomToolMap*
wacom_backend_wacom_tool_map_get_default (void)
{
	gconstpointer _tmp0_;
	WacomBackendWacomToolMap* result;
#line 39 "../src/Backend/WacomToolMap.vala"
	_tmp0_ = g_once (&wacom_backend_wacom_tool_map_instance, ___lambda5__gthread_func, NULL);
#line 39 "../src/Backend/WacomToolMap.vala"
	result = (WacomBackendWacomToolMap*) _tmp0_;
#line 39 "../src/Backend/WacomToolMap.vala"
	return result;
#line 142 "WacomToolMap.c"
}

WacomBackendWacomToolMap*
wacom_backend_wacom_tool_map_construct (GType object_type)
{
	WacomBackendWacomToolMap * self = NULL;
	GKeyFile* _tmp0_;
	GKeyFile* _tmp1_;
	GeeHashMap* _tmp2_;
	GeeHashMap* _tmp3_;
	GeeHashMap* _tmp4_;
#line 44 "../src/Backend/WacomToolMap.vala"
	self = (WacomBackendWacomToolMap*) g_object_new (object_type, NULL);
#line 45 "../src/Backend/WacomToolMap.vala"
	_tmp0_ = g_key_file_new ();
#line 45 "../src/Backend/WacomToolMap.vala"
	_g_key_file_unref0 (self->priv->tablets);
#line 45 "../src/Backend/WacomToolMap.vala"
	self->priv->tablets = _tmp0_;
#line 46 "../src/Backend/WacomToolMap.vala"
	_tmp1_ = g_key_file_new ();
#line 46 "../src/Backend/WacomToolMap.vala"
	_g_key_file_unref0 (self->priv->tools);
#line 46 "../src/Backend/WacomToolMap.vala"
	self->priv->tools = _tmp1_;
#line 48 "../src/Backend/WacomToolMap.vala"
	_tmp2_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, GEE_TYPE_ARRAY_LIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 48 "../src/Backend/WacomToolMap.vala"
	_g_object_unref0 (self->priv->tablet_map);
#line 48 "../src/Backend/WacomToolMap.vala"
	self->priv->tablet_map = _tmp2_;
#line 49 "../src/Backend/WacomToolMap.vala"
	_tmp3_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, WACOM_BACKEND_TYPE_WACOM_TOOL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 49 "../src/Backend/WacomToolMap.vala"
	_g_object_unref0 (self->priv->tool_map);
#line 49 "../src/Backend/WacomToolMap.vala"
	self->priv->tool_map = _tmp3_;
#line 50 "../src/Backend/WacomToolMap.vala"
	_tmp4_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, WACOM_BACKEND_TYPE_WACOM_TOOL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 50 "../src/Backend/WacomToolMap.vala"
	_g_object_unref0 (self->priv->no_serial_tool_map);
#line 50 "../src/Backend/WacomToolMap.vala"
	self->priv->no_serial_tool_map = _tmp4_;
#line 52 "../src/Backend/WacomToolMap.vala"
	wacom_backend_wacom_tool_map_load_keyfiles (self);
#line 53 "../src/Backend/WacomToolMap.vala"
	wacom_backend_wacom_tool_map_cache_tools (self);
#line 54 "../src/Backend/WacomToolMap.vala"
	wacom_backend_wacom_tool_map_cache_devices (self);
#line 44 "../src/Backend/WacomToolMap.vala"
	return self;
#line 194 "WacomToolMap.c"
}

WacomBackendWacomToolMap*
wacom_backend_wacom_tool_map_new (void)
{
#line 44 "../src/Backend/WacomToolMap.vala"
	return wacom_backend_wacom_tool_map_construct (WACOM_BACKEND_TYPE_WACOM_TOOL_MAP);
#line 202 "WacomToolMap.c"
}

static void
wacom_backend_wacom_tool_map_load_keyfiles (WacomBackendWacomToolMap* self)
{
	gchar* dir = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	GError* _inner_error0_ = NULL;
#line 57 "../src/Backend/WacomToolMap.vala"
	g_return_if_fail (self != NULL);
#line 58 "../src/Backend/WacomToolMap.vala"
	_tmp0_ = g_get_user_cache_dir ();
#line 58 "../src/Backend/WacomToolMap.vala"
	_tmp1_ = g_build_filename (_tmp0_, "io.elementary.settings", "wacom", NULL);
#line 58 "../src/Backend/WacomToolMap.vala"
	dir = _tmp1_;
#line 60 "../src/Backend/WacomToolMap.vala"
	_tmp2_ = dir;
#line 60 "../src/Backend/WacomToolMap.vala"
	if (g_mkdir_with_parents (_tmp2_, 0700) < 0) {
#line 229 "WacomToolMap.c"
		const gchar* _tmp3_;
#line 61 "../src/Backend/WacomToolMap.vala"
		_tmp3_ = dir;
#line 61 "../src/Backend/WacomToolMap.vala"
		g_warning ("WacomToolMap.vala:61: Could not create directory '%s', stylus mapping " \
"may not work well", _tmp3_);
#line 62 "../src/Backend/WacomToolMap.vala"
		_g_free0 (dir);
#line 62 "../src/Backend/WacomToolMap.vala"
		return;
#line 239 "WacomToolMap.c"
	}
#line 65 "../src/Backend/WacomToolMap.vala"
	_tmp4_ = dir;
#line 65 "../src/Backend/WacomToolMap.vala"
	_tmp5_ = g_build_filename (_tmp4_, "devices", NULL);
#line 65 "../src/Backend/WacomToolMap.vala"
	_g_free0 (self->priv->tablet_path);
#line 65 "../src/Backend/WacomToolMap.vala"
	self->priv->tablet_path = _tmp5_;
#line 249 "WacomToolMap.c"
	{
		GKeyFile* _tmp6_;
		const gchar* _tmp7_;
#line 67 "../src/Backend/WacomToolMap.vala"
		_tmp6_ = self->priv->tablets;
#line 67 "../src/Backend/WacomToolMap.vala"
		_tmp7_ = self->priv->tablet_path;
#line 67 "../src/Backend/WacomToolMap.vala"
		g_key_file_load_from_file (_tmp6_, _tmp7_, G_KEY_FILE_NONE, &_inner_error0_);
#line 67 "../src/Backend/WacomToolMap.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 261 "WacomToolMap.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp8_;
		GError* _tmp9_;
		const gchar* _tmp10_;
#line 66 "../src/Backend/WacomToolMap.vala"
		e = _inner_error0_;
#line 66 "../src/Backend/WacomToolMap.vala"
		_inner_error0_ = NULL;
#line 69 "../src/Backend/WacomToolMap.vala"
		_tmp8_ = self->priv->tablet_path;
#line 69 "../src/Backend/WacomToolMap.vala"
		_tmp9_ = e;
#line 69 "../src/Backend/WacomToolMap.vala"
		_tmp10_ = _tmp9_->message;
#line 69 "../src/Backend/WacomToolMap.vala"
		g_warning ("WacomToolMap.vala:69: Could not load tablets keyfile '%s': %s", _tmp8_, _tmp10_);
#line 66 "../src/Backend/WacomToolMap.vala"
		_g_error_free0 (e);
#line 286 "WacomToolMap.c"
	}
	__finally0:
#line 66 "../src/Backend/WacomToolMap.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 66 "../src/Backend/WacomToolMap.vala"
		_g_free0 (dir);
#line 66 "../src/Backend/WacomToolMap.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 66 "../src/Backend/WacomToolMap.vala"
		g_clear_error (&_inner_error0_);
#line 66 "../src/Backend/WacomToolMap.vala"
		return;
#line 299 "WacomToolMap.c"
	}
#line 72 "../src/Backend/WacomToolMap.vala"
	_tmp11_ = dir;
#line 72 "../src/Backend/WacomToolMap.vala"
	_tmp12_ = g_build_filename (_tmp11_, "tools", NULL);
#line 72 "../src/Backend/WacomToolMap.vala"
	_g_free0 (self->priv->tool_path);
#line 72 "../src/Backend/WacomToolMap.vala"
	self->priv->tool_path = _tmp12_;
#line 309 "WacomToolMap.c"
	{
		GKeyFile* _tmp13_;
		const gchar* _tmp14_;
#line 74 "../src/Backend/WacomToolMap.vala"
		_tmp13_ = self->priv->tools;
#line 74 "../src/Backend/WacomToolMap.vala"
		_tmp14_ = self->priv->tool_path;
#line 74 "../src/Backend/WacomToolMap.vala"
		g_key_file_load_from_file (_tmp13_, _tmp14_, G_KEY_FILE_NONE, &_inner_error0_);
#line 74 "../src/Backend/WacomToolMap.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 321 "WacomToolMap.c"
			goto __catch1_g_error;
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp15_;
		GError* _tmp16_;
		const gchar* _tmp17_;
#line 73 "../src/Backend/WacomToolMap.vala"
		e = _inner_error0_;
#line 73 "../src/Backend/WacomToolMap.vala"
		_inner_error0_ = NULL;
#line 76 "../src/Backend/WacomToolMap.vala"
		_tmp15_ = self->priv->tool_path;
#line 76 "../src/Backend/WacomToolMap.vala"
		_tmp16_ = e;
#line 76 "../src/Backend/WacomToolMap.vala"
		_tmp17_ = _tmp16_->message;
#line 76 "../src/Backend/WacomToolMap.vala"
		g_warning ("WacomToolMap.vala:76: Could not load tools keyfile '%s': %s", _tmp15_, _tmp17_);
#line 73 "../src/Backend/WacomToolMap.vala"
		_g_error_free0 (e);
#line 346 "WacomToolMap.c"
	}
	__finally1:
#line 73 "../src/Backend/WacomToolMap.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 73 "../src/Backend/WacomToolMap.vala"
		_g_free0 (dir);
#line 73 "../src/Backend/WacomToolMap.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 73 "../src/Backend/WacomToolMap.vala"
		g_clear_error (&_inner_error0_);
#line 73 "../src/Backend/WacomToolMap.vala"
		return;
#line 359 "WacomToolMap.c"
	}
#line 57 "../src/Backend/WacomToolMap.vala"
	_g_free0 (dir);
#line 363 "WacomToolMap.c"
}

static void
wacom_backend_wacom_tool_map_cache_tools (WacomBackendWacomToolMap* self)
{
	gchar** serials = NULL;
	GKeyFile* _tmp0_;
	gsize _tmp1_ = 0;
	gchar** _tmp2_;
	gint serials_length1;
	gint _serials_size_;
	GError* _inner_error0_ = NULL;
#line 80 "../src/Backend/WacomToolMap.vala"
	g_return_if_fail (self != NULL);
#line 81 "../src/Backend/WacomToolMap.vala"
	_tmp0_ = self->priv->tools;
#line 81 "../src/Backend/WacomToolMap.vala"
	_tmp2_ = g_key_file_get_groups (_tmp0_, &_tmp1_);
#line 81 "../src/Backend/WacomToolMap.vala"
	serials = _tmp2_;
#line 81 "../src/Backend/WacomToolMap.vala"
	serials_length1 = _tmp1_;
#line 81 "../src/Backend/WacomToolMap.vala"
	_serials_size_ = serials_length1;
#line 388 "WacomToolMap.c"
	{
		gint i = 0;
#line 82 "../src/Backend/WacomToolMap.vala"
		i = 0;
#line 393 "WacomToolMap.c"
		{
			gboolean _tmp3_ = FALSE;
#line 82 "../src/Backend/WacomToolMap.vala"
			_tmp3_ = TRUE;
#line 82 "../src/Backend/WacomToolMap.vala"
			while (TRUE) {
#line 400 "WacomToolMap.c"
				gchar** _tmp5_;
				gint _tmp5__length1;
				guint64 serial = 0ULL;
				guint64 id = 0ULL;
				gchar* str = NULL;
				GeeHashMap* _tmp31_;
				gchar** _tmp32_;
				gint _tmp32__length1;
				const gchar* _tmp33_;
				gchar* _tmp34_;
				gchar* _tmp35_;
				WacomBackendWacomTool* _tmp36_;
				WacomBackendWacomTool* _tmp37_;
#line 82 "../src/Backend/WacomToolMap.vala"
				if (!_tmp3_) {
#line 416 "WacomToolMap.c"
					gint _tmp4_;
#line 82 "../src/Backend/WacomToolMap.vala"
					_tmp4_ = i;
#line 82 "../src/Backend/WacomToolMap.vala"
					i = _tmp4_ + 1;
#line 422 "WacomToolMap.c"
				}
#line 82 "../src/Backend/WacomToolMap.vala"
				_tmp3_ = FALSE;
#line 82 "../src/Backend/WacomToolMap.vala"
				_tmp5_ = serials;
#line 82 "../src/Backend/WacomToolMap.vala"
				_tmp5__length1 = serials_length1;
#line 82 "../src/Backend/WacomToolMap.vala"
				if (!(i < _tmp5__length1)) {
#line 82 "../src/Backend/WacomToolMap.vala"
					break;
#line 434 "WacomToolMap.c"
				}
				{
					gboolean _tmp6_ = FALSE;
					gchar** _tmp7_;
					gint _tmp7__length1;
					const gchar* _tmp8_;
					guint64 _tmp9_ = 0ULL;
					gboolean _tmp10_;
#line 85 "../src/Backend/WacomToolMap.vala"
					_tmp7_ = serials;
#line 85 "../src/Backend/WacomToolMap.vala"
					_tmp7__length1 = serials_length1;
#line 85 "../src/Backend/WacomToolMap.vala"
					_tmp8_ = _tmp7_[i];
#line 85 "../src/Backend/WacomToolMap.vala"
					_tmp10_ = g_ascii_string_to_unsigned (_tmp8_, (guint) 16, 0ULL, G_MAXUINT64, &_tmp9_, &_inner_error0_);
#line 85 "../src/Backend/WacomToolMap.vala"
					serial = _tmp9_;
#line 85 "../src/Backend/WacomToolMap.vala"
					_tmp6_ = _tmp10_;
#line 85 "../src/Backend/WacomToolMap.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 457 "WacomToolMap.c"
						goto __catch0_g_error;
					}
#line 85 "../src/Backend/WacomToolMap.vala"
					if (!_tmp6_) {
#line 462 "WacomToolMap.c"
						gchar** _tmp11_;
						gint _tmp11__length1;
						const gchar* _tmp12_;
#line 86 "../src/Backend/WacomToolMap.vala"
						_tmp11_ = serials;
#line 86 "../src/Backend/WacomToolMap.vala"
						_tmp11__length1 = serials_length1;
#line 86 "../src/Backend/WacomToolMap.vala"
						_tmp12_ = _tmp11_[i];
#line 86 "../src/Backend/WacomToolMap.vala"
						g_warning ("WacomToolMap.vala:86: Invalid tool serial %s", _tmp12_);
#line 87 "../src/Backend/WacomToolMap.vala"
						continue;
#line 476 "WacomToolMap.c"
					}
				}
				goto __finally0;
				__catch0_g_error:
				{
					gchar** _tmp13_;
					gint _tmp13__length1;
					const gchar* _tmp14_;
#line 84 "../src/Backend/WacomToolMap.vala"
					g_clear_error (&_inner_error0_);
#line 90 "../src/Backend/WacomToolMap.vala"
					_tmp13_ = serials;
#line 90 "../src/Backend/WacomToolMap.vala"
					_tmp13__length1 = serials_length1;
#line 90 "../src/Backend/WacomToolMap.vala"
					_tmp14_ = _tmp13_[i];
#line 90 "../src/Backend/WacomToolMap.vala"
					g_warning ("WacomToolMap.vala:90: Invalid tool serial %s", _tmp14_);
#line 91 "../src/Backend/WacomToolMap.vala"
					continue;
#line 497 "WacomToolMap.c"
				}
				__finally0:
#line 84 "../src/Backend/WacomToolMap.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 84 "../src/Backend/WacomToolMap.vala"
					serials = (_vala_array_free (serials, serials_length1, (GDestroyNotify) g_free), NULL);
#line 84 "../src/Backend/WacomToolMap.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 84 "../src/Backend/WacomToolMap.vala"
					g_clear_error (&_inner_error0_);
#line 84 "../src/Backend/WacomToolMap.vala"
					return;
#line 510 "WacomToolMap.c"
				}
				{
					gchar* _tmp15_ = NULL;
					GKeyFile* _tmp16_;
					gchar** _tmp17_;
					gint _tmp17__length1;
					const gchar* _tmp18_;
					gchar* _tmp19_;
					gchar* _tmp20_;
#line 96 "../src/Backend/WacomToolMap.vala"
					_tmp16_ = self->priv->tools;
#line 96 "../src/Backend/WacomToolMap.vala"
					_tmp17_ = serials;
#line 96 "../src/Backend/WacomToolMap.vala"
					_tmp17__length1 = serials_length1;
#line 96 "../src/Backend/WacomToolMap.vala"
					_tmp18_ = _tmp17_[i];
#line 96 "../src/Backend/WacomToolMap.vala"
					_tmp19_ = g_key_file_get_string (_tmp16_, _tmp18_, WACOM_BACKEND_WACOM_TOOL_MAP_KEY_TOOL_ID, &_inner_error0_);
#line 96 "../src/Backend/WacomToolMap.vala"
					_tmp15_ = _tmp19_;
#line 96 "../src/Backend/WacomToolMap.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 534 "WacomToolMap.c"
						goto __catch1_g_error;
					}
#line 96 "../src/Backend/WacomToolMap.vala"
					_tmp20_ = _tmp15_;
#line 96 "../src/Backend/WacomToolMap.vala"
					_tmp15_ = NULL;
#line 96 "../src/Backend/WacomToolMap.vala"
					_g_free0 (str);
#line 96 "../src/Backend/WacomToolMap.vala"
					str = _tmp20_;
#line 95 "../src/Backend/WacomToolMap.vala"
					_g_free0 (_tmp15_);
#line 547 "WacomToolMap.c"
				}
				goto __finally1;
				__catch1_g_error:
				{
					GError* e = NULL;
					gchar** _tmp21_;
					gint _tmp21__length1;
					const gchar* _tmp22_;
					GError* _tmp23_;
					const gchar* _tmp24_;
#line 95 "../src/Backend/WacomToolMap.vala"
					e = _inner_error0_;
#line 95 "../src/Backend/WacomToolMap.vala"
					_inner_error0_ = NULL;
#line 98 "../src/Backend/WacomToolMap.vala"
					_tmp21_ = serials;
#line 98 "../src/Backend/WacomToolMap.vala"
					_tmp21__length1 = serials_length1;
#line 98 "../src/Backend/WacomToolMap.vala"
					_tmp22_ = _tmp21_[i];
#line 98 "../src/Backend/WacomToolMap.vala"
					_tmp23_ = e;
#line 98 "../src/Backend/WacomToolMap.vala"
					_tmp24_ = _tmp23_->message;
#line 98 "../src/Backend/WacomToolMap.vala"
					g_warning ("WacomToolMap.vala:98: Could not get cached ID for tool with serial %s:" \
" %s", _tmp22_, _tmp24_);
#line 99 "../src/Backend/WacomToolMap.vala"
					_g_error_free0 (e);
#line 99 "../src/Backend/WacomToolMap.vala"
					_g_free0 (str);
#line 99 "../src/Backend/WacomToolMap.vala"
					continue;
#line 580 "WacomToolMap.c"
				}
				__finally1:
#line 95 "../src/Backend/WacomToolMap.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 95 "../src/Backend/WacomToolMap.vala"
					_g_free0 (str);
#line 95 "../src/Backend/WacomToolMap.vala"
					serials = (_vala_array_free (serials, serials_length1, (GDestroyNotify) g_free), NULL);
#line 95 "../src/Backend/WacomToolMap.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 95 "../src/Backend/WacomToolMap.vala"
					g_clear_error (&_inner_error0_);
#line 95 "../src/Backend/WacomToolMap.vala"
					return;
#line 595 "WacomToolMap.c"
				}
				{
					gboolean _tmp25_ = FALSE;
					const gchar* _tmp26_;
					guint64 _tmp27_ = 0ULL;
					gboolean _tmp28_;
#line 103 "../src/Backend/WacomToolMap.vala"
					_tmp26_ = str;
#line 103 "../src/Backend/WacomToolMap.vala"
					_tmp28_ = g_ascii_string_to_unsigned (_tmp26_, (guint) 16, 0ULL, G_MAXUINT64, &_tmp27_, &_inner_error0_);
#line 103 "../src/Backend/WacomToolMap.vala"
					id = _tmp27_;
#line 103 "../src/Backend/WacomToolMap.vala"
					_tmp25_ = _tmp28_;
#line 103 "../src/Backend/WacomToolMap.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 612 "WacomToolMap.c"
						goto __catch2_g_error;
					}
#line 103 "../src/Backend/WacomToolMap.vala"
					if (!_tmp25_) {
#line 617 "WacomToolMap.c"
						const gchar* _tmp29_;
#line 104 "../src/Backend/WacomToolMap.vala"
						_tmp29_ = str;
#line 104 "../src/Backend/WacomToolMap.vala"
						g_warning ("WacomToolMap.vala:104: Invalid tool ID %s", _tmp29_);
#line 105 "../src/Backend/WacomToolMap.vala"
						_g_free0 (str);
#line 105 "../src/Backend/WacomToolMap.vala"
						continue;
#line 627 "WacomToolMap.c"
					}
				}
				goto __finally2;
				__catch2_g_error:
				{
					const gchar* _tmp30_;
#line 102 "../src/Backend/WacomToolMap.vala"
					g_clear_error (&_inner_error0_);
#line 108 "../src/Backend/WacomToolMap.vala"
					_tmp30_ = str;
#line 108 "../src/Backend/WacomToolMap.vala"
					g_warning ("WacomToolMap.vala:108: Invalid tool ID %s", _tmp30_);
#line 109 "../src/Backend/WacomToolMap.vala"
					_g_free0 (str);
#line 109 "../src/Backend/WacomToolMap.vala"
					continue;
#line 644 "WacomToolMap.c"
				}
				__finally2:
#line 102 "../src/Backend/WacomToolMap.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 102 "../src/Backend/WacomToolMap.vala"
					_g_free0 (str);
#line 102 "../src/Backend/WacomToolMap.vala"
					serials = (_vala_array_free (serials, serials_length1, (GDestroyNotify) g_free), NULL);
#line 102 "../src/Backend/WacomToolMap.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 102 "../src/Backend/WacomToolMap.vala"
					g_clear_error (&_inner_error0_);
#line 102 "../src/Backend/WacomToolMap.vala"
					return;
#line 659 "WacomToolMap.c"
				}
#line 112 "../src/Backend/WacomToolMap.vala"
				_tmp31_ = self->priv->tool_map;
#line 112 "../src/Backend/WacomToolMap.vala"
				_tmp32_ = serials;
#line 112 "../src/Backend/WacomToolMap.vala"
				_tmp32__length1 = serials_length1;
#line 112 "../src/Backend/WacomToolMap.vala"
				_tmp33_ = _tmp32_[i];
#line 112 "../src/Backend/WacomToolMap.vala"
				_tmp34_ = g_strdup_printf ("/org/gnome/desktop/peripherals/stylus/%llx/", serial);
#line 112 "../src/Backend/WacomToolMap.vala"
				_tmp35_ = _tmp34_;
#line 112 "../src/Backend/WacomToolMap.vala"
				_tmp36_ = wacom_backend_wacom_tool_new (serial, id, _tmp35_);
#line 112 "../src/Backend/WacomToolMap.vala"
				_tmp37_ = _tmp36_;
#line 112 "../src/Backend/WacomToolMap.vala"
				gee_abstract_map_set ((GeeAbstractMap*) _tmp31_, _tmp33_, _tmp37_);
#line 112 "../src/Backend/WacomToolMap.vala"
				_g_object_unref0 (_tmp37_);
#line 112 "../src/Backend/WacomToolMap.vala"
				_g_free0 (_tmp35_);
#line 82 "../src/Backend/WacomToolMap.vala"
				_g_free0 (str);
#line 685 "WacomToolMap.c"
			}
		}
	}
#line 80 "../src/Backend/WacomToolMap.vala"
	serials = (_vala_array_free (serials, serials_length1, (GDestroyNotify) g_free), NULL);
#line 691 "WacomToolMap.c"
}

static void
wacom_backend_wacom_tool_map_cache_devices (WacomBackendWacomToolMap* self)
{
	gchar** ids = NULL;
	GKeyFile* _tmp0_;
	gsize _tmp1_ = 0;
	gchar** _tmp2_;
	gint ids_length1;
	gint _ids_size_;
	GError* _inner_error0_ = NULL;
#line 116 "../src/Backend/WacomToolMap.vala"
	g_return_if_fail (self != NULL);
#line 117 "../src/Backend/WacomToolMap.vala"
	_tmp0_ = self->priv->tablets;
#line 117 "../src/Backend/WacomToolMap.vala"
	_tmp2_ = g_key_file_get_groups (_tmp0_, &_tmp1_);
#line 117 "../src/Backend/WacomToolMap.vala"
	ids = _tmp2_;
#line 117 "../src/Backend/WacomToolMap.vala"
	ids_length1 = _tmp1_;
#line 117 "../src/Backend/WacomToolMap.vala"
	_ids_size_ = ids_length1;
#line 716 "WacomToolMap.c"
	{
		gint i = 0;
#line 118 "../src/Backend/WacomToolMap.vala"
		i = 0;
#line 721 "WacomToolMap.c"
		{
			gboolean _tmp3_ = FALSE;
#line 118 "../src/Backend/WacomToolMap.vala"
			_tmp3_ = TRUE;
#line 118 "../src/Backend/WacomToolMap.vala"
			while (TRUE) {
#line 728 "WacomToolMap.c"
				gchar** _tmp5_;
				gint _tmp5__length1;
				GeeArrayList* tools = NULL;
				GeeArrayList* _tmp6_;
				gchar** styli = NULL;
				gint styli_length1;
				gint _styli_size_;
				GeeArrayList* _tmp33_;
				gint _tmp34_;
				gint _tmp35_;
#line 118 "../src/Backend/WacomToolMap.vala"
				if (!_tmp3_) {
#line 741 "WacomToolMap.c"
					gint _tmp4_;
#line 118 "../src/Backend/WacomToolMap.vala"
					_tmp4_ = i;
#line 118 "../src/Backend/WacomToolMap.vala"
					i = _tmp4_ + 1;
#line 747 "WacomToolMap.c"
				}
#line 118 "../src/Backend/WacomToolMap.vala"
				_tmp3_ = FALSE;
#line 118 "../src/Backend/WacomToolMap.vala"
				_tmp5_ = ids;
#line 118 "../src/Backend/WacomToolMap.vala"
				_tmp5__length1 = ids_length1;
#line 118 "../src/Backend/WacomToolMap.vala"
				if (!(i < _tmp5__length1)) {
#line 118 "../src/Backend/WacomToolMap.vala"
					break;
#line 759 "WacomToolMap.c"
				}
#line 119 "../src/Backend/WacomToolMap.vala"
				_tmp6_ = gee_array_list_new (WACOM_BACKEND_TYPE_WACOM_TOOL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 119 "../src/Backend/WacomToolMap.vala"
				tools = _tmp6_;
#line 121 "../src/Backend/WacomToolMap.vala"
				styli = NULL;
#line 121 "../src/Backend/WacomToolMap.vala"
				styli_length1 = 0;
#line 121 "../src/Backend/WacomToolMap.vala"
				_styli_size_ = styli_length1;
#line 771 "WacomToolMap.c"
				{
					gchar** _tmp7_ = NULL;
					GKeyFile* _tmp8_;
					gchar** _tmp9_;
					gint _tmp9__length1;
					const gchar* _tmp10_;
					gsize _tmp11_ = 0;
					gchar** _tmp12_;
					gint _tmp7__length1;
					gint __tmp7__size_;
					gchar** _tmp13_;
					gint _tmp13__length1;
#line 123 "../src/Backend/WacomToolMap.vala"
					_tmp8_ = self->priv->tablets;
#line 123 "../src/Backend/WacomToolMap.vala"
					_tmp9_ = ids;
#line 123 "../src/Backend/WacomToolMap.vala"
					_tmp9__length1 = ids_length1;
#line 123 "../src/Backend/WacomToolMap.vala"
					_tmp10_ = _tmp9_[i];
#line 123 "../src/Backend/WacomToolMap.vala"
					_tmp12_ = g_key_file_get_string_list (_tmp8_, _tmp10_, WACOM_BACKEND_WACOM_TOOL_MAP_KEY_DEVICE_STYLI, &_tmp11_, &_inner_error0_);
#line 123 "../src/Backend/WacomToolMap.vala"
					_tmp7_ = _tmp12_;
#line 123 "../src/Backend/WacomToolMap.vala"
					_tmp7__length1 = _tmp11_;
#line 123 "../src/Backend/WacomToolMap.vala"
					__tmp7__size_ = _tmp7__length1;
#line 123 "../src/Backend/WacomToolMap.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 123 "../src/Backend/WacomToolMap.vala"
						if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 804 "WacomToolMap.c"
							goto __catch0_g_key_file_error;
						}
#line 123 "../src/Backend/WacomToolMap.vala"
						styli = (_vala_array_free (styli, styli_length1, (GDestroyNotify) g_free), NULL);
#line 123 "../src/Backend/WacomToolMap.vala"
						_g_object_unref0 (tools);
#line 123 "../src/Backend/WacomToolMap.vala"
						ids = (_vala_array_free (ids, ids_length1, (GDestroyNotify) g_free), NULL);
#line 123 "../src/Backend/WacomToolMap.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 123 "../src/Backend/WacomToolMap.vala"
						g_clear_error (&_inner_error0_);
#line 123 "../src/Backend/WacomToolMap.vala"
						return;
#line 819 "WacomToolMap.c"
					}
#line 123 "../src/Backend/WacomToolMap.vala"
					_tmp13_ = _tmp7_;
#line 123 "../src/Backend/WacomToolMap.vala"
					_tmp13__length1 = _tmp7__length1;
#line 123 "../src/Backend/WacomToolMap.vala"
					_tmp7_ = NULL;
#line 123 "../src/Backend/WacomToolMap.vala"
					_tmp7__length1 = 0;
#line 123 "../src/Backend/WacomToolMap.vala"
					styli = (_vala_array_free (styli, styli_length1, (GDestroyNotify) g_free), NULL);
#line 123 "../src/Backend/WacomToolMap.vala"
					styli = _tmp13_;
#line 123 "../src/Backend/WacomToolMap.vala"
					styli_length1 = _tmp13__length1;
#line 123 "../src/Backend/WacomToolMap.vala"
					_styli_size_ = styli_length1;
#line 122 "../src/Backend/WacomToolMap.vala"
					_tmp7_ = (_vala_array_free (_tmp7_, _tmp7__length1, (GDestroyNotify) g_free), NULL);
#line 839 "WacomToolMap.c"
				}
				goto __finally0;
				__catch0_g_key_file_error:
				{
					GError* e = NULL;
					gchar** _tmp14_;
					gint _tmp14__length1;
					const gchar* _tmp15_;
					GError* _tmp16_;
					const gchar* _tmp17_;
#line 122 "../src/Backend/WacomToolMap.vala"
					e = _inner_error0_;
#line 122 "../src/Backend/WacomToolMap.vala"
					_inner_error0_ = NULL;
#line 125 "../src/Backend/WacomToolMap.vala"
					_tmp14_ = ids;
#line 125 "../src/Backend/WacomToolMap.vala"
					_tmp14__length1 = ids_length1;
#line 125 "../src/Backend/WacomToolMap.vala"
					_tmp15_ = _tmp14_[i];
#line 125 "../src/Backend/WacomToolMap.vala"
					_tmp16_ = e;
#line 125 "../src/Backend/WacomToolMap.vala"
					_tmp17_ = _tmp16_->message;
#line 125 "../src/Backend/WacomToolMap.vala"
					g_warning ("WacomToolMap.vala:125: Could not get cached styli for tablet with id %" \
"s: %s", _tmp15_, _tmp17_);
#line 126 "../src/Backend/WacomToolMap.vala"
					_g_error_free0 (e);
#line 126 "../src/Backend/WacomToolMap.vala"
					styli = (_vala_array_free (styli, styli_length1, (GDestroyNotify) g_free), NULL);
#line 126 "../src/Backend/WacomToolMap.vala"
					_g_object_unref0 (tools);
#line 126 "../src/Backend/WacomToolMap.vala"
					continue;
#line 874 "WacomToolMap.c"
				}
				__finally0:
#line 122 "../src/Backend/WacomToolMap.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 122 "../src/Backend/WacomToolMap.vala"
					styli = (_vala_array_free (styli, styli_length1, (GDestroyNotify) g_free), NULL);
#line 122 "../src/Backend/WacomToolMap.vala"
					_g_object_unref0 (tools);
#line 122 "../src/Backend/WacomToolMap.vala"
					ids = (_vala_array_free (ids, ids_length1, (GDestroyNotify) g_free), NULL);
#line 122 "../src/Backend/WacomToolMap.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 122 "../src/Backend/WacomToolMap.vala"
					g_clear_error (&_inner_error0_);
#line 122 "../src/Backend/WacomToolMap.vala"
					return;
#line 891 "WacomToolMap.c"
				}
				{
					gint j = 0;
#line 129 "../src/Backend/WacomToolMap.vala"
					j = 0;
#line 897 "WacomToolMap.c"
					{
						gboolean _tmp18_ = FALSE;
#line 129 "../src/Backend/WacomToolMap.vala"
						_tmp18_ = TRUE;
#line 129 "../src/Backend/WacomToolMap.vala"
						while (TRUE) {
#line 904 "WacomToolMap.c"
							gchar** _tmp20_;
							gint _tmp20__length1;
							gchar** _tmp21_;
							gint _tmp21__length1;
							const gchar* _tmp22_;
							WacomBackendWacomTool* tool = NULL;
							GeeHashMap* _tmp26_;
							gchar** _tmp27_;
							gint _tmp27__length1;
							const gchar* _tmp28_;
							gpointer _tmp29_;
							WacomBackendWacomTool* _tmp30_;
#line 129 "../src/Backend/WacomToolMap.vala"
							if (!_tmp18_) {
#line 919 "WacomToolMap.c"
								gint _tmp19_;
#line 129 "../src/Backend/WacomToolMap.vala"
								_tmp19_ = j;
#line 129 "../src/Backend/WacomToolMap.vala"
								j = _tmp19_ + 1;
#line 925 "WacomToolMap.c"
							}
#line 129 "../src/Backend/WacomToolMap.vala"
							_tmp18_ = FALSE;
#line 129 "../src/Backend/WacomToolMap.vala"
							_tmp20_ = styli;
#line 129 "../src/Backend/WacomToolMap.vala"
							_tmp20__length1 = styli_length1;
#line 129 "../src/Backend/WacomToolMap.vala"
							if (!(j < _tmp20__length1)) {
#line 129 "../src/Backend/WacomToolMap.vala"
								break;
#line 937 "WacomToolMap.c"
							}
#line 130 "../src/Backend/WacomToolMap.vala"
							_tmp21_ = styli;
#line 130 "../src/Backend/WacomToolMap.vala"
							_tmp21__length1 = styli_length1;
#line 130 "../src/Backend/WacomToolMap.vala"
							_tmp22_ = _tmp21_[j];
#line 130 "../src/Backend/WacomToolMap.vala"
							if (g_strcmp0 (_tmp22_, WACOM_BACKEND_WACOM_TOOL_MAP_GENERIC_STYLUS) == 0) {
#line 947 "WacomToolMap.c"
								GeeHashMap* _tmp23_;
								gchar** _tmp24_;
								gint _tmp24__length1;
								const gchar* _tmp25_;
#line 131 "../src/Backend/WacomToolMap.vala"
								_tmp23_ = self->priv->no_serial_tool_map;
#line 131 "../src/Backend/WacomToolMap.vala"
								_tmp24_ = ids;
#line 131 "../src/Backend/WacomToolMap.vala"
								_tmp24__length1 = ids_length1;
#line 131 "../src/Backend/WacomToolMap.vala"
								_tmp25_ = _tmp24_[i];
#line 131 "../src/Backend/WacomToolMap.vala"
								gee_abstract_map_set ((GeeAbstractMap*) _tmp23_, _tmp25_, NULL);
#line 962 "WacomToolMap.c"
							}
#line 134 "../src/Backend/WacomToolMap.vala"
							_tmp26_ = self->priv->tool_map;
#line 134 "../src/Backend/WacomToolMap.vala"
							_tmp27_ = styli;
#line 134 "../src/Backend/WacomToolMap.vala"
							_tmp27__length1 = styli_length1;
#line 134 "../src/Backend/WacomToolMap.vala"
							_tmp28_ = _tmp27_[j];
#line 134 "../src/Backend/WacomToolMap.vala"
							_tmp29_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp26_, _tmp28_);
#line 134 "../src/Backend/WacomToolMap.vala"
							tool = (WacomBackendWacomTool*) _tmp29_;
#line 135 "../src/Backend/WacomToolMap.vala"
							_tmp30_ = tool;
#line 135 "../src/Backend/WacomToolMap.vala"
							if (_tmp30_ != NULL) {
#line 980 "WacomToolMap.c"
								GeeArrayList* _tmp31_;
								WacomBackendWacomTool* _tmp32_;
#line 136 "../src/Backend/WacomToolMap.vala"
								_tmp31_ = tools;
#line 136 "../src/Backend/WacomToolMap.vala"
								_tmp32_ = tool;
#line 136 "../src/Backend/WacomToolMap.vala"
								gee_abstract_collection_add ((GeeAbstractCollection*) _tmp31_, _tmp32_);
#line 989 "WacomToolMap.c"
							}
#line 129 "../src/Backend/WacomToolMap.vala"
							_g_object_unref0 (tool);
#line 993 "WacomToolMap.c"
						}
					}
				}
#line 140 "../src/Backend/WacomToolMap.vala"
				_tmp33_ = tools;
#line 140 "../src/Backend/WacomToolMap.vala"
				_tmp34_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp33_);
#line 140 "../src/Backend/WacomToolMap.vala"
				_tmp35_ = _tmp34_;
#line 140 "../src/Backend/WacomToolMap.vala"
				if (_tmp35_ > 0) {
#line 1005 "WacomToolMap.c"
					GeeHashMap* _tmp36_;
					gchar** _tmp37_;
					gint _tmp37__length1;
					const gchar* _tmp38_;
					GeeArrayList* _tmp39_;
#line 141 "../src/Backend/WacomToolMap.vala"
					_tmp36_ = self->priv->tablet_map;
#line 141 "../src/Backend/WacomToolMap.vala"
					_tmp37_ = ids;
#line 141 "../src/Backend/WacomToolMap.vala"
					_tmp37__length1 = ids_length1;
#line 141 "../src/Backend/WacomToolMap.vala"
					_tmp38_ = _tmp37_[i];
#line 141 "../src/Backend/WacomToolMap.vala"
					_tmp39_ = tools;
#line 141 "../src/Backend/WacomToolMap.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _tmp36_, _tmp38_, _tmp39_);
#line 1023 "WacomToolMap.c"
				}
#line 118 "../src/Backend/WacomToolMap.vala"
				styli = (_vala_array_free (styli, styli_length1, (GDestroyNotify) g_free), NULL);
#line 118 "../src/Backend/WacomToolMap.vala"
				_g_object_unref0 (tools);
#line 1029 "WacomToolMap.c"
			}
		}
	}
#line 116 "../src/Backend/WacomToolMap.vala"
	ids = (_vala_array_free (ids, ids_length1, (GDestroyNotify) g_free), NULL);
#line 1035 "WacomToolMap.c"
}

static gchar*
wacom_backend_wacom_tool_map_get_tool_key (guint64 serial)
{
	gchar* _tmp0_;
	gchar* result;
#line 147 "../src/Backend/WacomToolMap.vala"
	_tmp0_ = g_strdup_printf ("%llx", serial);
#line 147 "../src/Backend/WacomToolMap.vala"
	result = _tmp0_;
#line 147 "../src/Backend/WacomToolMap.vala"
	return result;
#line 1049 "WacomToolMap.c"
}

void
wacom_backend_wacom_tool_map_add_relation (WacomBackendWacomToolMap* self,
                                           const gchar* device_key,
                                           WacomBackendWacomTool* tool)
{
	gchar* tool_key = NULL;
	gboolean tools_changed = FALSE;
	gboolean tablets_changed = FALSE;
	guint64 serial = 0ULL;
	guint64 _tmp0_;
	guint64 _tmp1_;
	GeeArrayList* styli = NULL;
	GeeHashMap* _tmp19_;
	gpointer _tmp20_;
	GeeArrayList* _tmp21_;
	GeeArrayList* _tmp25_;
	GError* _inner_error0_ = NULL;
#line 150 "../src/Backend/WacomToolMap.vala"
	g_return_if_fail (self != NULL);
#line 150 "../src/Backend/WacomToolMap.vala"
	g_return_if_fail (device_key != NULL);
#line 150 "../src/Backend/WacomToolMap.vala"
	g_return_if_fail (tool != NULL);
#line 152 "../src/Backend/WacomToolMap.vala"
	tools_changed = FALSE;
#line 152 "../src/Backend/WacomToolMap.vala"
	tablets_changed = FALSE;
#line 154 "../src/Backend/WacomToolMap.vala"
	_tmp0_ = wacom_backend_wacom_tool_get_serial (tool);
#line 154 "../src/Backend/WacomToolMap.vala"
	_tmp1_ = _tmp0_;
#line 154 "../src/Backend/WacomToolMap.vala"
	serial = _tmp1_;
#line 156 "../src/Backend/WacomToolMap.vala"
	if (serial == ((guint64) 0)) {
#line 1087 "WacomToolMap.c"
		gchar* _tmp2_;
		GeeHashMap* _tmp3_;
#line 157 "../src/Backend/WacomToolMap.vala"
		_tmp2_ = g_strdup (WACOM_BACKEND_WACOM_TOOL_MAP_GENERIC_STYLUS);
#line 157 "../src/Backend/WacomToolMap.vala"
		_g_free0 (tool_key);
#line 157 "../src/Backend/WacomToolMap.vala"
		tool_key = _tmp2_;
#line 158 "../src/Backend/WacomToolMap.vala"
		_tmp3_ = self->priv->no_serial_tool_map;
#line 158 "../src/Backend/WacomToolMap.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp3_, device_key, tool);
#line 1100 "WacomToolMap.c"
	} else {
		gchar* _tmp4_;
		GeeHashMap* _tmp5_;
		const gchar* _tmp6_;
#line 160 "../src/Backend/WacomToolMap.vala"
		_tmp4_ = wacom_backend_wacom_tool_map_get_tool_key (serial);
#line 160 "../src/Backend/WacomToolMap.vala"
		_g_free0 (tool_key);
#line 160 "../src/Backend/WacomToolMap.vala"
		tool_key = _tmp4_;
#line 161 "../src/Backend/WacomToolMap.vala"
		_tmp5_ = self->priv->tool_map;
#line 161 "../src/Backend/WacomToolMap.vala"
		_tmp6_ = tool_key;
#line 161 "../src/Backend/WacomToolMap.vala"
		if (!gee_abstract_map_has_key ((GeeAbstractMap*) _tmp5_, _tmp6_)) {
#line 1117 "WacomToolMap.c"
			const gchar* _tmp7_;
			guint64 _tmp8_;
			guint64 _tmp9_;
			GeeHashMap* _tmp10_;
			const gchar* _tmp11_;
#line 162 "../src/Backend/WacomToolMap.vala"
			_tmp7_ = tool_key;
#line 162 "../src/Backend/WacomToolMap.vala"
			_tmp8_ = wacom_backend_wacom_tool_get_id (tool);
#line 162 "../src/Backend/WacomToolMap.vala"
			_tmp9_ = _tmp8_;
#line 162 "../src/Backend/WacomToolMap.vala"
			wacom_backend_wacom_tool_map_keyfile_add_stylus (self, _tmp7_, _tmp9_);
#line 163 "../src/Backend/WacomToolMap.vala"
			tools_changed = TRUE;
#line 164 "../src/Backend/WacomToolMap.vala"
			_tmp10_ = self->priv->tool_map;
#line 164 "../src/Backend/WacomToolMap.vala"
			_tmp11_ = tool_key;
#line 164 "../src/Backend/WacomToolMap.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp10_, _tmp11_, tool);
#line 1139 "WacomToolMap.c"
		} else {
			GeeHashMap* _tmp12_;
			const gchar* _tmp13_;
			gpointer _tmp14_;
			WacomBackendWacomTool* _tmp15_;
			gboolean _tmp16_;
#line 165 "../src/Backend/WacomToolMap.vala"
			_tmp12_ = self->priv->tool_map;
#line 165 "../src/Backend/WacomToolMap.vala"
			_tmp13_ = tool_key;
#line 165 "../src/Backend/WacomToolMap.vala"
			_tmp14_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp12_, _tmp13_);
#line 165 "../src/Backend/WacomToolMap.vala"
			_tmp15_ = (WacomBackendWacomTool*) _tmp14_;
#line 165 "../src/Backend/WacomToolMap.vala"
			_tmp16_ = _tmp15_ == NULL;
#line 165 "../src/Backend/WacomToolMap.vala"
			_g_object_unref0 (_tmp15_);
#line 165 "../src/Backend/WacomToolMap.vala"
			if (_tmp16_) {
#line 1160 "WacomToolMap.c"
				GeeHashMap* _tmp17_;
				const gchar* _tmp18_;
#line 166 "../src/Backend/WacomToolMap.vala"
				_tmp17_ = self->priv->tool_map;
#line 166 "../src/Backend/WacomToolMap.vala"
				_tmp18_ = tool_key;
#line 166 "../src/Backend/WacomToolMap.vala"
				gee_abstract_map_set ((GeeAbstractMap*) _tmp17_, _tmp18_, tool);
#line 1169 "WacomToolMap.c"
			}
		}
	}
#line 170 "../src/Backend/WacomToolMap.vala"
	_tmp19_ = self->priv->tablet_map;
#line 170 "../src/Backend/WacomToolMap.vala"
	_tmp20_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp19_, device_key);
#line 170 "../src/Backend/WacomToolMap.vala"
	styli = (GeeArrayList*) _tmp20_;
#line 171 "../src/Backend/WacomToolMap.vala"
	_tmp21_ = styli;
#line 171 "../src/Backend/WacomToolMap.vala"
	if (_tmp21_ == NULL) {
#line 1183 "WacomToolMap.c"
		GeeArrayList* _tmp22_;
		GeeHashMap* _tmp23_;
		GeeArrayList* _tmp24_;
#line 172 "../src/Backend/WacomToolMap.vala"
		_tmp22_ = gee_array_list_new (WACOM_BACKEND_TYPE_WACOM_TOOL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 172 "../src/Backend/WacomToolMap.vala"
		_g_object_unref0 (styli);
#line 172 "../src/Backend/WacomToolMap.vala"
		styli = _tmp22_;
#line 173 "../src/Backend/WacomToolMap.vala"
		_tmp23_ = self->priv->tablet_map;
#line 173 "../src/Backend/WacomToolMap.vala"
		_tmp24_ = styli;
#line 173 "../src/Backend/WacomToolMap.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp23_, device_key, _tmp24_);
#line 1199 "WacomToolMap.c"
	}
#line 176 "../src/Backend/WacomToolMap.vala"
	_tmp25_ = styli;
#line 176 "../src/Backend/WacomToolMap.vala"
	if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp25_, tool)) {
#line 1205 "WacomToolMap.c"
		const gchar* _tmp26_;
		GeeArrayList* _tmp27_;
#line 177 "../src/Backend/WacomToolMap.vala"
		tablets_changed = TRUE;
#line 178 "../src/Backend/WacomToolMap.vala"
		_tmp26_ = tool_key;
#line 178 "../src/Backend/WacomToolMap.vala"
		wacom_backend_wacom_tool_map_keyfile_add_device_stylus (self, device_key, _tmp26_);
#line 179 "../src/Backend/WacomToolMap.vala"
		_tmp27_ = styli;
#line 179 "../src/Backend/WacomToolMap.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp27_, tool);
#line 1218 "WacomToolMap.c"
	}
#line 182 "../src/Backend/WacomToolMap.vala"
	if (tools_changed) {
#line 1222 "WacomToolMap.c"
		{
			GKeyFile* _tmp28_;
			const gchar* _tmp29_;
#line 184 "../src/Backend/WacomToolMap.vala"
			_tmp28_ = self->priv->tools;
#line 184 "../src/Backend/WacomToolMap.vala"
			_tmp29_ = self->priv->tool_path;
#line 184 "../src/Backend/WacomToolMap.vala"
			g_key_file_save_to_file (_tmp28_, _tmp29_, &_inner_error0_);
#line 184 "../src/Backend/WacomToolMap.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 184 "../src/Backend/WacomToolMap.vala"
				if (_inner_error0_->domain == G_FILE_ERROR) {
#line 1236 "WacomToolMap.c"
					goto __catch0_g_file_error;
				}
#line 184 "../src/Backend/WacomToolMap.vala"
				_g_object_unref0 (styli);
#line 184 "../src/Backend/WacomToolMap.vala"
				_g_free0 (tool_key);
#line 184 "../src/Backend/WacomToolMap.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 184 "../src/Backend/WacomToolMap.vala"
				g_clear_error (&_inner_error0_);
#line 184 "../src/Backend/WacomToolMap.vala"
				return;
#line 1249 "WacomToolMap.c"
			}
		}
		goto __finally0;
		__catch0_g_file_error:
		{
			GError* e = NULL;
			const gchar* _tmp30_;
			GError* _tmp31_;
			const gchar* _tmp32_;
#line 183 "../src/Backend/WacomToolMap.vala"
			e = _inner_error0_;
#line 183 "../src/Backend/WacomToolMap.vala"
			_inner_error0_ = NULL;
#line 186 "../src/Backend/WacomToolMap.vala"
			_tmp30_ = self->priv->tool_path;
#line 186 "../src/Backend/WacomToolMap.vala"
			_tmp31_ = e;
#line 186 "../src/Backend/WacomToolMap.vala"
			_tmp32_ = _tmp31_->message;
#line 186 "../src/Backend/WacomToolMap.vala"
			g_warning ("WacomToolMap.vala:186: Error saving tools keyfile '%s': %s", _tmp30_, _tmp32_);
#line 183 "../src/Backend/WacomToolMap.vala"
			_g_error_free0 (e);
#line 1273 "WacomToolMap.c"
		}
		__finally0:
#line 183 "../src/Backend/WacomToolMap.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 183 "../src/Backend/WacomToolMap.vala"
			_g_object_unref0 (styli);
#line 183 "../src/Backend/WacomToolMap.vala"
			_g_free0 (tool_key);
#line 183 "../src/Backend/WacomToolMap.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 183 "../src/Backend/WacomToolMap.vala"
			g_clear_error (&_inner_error0_);
#line 183 "../src/Backend/WacomToolMap.vala"
			return;
#line 1288 "WacomToolMap.c"
		}
	}
#line 190 "../src/Backend/WacomToolMap.vala"
	if (tablets_changed) {
#line 1293 "WacomToolMap.c"
		{
			GKeyFile* _tmp33_;
			const gchar* _tmp34_;
#line 192 "../src/Backend/WacomToolMap.vala"
			_tmp33_ = self->priv->tablets;
#line 192 "../src/Backend/WacomToolMap.vala"
			_tmp34_ = self->priv->tablet_path;
#line 192 "../src/Backend/WacomToolMap.vala"
			g_key_file_save_to_file (_tmp33_, _tmp34_, &_inner_error0_);
#line 192 "../src/Backend/WacomToolMap.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 192 "../src/Backend/WacomToolMap.vala"
				if (_inner_error0_->domain == G_FILE_ERROR) {
#line 1307 "WacomToolMap.c"
					goto __catch1_g_file_error;
				}
#line 192 "../src/Backend/WacomToolMap.vala"
				_g_object_unref0 (styli);
#line 192 "../src/Backend/WacomToolMap.vala"
				_g_free0 (tool_key);
#line 192 "../src/Backend/WacomToolMap.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 192 "../src/Backend/WacomToolMap.vala"
				g_clear_error (&_inner_error0_);
#line 192 "../src/Backend/WacomToolMap.vala"
				return;
#line 1320 "WacomToolMap.c"
			}
		}
		goto __finally1;
		__catch1_g_file_error:
		{
			GError* e = NULL;
			const gchar* _tmp35_;
			GError* _tmp36_;
			const gchar* _tmp37_;
#line 191 "../src/Backend/WacomToolMap.vala"
			e = _inner_error0_;
#line 191 "../src/Backend/WacomToolMap.vala"
			_inner_error0_ = NULL;
#line 194 "../src/Backend/WacomToolMap.vala"
			_tmp35_ = self->priv->tablet_path;
#line 194 "../src/Backend/WacomToolMap.vala"
			_tmp36_ = e;
#line 194 "../src/Backend/WacomToolMap.vala"
			_tmp37_ = _tmp36_->message;
#line 194 "../src/Backend/WacomToolMap.vala"
			g_warning ("WacomToolMap.vala:194: Error saving tablets keyfile '%s': %s", _tmp35_, _tmp37_);
#line 191 "../src/Backend/WacomToolMap.vala"
			_g_error_free0 (e);
#line 1344 "WacomToolMap.c"
		}
		__finally1:
#line 191 "../src/Backend/WacomToolMap.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 191 "../src/Backend/WacomToolMap.vala"
			_g_object_unref0 (styli);
#line 191 "../src/Backend/WacomToolMap.vala"
			_g_free0 (tool_key);
#line 191 "../src/Backend/WacomToolMap.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 191 "../src/Backend/WacomToolMap.vala"
			g_clear_error (&_inner_error0_);
#line 191 "../src/Backend/WacomToolMap.vala"
			return;
#line 1359 "WacomToolMap.c"
		}
	}
#line 150 "../src/Backend/WacomToolMap.vala"
	_g_object_unref0 (styli);
#line 150 "../src/Backend/WacomToolMap.vala"
	_g_free0 (tool_key);
#line 1366 "WacomToolMap.c"
}

static void
_vala_array_add1 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 211 "../src/Backend/WacomToolMap.vala"
	if ((*length) == (*size)) {
#line 211 "../src/Backend/WacomToolMap.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 211 "../src/Backend/WacomToolMap.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1381 "WacomToolMap.c"
	}
#line 211 "../src/Backend/WacomToolMap.vala"
	(*array)[(*length)++] = value;
#line 211 "../src/Backend/WacomToolMap.vala"
	(*array)[*length] = NULL;
#line 1387 "WacomToolMap.c"
}

static void
wacom_backend_wacom_tool_map_keyfile_add_device_stylus (WacomBackendWacomToolMap* self,
                                                        const gchar* device_key,
                                                        const gchar* tool_key)
{
	gchar** styli = NULL;
	gint styli_length1;
	gint _styli_size_;
	gchar** _tmp5_;
	gint _tmp5__length1;
	gchar* _tmp7_;
	GKeyFile* _tmp8_;
	gchar** _tmp9_;
	gint _tmp9__length1;
	GError* _inner_error0_ = NULL;
#line 199 "../src/Backend/WacomToolMap.vala"
	g_return_if_fail (self != NULL);
#line 199 "../src/Backend/WacomToolMap.vala"
	g_return_if_fail (device_key != NULL);
#line 199 "../src/Backend/WacomToolMap.vala"
	g_return_if_fail (tool_key != NULL);
#line 200 "../src/Backend/WacomToolMap.vala"
	styli = NULL;
#line 200 "../src/Backend/WacomToolMap.vala"
	styli_length1 = 0;
#line 200 "../src/Backend/WacomToolMap.vala"
	_styli_size_ = styli_length1;
#line 1417 "WacomToolMap.c"
	{
		gchar** _tmp0_ = NULL;
		GKeyFile* _tmp1_;
		gsize _tmp2_ = 0;
		gchar** _tmp3_;
		gint _tmp0__length1;
		gint __tmp0__size_;
		gchar** _tmp4_;
		gint _tmp4__length1;
#line 202 "../src/Backend/WacomToolMap.vala"
		_tmp1_ = self->priv->tablets;
#line 202 "../src/Backend/WacomToolMap.vala"
		_tmp3_ = g_key_file_get_string_list (_tmp1_, device_key, WACOM_BACKEND_WACOM_TOOL_MAP_KEY_DEVICE_STYLI, &_tmp2_, &_inner_error0_);
#line 202 "../src/Backend/WacomToolMap.vala"
		_tmp0_ = _tmp3_;
#line 202 "../src/Backend/WacomToolMap.vala"
		_tmp0__length1 = _tmp2_;
#line 202 "../src/Backend/WacomToolMap.vala"
		__tmp0__size_ = _tmp0__length1;
#line 202 "../src/Backend/WacomToolMap.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 202 "../src/Backend/WacomToolMap.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1441 "WacomToolMap.c"
				goto __catch0_g_key_file_error;
			}
#line 202 "../src/Backend/WacomToolMap.vala"
			styli = (_vala_array_free (styli, styli_length1, (GDestroyNotify) g_free), NULL);
#line 202 "../src/Backend/WacomToolMap.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 202 "../src/Backend/WacomToolMap.vala"
			g_clear_error (&_inner_error0_);
#line 202 "../src/Backend/WacomToolMap.vala"
			return;
#line 1452 "WacomToolMap.c"
		}
#line 202 "../src/Backend/WacomToolMap.vala"
		_tmp4_ = _tmp0_;
#line 202 "../src/Backend/WacomToolMap.vala"
		_tmp4__length1 = _tmp0__length1;
#line 202 "../src/Backend/WacomToolMap.vala"
		_tmp0_ = NULL;
#line 202 "../src/Backend/WacomToolMap.vala"
		_tmp0__length1 = 0;
#line 202 "../src/Backend/WacomToolMap.vala"
		styli = (_vala_array_free (styli, styli_length1, (GDestroyNotify) g_free), NULL);
#line 202 "../src/Backend/WacomToolMap.vala"
		styli = _tmp4_;
#line 202 "../src/Backend/WacomToolMap.vala"
		styli_length1 = _tmp4__length1;
#line 202 "../src/Backend/WacomToolMap.vala"
		_styli_size_ = styli_length1;
#line 201 "../src/Backend/WacomToolMap.vala"
		_tmp0_ = (_vala_array_free (_tmp0_, _tmp0__length1, (GDestroyNotify) g_free), NULL);
#line 1472 "WacomToolMap.c"
	}
	goto __finally0;
	__catch0_g_key_file_error:
	{
#line 201 "../src/Backend/WacomToolMap.vala"
		g_clear_error (&_inner_error0_);
#line 1479 "WacomToolMap.c"
	}
	__finally0:
#line 201 "../src/Backend/WacomToolMap.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 201 "../src/Backend/WacomToolMap.vala"
		styli = (_vala_array_free (styli, styli_length1, (GDestroyNotify) g_free), NULL);
#line 201 "../src/Backend/WacomToolMap.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 201 "../src/Backend/WacomToolMap.vala"
		g_clear_error (&_inner_error0_);
#line 201 "../src/Backend/WacomToolMap.vala"
		return;
#line 1492 "WacomToolMap.c"
	}
#line 207 "../src/Backend/WacomToolMap.vala"
	_tmp5_ = styli;
#line 207 "../src/Backend/WacomToolMap.vala"
	_tmp5__length1 = styli_length1;
#line 207 "../src/Backend/WacomToolMap.vala"
	if (_tmp5_ == NULL) {
#line 1500 "WacomToolMap.c"
		gchar** _tmp6_;
#line 208 "../src/Backend/WacomToolMap.vala"
		_tmp6_ = g_new0 (gchar*, 0 + 1);
#line 208 "../src/Backend/WacomToolMap.vala"
		styli = (_vala_array_free (styli, styli_length1, (GDestroyNotify) g_free), NULL);
#line 208 "../src/Backend/WacomToolMap.vala"
		styli = _tmp6_;
#line 208 "../src/Backend/WacomToolMap.vala"
		styli_length1 = 0;
#line 208 "../src/Backend/WacomToolMap.vala"
		_styli_size_ = styli_length1;
#line 1512 "WacomToolMap.c"
	}
#line 211 "../src/Backend/WacomToolMap.vala"
	_tmp7_ = g_strdup (tool_key);
#line 211 "../src/Backend/WacomToolMap.vala"
	_vala_array_add1 (&styli, &styli_length1, &_styli_size_, _tmp7_);
#line 212 "../src/Backend/WacomToolMap.vala"
	_tmp8_ = self->priv->tablets;
#line 212 "../src/Backend/WacomToolMap.vala"
	_tmp9_ = styli;
#line 212 "../src/Backend/WacomToolMap.vala"
	_tmp9__length1 = styli_length1;
#line 212 "../src/Backend/WacomToolMap.vala"
	g_key_file_set_string_list (_tmp8_, device_key, WACOM_BACKEND_WACOM_TOOL_MAP_KEY_DEVICE_STYLI, (const gchar* const*) _tmp9_, (gint) _tmp9__length1);
#line 199 "../src/Backend/WacomToolMap.vala"
	styli = (_vala_array_free (styli, styli_length1, (GDestroyNotify) g_free), NULL);
#line 1528 "WacomToolMap.c"
}

static void
wacom_backend_wacom_tool_map_keyfile_add_stylus (WacomBackendWacomToolMap* self,
                                                 const gchar* tool_key,
                                                 guint64 id)
{
	gchar* str = NULL;
	gchar* _tmp0_;
	GKeyFile* _tmp1_;
#line 215 "../src/Backend/WacomToolMap.vala"
	g_return_if_fail (self != NULL);
#line 215 "../src/Backend/WacomToolMap.vala"
	g_return_if_fail (tool_key != NULL);
#line 216 "../src/Backend/WacomToolMap.vala"
	_tmp0_ = wacom_backend_wacom_tool_map_get_tool_key (id);
#line 216 "../src/Backend/WacomToolMap.vala"
	str = _tmp0_;
#line 217 "../src/Backend/WacomToolMap.vala"
	_tmp1_ = self->priv->tools;
#line 217 "../src/Backend/WacomToolMap.vala"
	g_key_file_set_string (_tmp1_, tool_key, WACOM_BACKEND_WACOM_TOOL_MAP_KEY_TOOL_ID, str);
#line 215 "../src/Backend/WacomToolMap.vala"
	_g_free0 (str);
#line 1553 "WacomToolMap.c"
}

WacomBackendWacomTool*
wacom_backend_wacom_tool_map_lookup_tool (WacomBackendWacomToolMap* self,
                                          guint64 serial,
                                          const gchar* device_key)
{
	WacomBackendWacomTool* result;
#line 220 "../src/Backend/WacomToolMap.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 220 "../src/Backend/WacomToolMap.vala"
	g_return_val_if_fail (device_key != NULL, NULL);
#line 221 "../src/Backend/WacomToolMap.vala"
	if (serial == ((guint64) 0)) {
#line 1568 "WacomToolMap.c"
		GeeHashMap* _tmp0_;
		gpointer _tmp1_;
#line 222 "../src/Backend/WacomToolMap.vala"
		_tmp0_ = self->priv->no_serial_tool_map;
#line 222 "../src/Backend/WacomToolMap.vala"
		_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, device_key);
#line 222 "../src/Backend/WacomToolMap.vala"
		result = (WacomBackendWacomTool*) _tmp1_;
#line 222 "../src/Backend/WacomToolMap.vala"
		return result;
#line 1579 "WacomToolMap.c"
	} else {
		GeeHashMap* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gpointer _tmp5_;
		WacomBackendWacomTool* _tmp6_;
#line 224 "../src/Backend/WacomToolMap.vala"
		_tmp2_ = self->priv->tool_map;
#line 224 "../src/Backend/WacomToolMap.vala"
		_tmp3_ = wacom_backend_wacom_tool_map_get_tool_key (serial);
#line 224 "../src/Backend/WacomToolMap.vala"
		_tmp4_ = _tmp3_;
#line 224 "../src/Backend/WacomToolMap.vala"
		_tmp5_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp2_, _tmp4_);
#line 224 "../src/Backend/WacomToolMap.vala"
		_tmp6_ = (WacomBackendWacomTool*) _tmp5_;
#line 224 "../src/Backend/WacomToolMap.vala"
		_g_free0 (_tmp4_);
#line 224 "../src/Backend/WacomToolMap.vala"
		result = _tmp6_;
#line 224 "../src/Backend/WacomToolMap.vala"
		return result;
#line 1602 "WacomToolMap.c"
	}
}

static void
_vala_WacomError_free_function_address_of (WacomError* self)
{
#line 247 "../src/Backend/WacomToolMap.vala"
	libwacom_error_free (&self);
#line 1611 "WacomToolMap.c"
}

GeeArrayList*
wacom_backend_wacom_tool_map_list_tools (WacomBackendWacomToolMap* self,
                                         WacomBackendDevice* device)
{
	GeeArrayList* styli = NULL;
	GeeArrayList* _tmp0_;
	gchar* key = NULL;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	GeeArrayList* tablet_tools = NULL;
	GeeHashMap* _tmp6_;
	const gchar* _tmp7_;
	gpointer _tmp8_;
	GeeArrayList* _tmp9_;
	GeeHashMap* _tmp15_;
	const gchar* _tmp16_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
#line 228 "../src/Backend/WacomToolMap.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 228 "../src/Backend/WacomToolMap.vala"
	g_return_val_if_fail (device != NULL, NULL);
#line 229 "../src/Backend/WacomToolMap.vala"
	_tmp0_ = gee_array_list_new (WACOM_BACKEND_TYPE_WACOM_TOOL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 229 "../src/Backend/WacomToolMap.vala"
	styli = _tmp0_;
#line 231 "../src/Backend/WacomToolMap.vala"
	_tmp1_ = wacom_backend_device_get_vendor_id (device);
#line 231 "../src/Backend/WacomToolMap.vala"
	_tmp2_ = _tmp1_;
#line 231 "../src/Backend/WacomToolMap.vala"
	_tmp3_ = wacom_backend_device_get_product_id (device);
#line 231 "../src/Backend/WacomToolMap.vala"
	_tmp4_ = _tmp3_;
#line 231 "../src/Backend/WacomToolMap.vala"
	_tmp5_ = g_strdup_printf ("%s:%s", _tmp2_, _tmp4_);
#line 231 "../src/Backend/WacomToolMap.vala"
	key = _tmp5_;
#line 232 "../src/Backend/WacomToolMap.vala"
	_tmp6_ = self->priv->tablet_map;
#line 232 "../src/Backend/WacomToolMap.vala"
	_tmp7_ = key;
#line 232 "../src/Backend/WacomToolMap.vala"
	_tmp8_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp6_, _tmp7_);
#line 232 "../src/Backend/WacomToolMap.vala"
	tablet_tools = (GeeArrayList*) _tmp8_;
#line 233 "../src/Backend/WacomToolMap.vala"
	_tmp9_ = tablet_tools;
#line 233 "../src/Backend/WacomToolMap.vala"
	if (_tmp9_ != NULL) {
#line 1667 "WacomToolMap.c"
		GeeArrayList* _tmp10_;
		GeeHashMap* _tmp11_;
		const gchar* _tmp12_;
		gpointer _tmp13_;
		GeeArrayList* _tmp14_;
#line 234 "../src/Backend/WacomToolMap.vala"
		_tmp10_ = styli;
#line 234 "../src/Backend/WacomToolMap.vala"
		_tmp11_ = self->priv->tablet_map;
#line 234 "../src/Backend/WacomToolMap.vala"
		_tmp12_ = key;
#line 234 "../src/Backend/WacomToolMap.vala"
		_tmp13_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp11_, _tmp12_);
#line 234 "../src/Backend/WacomToolMap.vala"
		_tmp14_ = (GeeArrayList*) _tmp13_;
#line 234 "../src/Backend/WacomToolMap.vala"
		gee_array_list_add_all (_tmp10_, (GeeCollection*) _tmp14_);
#line 234 "../src/Backend/WacomToolMap.vala"
		_g_object_unref0 (_tmp14_);
#line 1687 "WacomToolMap.c"
	}
#line 237 "../src/Backend/WacomToolMap.vala"
	_tmp15_ = self->priv->no_serial_tool_map;
#line 237 "../src/Backend/WacomToolMap.vala"
	_tmp16_ = key;
#line 237 "../src/Backend/WacomToolMap.vala"
	if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp15_, _tmp16_)) {
#line 1695 "WacomToolMap.c"
		WacomBackendWacomTool* no_serial_tool = NULL;
		GeeHashMap* _tmp17_;
		const gchar* _tmp18_;
		gpointer _tmp19_;
		WacomBackendWacomTool* _tmp20_;
		GeeArrayList* _tmp50_;
		WacomBackendWacomTool* _tmp51_;
#line 238 "../src/Backend/WacomToolMap.vala"
		_tmp17_ = self->priv->no_serial_tool_map;
#line 238 "../src/Backend/WacomToolMap.vala"
		_tmp18_ = key;
#line 238 "../src/Backend/WacomToolMap.vala"
		_tmp19_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp17_, _tmp18_);
#line 238 "../src/Backend/WacomToolMap.vala"
		no_serial_tool = (WacomBackendWacomTool*) _tmp19_;
#line 239 "../src/Backend/WacomToolMap.vala"
		_tmp20_ = no_serial_tool;
#line 239 "../src/Backend/WacomToolMap.vala"
		if (_tmp20_ == NULL) {
#line 1715 "WacomToolMap.c"
			WacomDeviceDatabase* _tmp21_;
			WacomError* _error_ = NULL;
			WacomError* _tmp23_;
			WacomDevice* wacom_device = NULL;
			WacomDeviceDatabase* _tmp24_;
			const gchar* _tmp25_;
			const gchar* _tmp26_;
			WacomError* _tmp27_;
			WacomDevice* _tmp28_;
			WacomDevice* _tmp29_;
			gint id = 0;
			gint* supported_styli = NULL;
			WacomDevice* _tmp34_;
			gint _tmp35_ = 0;
			gint* _tmp36_;
			gint supported_styli_length1;
			gint _supported_styli_size_;
			gint* _tmp37_;
			gint _tmp37__length1;
			gchar* settings_path = NULL;
			const gchar* _tmp40_;
			const gchar* _tmp41_;
			const gchar* _tmp42_;
			const gchar* _tmp43_;
			gchar* _tmp44_;
			const gchar* _tmp45_;
			WacomBackendWacomTool* _tmp46_;
			GeeHashMap* _tmp47_;
			const gchar* _tmp48_;
			WacomBackendWacomTool* _tmp49_;
#line 240 "../src/Backend/WacomToolMap.vala"
			_tmp21_ = wacom_backend_wacom_tool_map_wacom_db;
#line 240 "../src/Backend/WacomToolMap.vala"
			if (_tmp21_ == NULL) {
#line 1750 "WacomToolMap.c"
				WacomDeviceDatabase* _tmp22_;
#line 241 "../src/Backend/WacomToolMap.vala"
				_tmp22_ = libwacom_database_new ();
#line 241 "../src/Backend/WacomToolMap.vala"
				_libwacom_database_destroy0 (wacom_backend_wacom_tool_map_wacom_db);
#line 241 "../src/Backend/WacomToolMap.vala"
				wacom_backend_wacom_tool_map_wacom_db = _tmp22_;
#line 1758 "WacomToolMap.c"
			}
#line 244 "../src/Backend/WacomToolMap.vala"
			_tmp23_ = libwacom_error_new ();
#line 244 "../src/Backend/WacomToolMap.vala"
			_error_ = _tmp23_;
#line 245 "../src/Backend/WacomToolMap.vala"
			_tmp24_ = wacom_backend_wacom_tool_map_wacom_db;
#line 245 "../src/Backend/WacomToolMap.vala"
			_tmp25_ = wacom_backend_device_get_device_file (device);
#line 245 "../src/Backend/WacomToolMap.vala"
			_tmp26_ = _tmp25_;
#line 245 "../src/Backend/WacomToolMap.vala"
			_tmp27_ = _error_;
#line 245 "../src/Backend/WacomToolMap.vala"
			_tmp28_ = libwacom_new_from_path (_tmp24_, _tmp26_, WFALLBACK_NONE, _tmp27_);
#line 245 "../src/Backend/WacomToolMap.vala"
			wacom_device = _tmp28_;
#line 246 "../src/Backend/WacomToolMap.vala"
			_tmp29_ = wacom_device;
#line 246 "../src/Backend/WacomToolMap.vala"
			if (_tmp29_ == NULL) {
#line 1780 "WacomToolMap.c"
				const gchar* _tmp30_ = NULL;
				WacomError* _tmp31_;
				const gchar* _tmp32_;
				GError* _tmp33_;
#line 247 "../src/Backend/WacomToolMap.vala"
				_tmp31_ = _error_;
#line 247 "../src/Backend/WacomToolMap.vala"
				_tmp32_ = libwacom_error_get_message (_tmp31_);
#line 247 "../src/Backend/WacomToolMap.vala"
				_tmp30_ = _tmp32_;
#line 247 "../src/Backend/WacomToolMap.vala"
				if (_tmp30_ == NULL) {
#line 247 "../src/Backend/WacomToolMap.vala"
					_tmp30_ = "";
#line 1795 "WacomToolMap.c"
				}
#line 247 "../src/Backend/WacomToolMap.vala"
				_tmp33_ = g_error_new_literal (WACOM_EXCEPTION, WACOM_EXCEPTION_LIBWACOM_ERROR, _tmp30_);
#line 247 "../src/Backend/WacomToolMap.vala"
				_inner_error0_ = _tmp33_;
#line 247 "../src/Backend/WacomToolMap.vala"
				_libwacom_destroy0 (wacom_device);
#line 247 "../src/Backend/WacomToolMap.vala"
				__vala_WacomError_free_function_address_of0 (_error_);
#line 247 "../src/Backend/WacomToolMap.vala"
				_g_object_unref0 (no_serial_tool);
#line 247 "../src/Backend/WacomToolMap.vala"
				_g_object_unref0 (tablet_tools);
#line 247 "../src/Backend/WacomToolMap.vala"
				_g_free0 (key);
#line 247 "../src/Backend/WacomToolMap.vala"
				_g_object_unref0 (styli);
#line 247 "../src/Backend/WacomToolMap.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 247 "../src/Backend/WacomToolMap.vala"
				g_clear_error (&_inner_error0_);
#line 247 "../src/Backend/WacomToolMap.vala"
				return NULL;
#line 1819 "WacomToolMap.c"
			}
#line 250 "../src/Backend/WacomToolMap.vala"
			id = 0;
#line 251 "../src/Backend/WacomToolMap.vala"
			_tmp34_ = wacom_device;
#line 251 "../src/Backend/WacomToolMap.vala"
			_tmp36_ = libwacom_get_supported_styli (_tmp34_, &_tmp35_);
#line 251 "../src/Backend/WacomToolMap.vala"
			supported_styli = _tmp36_;
#line 251 "../src/Backend/WacomToolMap.vala"
			supported_styli_length1 = _tmp35_;
#line 251 "../src/Backend/WacomToolMap.vala"
			_supported_styli_size_ = supported_styli_length1;
#line 252 "../src/Backend/WacomToolMap.vala"
			_tmp37_ = supported_styli;
#line 252 "../src/Backend/WacomToolMap.vala"
			_tmp37__length1 = supported_styli_length1;
#line 252 "../src/Backend/WacomToolMap.vala"
			if (_tmp37__length1 > 0) {
#line 1839 "WacomToolMap.c"
				gint* _tmp38_;
				gint _tmp38__length1;
				gint _tmp39_;
#line 253 "../src/Backend/WacomToolMap.vala"
				_tmp38_ = supported_styli;
#line 253 "../src/Backend/WacomToolMap.vala"
				_tmp38__length1 = supported_styli_length1;
#line 253 "../src/Backend/WacomToolMap.vala"
				_tmp39_ = _tmp38_[0];
#line 253 "../src/Backend/WacomToolMap.vala"
				id = _tmp39_;
#line 1851 "WacomToolMap.c"
			}
#line 256 "../src/Backend/WacomToolMap.vala"
			_tmp40_ = wacom_backend_device_get_vendor_id (device);
#line 256 "../src/Backend/WacomToolMap.vala"
			_tmp41_ = _tmp40_;
#line 256 "../src/Backend/WacomToolMap.vala"
			_tmp42_ = wacom_backend_device_get_product_id (device);
#line 256 "../src/Backend/WacomToolMap.vala"
			_tmp43_ = _tmp42_;
#line 256 "../src/Backend/WacomToolMap.vala"
			_tmp44_ = g_strdup_printf ("/org/gnome/desktop/peripherals/stylus/default-%s:%s/", _tmp41_, _tmp43_);
#line 256 "../src/Backend/WacomToolMap.vala"
			settings_path = _tmp44_;
#line 260 "../src/Backend/WacomToolMap.vala"
			_tmp45_ = settings_path;
#line 260 "../src/Backend/WacomToolMap.vala"
			_tmp46_ = wacom_backend_wacom_tool_new ((guint64) 0, (guint64) id, _tmp45_);
#line 260 "../src/Backend/WacomToolMap.vala"
			_g_object_unref0 (no_serial_tool);
#line 260 "../src/Backend/WacomToolMap.vala"
			no_serial_tool = _tmp46_;
#line 261 "../src/Backend/WacomToolMap.vala"
			_tmp47_ = self->priv->no_serial_tool_map;
#line 261 "../src/Backend/WacomToolMap.vala"
			_tmp48_ = key;
#line 261 "../src/Backend/WacomToolMap.vala"
			_tmp49_ = no_serial_tool;
#line 261 "../src/Backend/WacomToolMap.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp47_, _tmp48_, _tmp49_);
#line 239 "../src/Backend/WacomToolMap.vala"
			_g_free0 (settings_path);
#line 239 "../src/Backend/WacomToolMap.vala"
			supported_styli = (g_free (supported_styli), NULL);
#line 239 "../src/Backend/WacomToolMap.vala"
			_libwacom_destroy0 (wacom_device);
#line 239 "../src/Backend/WacomToolMap.vala"
			__vala_WacomError_free_function_address_of0 (_error_);
#line 1889 "WacomToolMap.c"
		}
#line 264 "../src/Backend/WacomToolMap.vala"
		_tmp50_ = styli;
#line 264 "../src/Backend/WacomToolMap.vala"
		_tmp51_ = no_serial_tool;
#line 264 "../src/Backend/WacomToolMap.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp50_, _tmp51_);
#line 237 "../src/Backend/WacomToolMap.vala"
		_g_object_unref0 (no_serial_tool);
#line 1899 "WacomToolMap.c"
	}
#line 267 "../src/Backend/WacomToolMap.vala"
	result = styli;
#line 267 "../src/Backend/WacomToolMap.vala"
	_g_object_unref0 (tablet_tools);
#line 267 "../src/Backend/WacomToolMap.vala"
	_g_free0 (key);
#line 267 "../src/Backend/WacomToolMap.vala"
	return result;
#line 1909 "WacomToolMap.c"
}

static void
wacom_backend_wacom_tool_map_class_init (WacomBackendWacomToolMapClass * klass,
                                         gpointer klass_data)
{
#line 20 "../src/Backend/WacomToolMap.vala"
	wacom_backend_wacom_tool_map_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/Backend/WacomToolMap.vala"
	g_type_class_adjust_private_offset (klass, &WacomBackendWacomToolMap_private_offset);
#line 20 "../src/Backend/WacomToolMap.vala"
	G_OBJECT_CLASS (klass)->finalize = wacom_backend_wacom_tool_map_finalize;
#line 1922 "WacomToolMap.c"
}

static void
wacom_backend_wacom_tool_map_instance_init (WacomBackendWacomToolMap * self,
                                            gpointer klass)
{
#line 20 "../src/Backend/WacomToolMap.vala"
	self->priv = wacom_backend_wacom_tool_map_get_instance_private (self);
#line 1931 "WacomToolMap.c"
}

static void
wacom_backend_wacom_tool_map_finalize (GObject * obj)
{
	WacomBackendWacomToolMap * self;
#line 20 "../src/Backend/WacomToolMap.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WACOM_BACKEND_TYPE_WACOM_TOOL_MAP, WacomBackendWacomToolMap);
#line 25 "../src/Backend/WacomToolMap.vala"
	_g_key_file_unref0 (self->priv->tablets);
#line 26 "../src/Backend/WacomToolMap.vala"
	_g_key_file_unref0 (self->priv->tools);
#line 28 "../src/Backend/WacomToolMap.vala"
	_g_free0 (self->priv->tablet_path);
#line 29 "../src/Backend/WacomToolMap.vala"
	_g_free0 (self->priv->tool_path);
#line 31 "../src/Backend/WacomToolMap.vala"
	_g_object_unref0 (self->priv->tablet_map);
#line 32 "../src/Backend/WacomToolMap.vala"
	_g_object_unref0 (self->priv->tool_map);
#line 33 "../src/Backend/WacomToolMap.vala"
	_g_object_unref0 (self->priv->no_serial_tool_map);
#line 20 "../src/Backend/WacomToolMap.vala"
	G_OBJECT_CLASS (wacom_backend_wacom_tool_map_parent_class)->finalize (obj);
#line 1956 "WacomToolMap.c"
}

static GType
wacom_backend_wacom_tool_map_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WacomBackendWacomToolMapClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) wacom_backend_wacom_tool_map_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WacomBackendWacomToolMap), 0, (GInstanceInitFunc) wacom_backend_wacom_tool_map_instance_init, NULL };
	GType wacom_backend_wacom_tool_map_type_id;
	wacom_backend_wacom_tool_map_type_id = g_type_register_static (G_TYPE_OBJECT, "WacomBackendWacomToolMap", &g_define_type_info, 0);
	WacomBackendWacomToolMap_private_offset = g_type_add_instance_private (wacom_backend_wacom_tool_map_type_id, sizeof (WacomBackendWacomToolMapPrivate));
	return wacom_backend_wacom_tool_map_type_id;
}

GType
wacom_backend_wacom_tool_map_get_type (void)
{
	static volatile gsize wacom_backend_wacom_tool_map_type_id__once = 0;
	if (g_once_init_enter (&wacom_backend_wacom_tool_map_type_id__once)) {
		GType wacom_backend_wacom_tool_map_type_id;
		wacom_backend_wacom_tool_map_type_id = wacom_backend_wacom_tool_map_get_type_once ();
		g_once_init_leave (&wacom_backend_wacom_tool_map_type_id__once, wacom_backend_wacom_tool_map_type_id);
	}
	return wacom_backend_wacom_tool_map_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

