/* Plug.c generated by valac 0.56.17, the Vala compiler
 * generated from Plug.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-2.0-or-later
 * SPDX-FileCopyrightText: 2019-2024 elementary, Inc. (https://elementary.io)
 */

#include "wacom.h"
#include <gtk/gtk.h>
#include <switchboard.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gee.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <adwaita.h>
#include <granite-7.h>
#include <gmodule.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	WACOM_PLUG_0_PROPERTY,
	WACOM_PLUG_NUM_PROPERTIES
};
static GParamSpec* wacom_plug_properties[WACOM_PLUG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _WacomPlugSearchData WacomPlugSearchData;

struct _WacomPlugPrivate {
	GtkBox* box;
};

struct _WacomPlugSearchData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	WacomPlug* self;
	gchar* search;
	GeeTreeMap* result;
	GeeTreeMap* search_results;
	GCompareFunc _tmp0_;
	GEqualFunc _tmp1_;
	GeeTreeMap* _tmp2_;
};

static gint WacomPlug_private_offset;
static gpointer wacom_plug_parent_class = NULL;

static GtkWidget* wacom_plug_real_get_widget (SwitchboardPlug* base);
static void wacom_plug_real_shown (SwitchboardPlug* base);
static void wacom_plug_real_hidden (SwitchboardPlug* base);
static void wacom_plug_real_search_callback (SwitchboardPlug* base,
                                      const gchar* location);
static void wacom_plug_real_search_data_free (gpointer _data);
static void wacom_plug_real_search (SwitchboardPlug* base,
                             const gchar* search,
                             GAsyncReadyCallback _callback_,
                             gpointer _user_data_);
static gboolean wacom_plug_real_search_co (WacomPlugSearchData* _data_);
static void wacom_plug_finalize (GObject * obj);
static GType wacom_plug_get_type_once (void);

static inline gpointer
wacom_plug_get_instance_private (WacomPlug* self)
{
	return G_STRUCT_MEMBER_P (self, WacomPlug_private_offset);
}

WacomPlug*
wacom_plug_construct (GType object_type)
{
	WacomPlug * self = NULL;
	GeeTreeMap* settings = NULL;
	GeeTreeMap* _tmp0_;
#line 10 "../src/Plug.vala"
	bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
#line 11 "../src/Plug.vala"
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
#line 13 "../src/Plug.vala"
	_tmp0_ = gee_tree_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 13 "../src/Plug.vala"
	settings = _tmp0_;
#line 14 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) settings, "input/pointing/stylus", "general");
#line 16 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) settings, "input/wacom", "general");
#line 18 "../src/Plug.vala"
	self = (WacomPlug*) g_object_new (object_type, "category", SWITCHBOARD_PLUG_CATEGORY_HARDWARE, "code-name", "pantheon-wacom", "display-name", _ ("Wacom"), "description", _ ("Configure Wacom tablet"), "icon", "input-tablet", "supported-settings", settings, NULL);
#line 9 "../src/Plug.vala"
	_g_object_unref0 (settings);
#line 9 "../src/Plug.vala"
	return self;
#line 107 "Plug.c"
}

WacomPlug*
wacom_plug_new (void)
{
#line 9 "../src/Plug.vala"
	return wacom_plug_construct (WACOM_TYPE_PLUG);
#line 115 "Plug.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 45 "../src/Plug.vala"
	return self ? g_object_ref (self) : NULL;
#line 123 "Plug.c"
}

static GtkWidget*
wacom_plug_real_get_widget (SwitchboardPlug* base)
{
	WacomPlug * self;
	GtkBox* _tmp0_;
	GtkBox* _tmp9_;
	GtkWidget* _tmp10_;
	GtkWidget* result;
#line 28 "../src/Plug.vala"
	self = (WacomPlug*) base;
#line 29 "../src/Plug.vala"
	_tmp0_ = self->priv->box;
#line 29 "../src/Plug.vala"
	if (_tmp0_ == NULL) {
#line 140 "Plug.c"
		AdwHeaderBar* headerbar = NULL;
		AdwHeaderBar* _tmp1_ = NULL;
		AdwHeaderBar* _tmp2_;
		WacomMainPage* main_page = NULL;
		WacomMainPage* _tmp3_ = NULL;
		GtkBox* _tmp4_;
		GtkBox* _tmp5_;
		AdwHeaderBar* _tmp6_;
		GtkBox* _tmp7_;
		WacomMainPage* _tmp8_;
#line 30 "../src/Plug.vala"
		_tmp1_ = (AdwHeaderBar*) adw_header_bar_new ();
#line 30 "../src/Plug.vala"
		adw_header_bar_set_show_title (_tmp1_, FALSE);
#line 30 "../src/Plug.vala"
		g_object_ref_sink (_tmp1_);
#line 30 "../src/Plug.vala"
		headerbar = _tmp1_;
#line 33 "../src/Plug.vala"
		_tmp2_ = headerbar;
#line 33 "../src/Plug.vala"
		gtk_widget_add_css_class ((GtkWidget*) _tmp2_, GRANITE_STYLE_CLASS_FLAT);
#line 35 "../src/Plug.vala"
		_tmp3_ = wacom_main_page_new ();
#line 35 "../src/Plug.vala"
		gtk_widget_set_vexpand ((GtkWidget*) _tmp3_, TRUE);
#line 35 "../src/Plug.vala"
		g_object_ref_sink (_tmp3_);
#line 35 "../src/Plug.vala"
		main_page = _tmp3_;
#line 39 "../src/Plug.vala"
		_tmp4_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 39 "../src/Plug.vala"
		g_object_ref_sink (_tmp4_);
#line 39 "../src/Plug.vala"
		_g_object_unref0 (self->priv->box);
#line 39 "../src/Plug.vala"
		self->priv->box = _tmp4_;
#line 40 "../src/Plug.vala"
		_tmp5_ = self->priv->box;
#line 40 "../src/Plug.vala"
		_tmp6_ = headerbar;
#line 40 "../src/Plug.vala"
		gtk_box_append (_tmp5_, (GtkWidget*) _tmp6_);
#line 41 "../src/Plug.vala"
		_tmp7_ = self->priv->box;
#line 41 "../src/Plug.vala"
		_tmp8_ = main_page;
#line 41 "../src/Plug.vala"
		gtk_box_append (_tmp7_, (GtkWidget*) _tmp8_);
#line 29 "../src/Plug.vala"
		_g_object_unref0 (main_page);
#line 29 "../src/Plug.vala"
		_g_object_unref0 (headerbar);
#line 195 "Plug.c"
	}
#line 45 "../src/Plug.vala"
	_tmp9_ = self->priv->box;
#line 45 "../src/Plug.vala"
	_tmp10_ = _g_object_ref0 ((GtkWidget*) _tmp9_);
#line 45 "../src/Plug.vala"
	result = _tmp10_;
#line 45 "../src/Plug.vala"
	return result;
#line 205 "Plug.c"
}

static void
wacom_plug_real_shown (SwitchboardPlug* base)
{
	WacomPlug * self;
#line 48 "../src/Plug.vala"
	self = (WacomPlug*) base;
#line 214 "Plug.c"
}

static void
wacom_plug_real_hidden (SwitchboardPlug* base)
{
	WacomPlug * self;
#line 51 "../src/Plug.vala"
	self = (WacomPlug*) base;
#line 223 "Plug.c"
}

static void
wacom_plug_real_search_callback (SwitchboardPlug* base,
                                 const gchar* location)
{
	WacomPlug * self;
#line 54 "../src/Plug.vala"
	self = (WacomPlug*) base;
#line 54 "../src/Plug.vala"
	g_return_if_fail (location != NULL);
#line 235 "Plug.c"
}

static void
wacom_plug_real_search_data_free (gpointer _data)
{
	WacomPlugSearchData* _data_;
	_data_ = _data;
#line 6 "../src/Plug.vala"
	_g_free0 (_data_->search);
#line 6 "../src/Plug.vala"
	_g_object_unref0 (_data_->result);
#line 6 "../src/Plug.vala"
	_g_object_unref0 (_data_->self);
#line 6 "../src/Plug.vala"
	g_slice_free (WacomPlugSearchData, _data_);
#line 251 "Plug.c"
}

static void
wacom_plug_real_search (SwitchboardPlug* base,
                        const gchar* search,
                        GAsyncReadyCallback _callback_,
                        gpointer _user_data_)
{
	WacomPlug * self;
	WacomPlugSearchData* _data_;
	WacomPlug* _tmp0_;
	gchar* _tmp1_;
#line 6 "../src/Plug.vala"
	g_return_if_fail (search != NULL);
#line 6 "../src/Plug.vala"
	self = (WacomPlug*) base;
#line 6 "../src/Plug.vala"
	_data_ = g_slice_new0 (WacomPlugSearchData);
#line 6 "../src/Plug.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 6 "../src/Plug.vala"
	g_task_set_task_data (_data_->_async_result, _data_, wacom_plug_real_search_data_free);
#line 6 "../src/Plug.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 6 "../src/Plug.vala"
	_data_->self = _tmp0_;
#line 6 "../src/Plug.vala"
	_tmp1_ = g_strdup (search);
#line 6 "../src/Plug.vala"
	_g_free0 (_data_->search);
#line 6 "../src/Plug.vala"
	_data_->search = _tmp1_;
#line 6 "../src/Plug.vala"
	wacom_plug_real_search_co (_data_);
#line 286 "Plug.c"
}

static GeeTreeMap*
wacom_plug_search_finish (SwitchboardPlug* base,
                          GAsyncResult* _res_)
{
	GeeTreeMap* result;
	WacomPlugSearchData* _data_;
#line 6 "../src/Plug.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 6 "../src/Plug.vala"
	result = _data_->result;
#line 6 "../src/Plug.vala"
	_data_->result = NULL;
#line 6 "../src/Plug.vala"
	return result;
#line 303 "Plug.c"
}

static gboolean
wacom_plug_real_search_co (WacomPlugSearchData* _data_)
{
#line 58 "../src/Plug.vala"
	switch (_data_->_state_) {
#line 58 "../src/Plug.vala"
		case 0:
#line 313 "Plug.c"
		goto _state_0;
		default:
#line 58 "../src/Plug.vala"
		g_assert_not_reached ();
#line 318 "Plug.c"
	}
	_state_0:
#line 59 "../src/Plug.vala"
	_data_->_tmp0_ = ((GCompareFunc) g_strcmp0);
#line 59 "../src/Plug.vala"
	_data_->_tmp1_ = g_str_equal;
#line 59 "../src/Plug.vala"
	_data_->_tmp2_ = gee_tree_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, (GCompareDataFunc) _data_->_tmp0_, NULL, NULL, (GeeEqualDataFunc) _data_->_tmp1_, NULL, NULL);
#line 59 "../src/Plug.vala"
	_data_->search_results = _data_->_tmp2_;
#line 63 "../src/Plug.vala"
	_data_->result = _data_->search_results;
#line 63 "../src/Plug.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 63 "../src/Plug.vala"
	if (_data_->_state_ != 0) {
#line 63 "../src/Plug.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 63 "../src/Plug.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 339 "Plug.c"
		}
	}
#line 63 "../src/Plug.vala"
	g_object_unref (_data_->_async_result);
#line 63 "../src/Plug.vala"
	return FALSE;
#line 346 "Plug.c"
}

static void
wacom_plug_class_init (WacomPlugClass * klass,
                       gpointer klass_data)
{
#line 6 "../src/Plug.vala"
	wacom_plug_parent_class = g_type_class_peek_parent (klass);
#line 6 "../src/Plug.vala"
	g_type_class_adjust_private_offset (klass, &WacomPlug_private_offset);
#line 6 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->get_widget = (GtkWidget* (*) (SwitchboardPlug*)) wacom_plug_real_get_widget;
#line 6 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->shown = (void (*) (SwitchboardPlug*)) wacom_plug_real_shown;
#line 6 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->hidden = (void (*) (SwitchboardPlug*)) wacom_plug_real_hidden;
#line 6 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->search_callback = (void (*) (SwitchboardPlug*, const gchar*)) wacom_plug_real_search_callback;
#line 6 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->search = (void (*) (SwitchboardPlug*, const gchar*, GAsyncReadyCallback, gpointer)) wacom_plug_real_search;
#line 6 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->search_finish = (GeeTreeMap* (*) (SwitchboardPlug*, GAsyncResult*)) wacom_plug_search_finish;
#line 6 "../src/Plug.vala"
	G_OBJECT_CLASS (klass)->finalize = wacom_plug_finalize;
#line 371 "Plug.c"
}

static void
wacom_plug_instance_init (WacomPlug * self,
                          gpointer klass)
{
#line 6 "../src/Plug.vala"
	self->priv = wacom_plug_get_instance_private (self);
#line 380 "Plug.c"
}

static void
wacom_plug_finalize (GObject * obj)
{
	WacomPlug * self;
#line 6 "../src/Plug.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WACOM_TYPE_PLUG, WacomPlug);
#line 7 "../src/Plug.vala"
	_g_object_unref0 (self->priv->box);
#line 6 "../src/Plug.vala"
	G_OBJECT_CLASS (wacom_plug_parent_class)->finalize (obj);
#line 393 "Plug.c"
}

static GType
wacom_plug_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WacomPlugClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) wacom_plug_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WacomPlug), 0, (GInstanceInitFunc) wacom_plug_instance_init, NULL };
	GType wacom_plug_type_id;
	wacom_plug_type_id = g_type_register_static (SWITCHBOARD_TYPE_PLUG, "WacomPlug", &g_define_type_info, 0);
	WacomPlug_private_offset = g_type_add_instance_private (wacom_plug_type_id, sizeof (WacomPlugPrivate));
	return wacom_plug_type_id;
}

GType
wacom_plug_get_type (void)
{
	static volatile gsize wacom_plug_type_id__once = 0;
	if (g_once_init_enter (&wacom_plug_type_id__once)) {
		GType wacom_plug_type_id;
		wacom_plug_type_id = wacom_plug_get_type_once ();
		g_once_init_leave (&wacom_plug_type_id__once, wacom_plug_type_id);
	}
	return wacom_plug_type_id__once;
}

SwitchboardPlug*
get_plug (GModule* module)
{
	WacomPlug* _tmp0_;
	SwitchboardPlug* result;
#line 67 "../src/Plug.vala"
	g_return_val_if_fail (module != NULL, NULL);
#line 68 "../src/Plug.vala"
	g_debug ("Plug.vala:68: Activating Wacom plug");
#line 69 "../src/Plug.vala"
	_tmp0_ = wacom_plug_new ();
#line 69 "../src/Plug.vala"
	result = (SwitchboardPlug*) _tmp0_;
#line 69 "../src/Plug.vala"
	return result;
#line 433 "Plug.c"
}

