/* StylusView.c generated by valac 0.56.17, the Vala compiler
 * generated from StylusView.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-2.0-or-later
 * SPDX-FileCopyrightText: 2019-2024 elementary, Inc. (https://elementary.io)
 */

#include "wacom.h"
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <libwacom/libwacom.h>
#include <granite-7.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <glib-object.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	WACOM_STYLUS_VIEW_0_PROPERTY,
	WACOM_STYLUS_VIEW_NUM_PROPERTIES
};
static GParamSpec* wacom_stylus_view_properties[WACOM_STYLUS_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block1Data Block1Data;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block2Data Block2Data;
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _libwacom_database_destroy0(var) ((var == NULL) ? NULL : (var = (libwacom_database_destroy (var), NULL)))

struct _WacomStylusViewPrivate {
	GSettings* settings;
	GtkBox* stylus_box;
};

struct _Block1Data {
	int _ref_count_;
	WacomStylusView* self;
	WacomWidgetsDrawingArea* test_area;
	GraniteDialog* test_dialog;
};

struct _Block2Data {
	int _ref_count_;
	WacomStylusView* self;
	GtkScale* scale;
	gchar* schema_key;
};

static gint WacomStylusView_private_offset;
static gpointer wacom_stylus_view_parent_class = NULL;
static GtkSizeGroup* wacom_stylus_view_label_sizegroup;
static GtkSizeGroup* wacom_stylus_view_label_sizegroup = NULL;
static WacomDeviceDatabase* wacom_stylus_view_wacom_db;
static WacomDeviceDatabase* wacom_stylus_view_wacom_db = NULL;

static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static GtkBox* wacom_stylus_view_pressure_setting (WacomStylusView* self,
                                            const gchar* label,
                                            const gchar* schema_key);
static GtkBox* wacom_stylus_view_button_setting (WacomStylusView* self,
                                          const gchar* label,
                                          const gchar* schema_key);
static void __lambda7_ (Block1Data* _data1_);
static void ___lambda7__gtk_button_clicked (GtkButton* _sender,
                                     gpointer self);
static void __lambda8_ (Block1Data* _data1_);
static void ___lambda8__gtk_dialog_response (GtkDialog* _sender,
                                      gint response_id,
                                      gpointer self);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void wacom_stylus_view_set_pressure_scale_value_from_settings (WacomStylusView* self,
                                                               GtkScale* scale,
                                                               const gchar* schema_key);
static void __lambda6_ (Block2Data* _data2_);
static void wacom_stylus_view_on_pressure_value_changed (WacomStylusView* self,
                                                  gint new_value,
                                                  const gchar* schema_key);
static void ___lambda6__gtk_range_value_changed (GtkRange* _sender,
                                          gpointer self);
static GObject * wacom_stylus_view_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties);
static void wacom_stylus_view_finalize (GObject * obj);
static GType wacom_stylus_view_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static const gint32 WACOM_STYLUS_VIEW_PRESSURE_CURVES[7][4] = {{(gint32) 0, (gint32) 75, (gint32) 25, (gint32) 100}, {(gint32) 0, (gint32) 50, (gint32) 50, (gint32) 100}, {(gint32) 0, (gint32) 25, (gint32) 75, (gint32) 100}, {(gint32) 0, (gint32) 0, (gint32) 100, (gint32) 100}, {(gint32) 25, (gint32) 0, (gint32) 100, (gint32) 75}, {(gint32) 50, (gint32) 0, (gint32) 100, (gint32) 50}, {(gint32) 75, (gint32) 0, (gint32) 100, (gint32) 25}};

static inline gpointer
wacom_stylus_view_get_instance_private (WacomStylusView* self)
{
	return G_STRUCT_MEMBER_P (self, WacomStylusView_private_offset);
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 34 "../src/Views/StylusView.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 34 "../src/Views/StylusView.vala"
	return _data1_;
#line 123 "StylusView.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 34 "../src/Views/StylusView.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 133 "StylusView.c"
		WacomStylusView* self;
#line 34 "../src/Views/StylusView.vala"
		self = _data1_->self;
#line 34 "../src/Views/StylusView.vala"
		_g_object_unref0 (_data1_->test_dialog);
#line 34 "../src/Views/StylusView.vala"
		_g_object_unref0 (_data1_->test_area);
#line 34 "../src/Views/StylusView.vala"
		_g_object_unref0 (self);
#line 34 "../src/Views/StylusView.vala"
		g_slice_free (Block1Data, _data1_);
#line 145 "StylusView.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 53 "../src/Views/StylusView.vala"
	return self ? g_object_ref (self) : NULL;
#line 154 "StylusView.c"
}

static gboolean
_vala_libwacom_stylus_has_eraser (WacomStylus* self)
{
	gboolean result;
#line 199 "libwacom.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 200 "libwacom.vapi"
	result = libwacom_stylus_has_eraser (self) != 0;
#line 200 "libwacom.vapi"
	return result;
#line 167 "StylusView.c"
}

static void
__lambda7_ (Block1Data* _data1_)
{
	WacomStylusView* self;
	WacomWidgetsDrawingArea* _tmp0_;
	GraniteDialog* _tmp1_;
#line 98 "../src/Views/StylusView.vala"
	self = _data1_->self;
#line 99 "../src/Views/StylusView.vala"
	_tmp0_ = _data1_->test_area;
#line 99 "../src/Views/StylusView.vala"
	wacom_widgets_drawing_area_clear (_tmp0_);
#line 100 "../src/Views/StylusView.vala"
	_tmp1_ = _data1_->test_dialog;
#line 100 "../src/Views/StylusView.vala"
	gtk_window_present ((GtkWindow*) _tmp1_);
#line 186 "StylusView.c"
}

static void
___lambda7__gtk_button_clicked (GtkButton* _sender,
                                gpointer self)
{
#line 98 "../src/Views/StylusView.vala"
	__lambda7_ (self);
#line 195 "StylusView.c"
}

static void
__lambda8_ (Block1Data* _data1_)
{
	WacomStylusView* self;
	GraniteDialog* _tmp0_;
#line 103 "../src/Views/StylusView.vala"
	self = _data1_->self;
#line 103 "../src/Views/StylusView.vala"
	_tmp0_ = _data1_->test_dialog;
#line 103 "../src/Views/StylusView.vala"
	gtk_widget_hide ((GtkWidget*) _tmp0_);
#line 209 "StylusView.c"
}

static void
___lambda8__gtk_dialog_response (GtkDialog* _sender,
                                 gint response_id,
                                 gpointer self)
{
#line 103 "../src/Views/StylusView.vala"
	__lambda8_ (self);
#line 219 "StylusView.c"
}

void
wacom_stylus_view_set_device (WacomStylusView* self,
                              WacomBackendWacomTool* wacom_tool)
{
	Block1Data* _data1_;
	WacomStylus* stylus = NULL;
	WacomDeviceDatabase* _tmp5_;
	guint64 _tmp6_;
	guint64 _tmp7_;
	WacomStylus* _tmp8_;
	GraniteHeaderLabel* header_label = NULL;
	WacomStylus* _tmp9_;
	const gchar* _tmp10_;
	GraniteHeaderLabel* _tmp11_ = NULL;
	GtkButton* test_button = NULL;
	GtkButton* _tmp12_;
	WacomWidgetsDrawingArea* _tmp13_ = NULL;
	WacomWidgetsDrawingArea* _tmp14_;
	GApplication* _tmp15_;
	GtkWindow* _tmp16_;
	GtkWindow* _tmp17_;
	GtkWindow* _tmp18_;
	GraniteDialog* _tmp19_ = NULL;
	GraniteDialog* _tmp20_;
	GtkBox* _tmp21_;
	WacomWidgetsDrawingArea* _tmp22_;
	GraniteDialog* _tmp23_;
	GtkBox* header_box = NULL;
	GtkBox* _tmp24_;
	GtkBox* _tmp25_;
	GraniteHeaderLabel* _tmp26_;
	GtkBox* _tmp27_;
	GtkButton* _tmp28_;
	GtkBox* _tmp29_;
	GtkBox* _tmp30_;
	const gchar* _tmp31_;
	const gchar* _tmp32_;
	GSettings* _tmp33_;
	gboolean has_pressure_detection = FALSE;
	WacomStylus* _tmp34_;
	gboolean _tmp35_ = FALSE;
	WacomStylus* _tmp40_;
	GtkButton* _tmp62_;
	GraniteDialog* _tmp63_;
#line 34 "../src/Views/StylusView.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/Views/StylusView.vala"
	g_return_if_fail (wacom_tool != NULL);
#line 34 "../src/Views/StylusView.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 34 "../src/Views/StylusView.vala"
	_data1_->_ref_count_ = 1;
#line 34 "../src/Views/StylusView.vala"
	_data1_->self = g_object_ref (self);
#line 35 "../src/Views/StylusView.vala"
	while (TRUE) {
#line 278 "StylusView.c"
		GtkBox* _tmp0_;
		GtkWidget* _tmp1_;
		GtkBox* _tmp2_;
		GtkBox* _tmp3_;
		GtkWidget* _tmp4_;
#line 35 "../src/Views/StylusView.vala"
		_tmp0_ = self->priv->stylus_box;
#line 35 "../src/Views/StylusView.vala"
		_tmp1_ = gtk_widget_get_first_child ((GtkWidget*) _tmp0_);
#line 35 "../src/Views/StylusView.vala"
		if (!(_tmp1_ != NULL)) {
#line 35 "../src/Views/StylusView.vala"
			break;
#line 292 "StylusView.c"
		}
#line 36 "../src/Views/StylusView.vala"
		_tmp2_ = self->priv->stylus_box;
#line 36 "../src/Views/StylusView.vala"
		_tmp3_ = self->priv->stylus_box;
#line 36 "../src/Views/StylusView.vala"
		_tmp4_ = gtk_widget_get_first_child ((GtkWidget*) _tmp3_);
#line 36 "../src/Views/StylusView.vala"
		gtk_box_remove (_tmp2_, _tmp4_);
#line 302 "StylusView.c"
	}
#line 39 "../src/Views/StylusView.vala"
	_tmp5_ = wacom_stylus_view_wacom_db;
#line 39 "../src/Views/StylusView.vala"
	_tmp6_ = wacom_backend_wacom_tool_get_id (wacom_tool);
#line 39 "../src/Views/StylusView.vala"
	_tmp7_ = _tmp6_;
#line 39 "../src/Views/StylusView.vala"
	_tmp8_ = libwacom_stylus_get_for_id (_tmp5_, (gint) _tmp7_);
#line 39 "../src/Views/StylusView.vala"
	stylus = _tmp8_;
#line 41 "../src/Views/StylusView.vala"
	_tmp9_ = stylus;
#line 41 "../src/Views/StylusView.vala"
	_tmp10_ = libwacom_stylus_get_name (_tmp9_);
#line 41 "../src/Views/StylusView.vala"
	_tmp11_ = granite_header_label_new (_tmp10_);
#line 41 "../src/Views/StylusView.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp11_, TRUE);
#line 41 "../src/Views/StylusView.vala"
	g_object_ref_sink (_tmp11_);
#line 41 "../src/Views/StylusView.vala"
	header_label = _tmp11_;
#line 45 "../src/Views/StylusView.vala"
	_tmp12_ = (GtkButton*) gtk_button_new_with_label (_ ("Test Settings"));
#line 45 "../src/Views/StylusView.vala"
	g_object_ref_sink (_tmp12_);
#line 45 "../src/Views/StylusView.vala"
	test_button = _tmp12_;
#line 47 "../src/Views/StylusView.vala"
	_tmp13_ = wacom_widgets_drawing_area_new ();
#line 47 "../src/Views/StylusView.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp13_, TRUE);
#line 47 "../src/Views/StylusView.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp13_, TRUE);
#line 47 "../src/Views/StylusView.vala"
	g_object_ref_sink (_tmp13_);
#line 47 "../src/Views/StylusView.vala"
	_data1_->test_area = _tmp13_;
#line 51 "../src/Views/StylusView.vala"
	_tmp14_ = _data1_->test_area;
#line 51 "../src/Views/StylusView.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp14_, GRANITE_STYLE_CLASS_FRAME);
#line 53 "../src/Views/StylusView.vala"
	_tmp15_ = g_application_get_default ();
#line 53 "../src/Views/StylusView.vala"
	_tmp16_ = gtk_application_get_active_window (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, gtk_application_get_type (), GtkApplication));
#line 53 "../src/Views/StylusView.vala"
	_tmp17_ = _tmp16_;
#line 53 "../src/Views/StylusView.vala"
	_tmp18_ = _g_object_ref0 (_tmp17_);
#line 53 "../src/Views/StylusView.vala"
	_tmp19_ = granite_dialog_new ();
#line 53 "../src/Views/StylusView.vala"
	g_object_set ((GtkWindow*) _tmp19_, "default-width", 500, NULL);
#line 53 "../src/Views/StylusView.vala"
	g_object_set ((GtkWindow*) _tmp19_, "default-height", 400, NULL);
#line 53 "../src/Views/StylusView.vala"
	gtk_window_set_modal ((GtkWindow*) _tmp19_, TRUE);
#line 53 "../src/Views/StylusView.vala"
	gtk_window_set_transient_for ((GtkWindow*) _tmp19_, _tmp18_);
#line 53 "../src/Views/StylusView.vala"
	_g_object_unref0 (_tmp18_);
#line 53 "../src/Views/StylusView.vala"
	g_object_ref_sink (_tmp19_);
#line 53 "../src/Views/StylusView.vala"
	_data1_->test_dialog = _tmp19_;
#line 59 "../src/Views/StylusView.vala"
	_tmp20_ = _data1_->test_dialog;
#line 59 "../src/Views/StylusView.vala"
	_tmp21_ = gtk_dialog_get_content_area ((GtkDialog*) _tmp20_);
#line 59 "../src/Views/StylusView.vala"
	_tmp22_ = _data1_->test_area;
#line 59 "../src/Views/StylusView.vala"
	gtk_box_append (_tmp21_, (GtkWidget*) _tmp22_);
#line 60 "../src/Views/StylusView.vala"
	_tmp23_ = _data1_->test_dialog;
#line 60 "../src/Views/StylusView.vala"
	granite_dialog_add_button (_tmp23_, "Close", (gint) GTK_RESPONSE_CLOSE);
#line 62 "../src/Views/StylusView.vala"
	_tmp24_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 12);
#line 62 "../src/Views/StylusView.vala"
	g_object_ref_sink (_tmp24_);
#line 62 "../src/Views/StylusView.vala"
	header_box = _tmp24_;
#line 63 "../src/Views/StylusView.vala"
	_tmp25_ = header_box;
#line 63 "../src/Views/StylusView.vala"
	_tmp26_ = header_label;
#line 63 "../src/Views/StylusView.vala"
	gtk_box_append (_tmp25_, (GtkWidget*) _tmp26_);
#line 64 "../src/Views/StylusView.vala"
	_tmp27_ = header_box;
#line 64 "../src/Views/StylusView.vala"
	_tmp28_ = test_button;
#line 64 "../src/Views/StylusView.vala"
	gtk_box_append (_tmp27_, (GtkWidget*) _tmp28_);
#line 66 "../src/Views/StylusView.vala"
	_tmp29_ = self->priv->stylus_box;
#line 66 "../src/Views/StylusView.vala"
	_tmp30_ = header_box;
#line 66 "../src/Views/StylusView.vala"
	gtk_box_append (_tmp29_, (GtkWidget*) _tmp30_);
#line 68 "../src/Views/StylusView.vala"
	_tmp31_ = wacom_backend_wacom_tool_get_settings_path (wacom_tool);
#line 68 "../src/Views/StylusView.vala"
	_tmp32_ = _tmp31_;
#line 68 "../src/Views/StylusView.vala"
	_tmp33_ = g_settings_new_with_path ("org.gnome.desktop.peripherals.tablet.stylus", _tmp32_);
#line 68 "../src/Views/StylusView.vala"
	_g_object_unref0 (self->priv->settings);
#line 68 "../src/Views/StylusView.vala"
	self->priv->settings = _tmp33_;
#line 73 "../src/Views/StylusView.vala"
	_tmp34_ = stylus;
#line 73 "../src/Views/StylusView.vala"
	has_pressure_detection = (libwacom_stylus_get_axes (_tmp34_) & WACOM_AXIS_TYPE_PRESSURE) == WACOM_AXIS_TYPE_PRESSURE;
#line 75 "../src/Views/StylusView.vala"
	if (has_pressure_detection) {
#line 422 "StylusView.c"
		WacomStylus* _tmp36_;
#line 75 "../src/Views/StylusView.vala"
		_tmp36_ = stylus;
#line 75 "../src/Views/StylusView.vala"
		_tmp35_ = _vala_libwacom_stylus_has_eraser (_tmp36_);
#line 428 "StylusView.c"
	} else {
#line 75 "../src/Views/StylusView.vala"
		_tmp35_ = FALSE;
#line 432 "StylusView.c"
	}
#line 75 "../src/Views/StylusView.vala"
	if (_tmp35_) {
#line 436 "StylusView.c"
		GtkBox* _tmp37_;
		GtkBox* _tmp38_;
		GtkBox* _tmp39_;
#line 76 "../src/Views/StylusView.vala"
		_tmp37_ = self->priv->stylus_box;
#line 76 "../src/Views/StylusView.vala"
		_tmp38_ = wacom_stylus_view_pressure_setting (self, _ ("Eraser Pressure Feel"), "eraser-pressure-curve");
#line 76 "../src/Views/StylusView.vala"
		_tmp39_ = _tmp38_;
#line 76 "../src/Views/StylusView.vala"
		gtk_box_append (_tmp37_, (GtkWidget*) _tmp39_);
#line 76 "../src/Views/StylusView.vala"
		_g_object_unref0 (_tmp39_);
#line 450 "StylusView.c"
	}
#line 79 "../src/Views/StylusView.vala"
	_tmp40_ = stylus;
#line 79 "../src/Views/StylusView.vala"
	switch (libwacom_stylus_get_num_buttons (_tmp40_)) {
#line 79 "../src/Views/StylusView.vala"
		case 1:
#line 458 "StylusView.c"
		{
			GtkBox* _tmp41_;
			GtkBox* _tmp42_;
			GtkBox* _tmp43_;
#line 81 "../src/Views/StylusView.vala"
			_tmp41_ = self->priv->stylus_box;
#line 81 "../src/Views/StylusView.vala"
			_tmp42_ = wacom_stylus_view_button_setting (self, _ ("Button Action"), "button-action");
#line 81 "../src/Views/StylusView.vala"
			_tmp43_ = _tmp42_;
#line 81 "../src/Views/StylusView.vala"
			gtk_box_append (_tmp41_, (GtkWidget*) _tmp43_);
#line 81 "../src/Views/StylusView.vala"
			_g_object_unref0 (_tmp43_);
#line 82 "../src/Views/StylusView.vala"
			break;
#line 475 "StylusView.c"
		}
#line 79 "../src/Views/StylusView.vala"
		case 2:
#line 479 "StylusView.c"
		{
			GtkBox* _tmp44_;
			GtkBox* _tmp45_;
			GtkBox* _tmp46_;
			GtkBox* _tmp47_;
			GtkBox* _tmp48_;
			GtkBox* _tmp49_;
#line 84 "../src/Views/StylusView.vala"
			_tmp44_ = self->priv->stylus_box;
#line 84 "../src/Views/StylusView.vala"
			_tmp45_ = wacom_stylus_view_button_setting (self, _ ("Top Button Action"), "secondary-button-action");
#line 84 "../src/Views/StylusView.vala"
			_tmp46_ = _tmp45_;
#line 84 "../src/Views/StylusView.vala"
			gtk_box_append (_tmp44_, (GtkWidget*) _tmp46_);
#line 84 "../src/Views/StylusView.vala"
			_g_object_unref0 (_tmp46_);
#line 85 "../src/Views/StylusView.vala"
			_tmp47_ = self->priv->stylus_box;
#line 85 "../src/Views/StylusView.vala"
			_tmp48_ = wacom_stylus_view_button_setting (self, _ ("Bottom Button Action"), "button-action");
#line 85 "../src/Views/StylusView.vala"
			_tmp49_ = _tmp48_;
#line 85 "../src/Views/StylusView.vala"
			gtk_box_append (_tmp47_, (GtkWidget*) _tmp49_);
#line 85 "../src/Views/StylusView.vala"
			_g_object_unref0 (_tmp49_);
#line 86 "../src/Views/StylusView.vala"
			break;
#line 509 "StylusView.c"
		}
#line 79 "../src/Views/StylusView.vala"
		case 3:
#line 513 "StylusView.c"
		{
			GtkBox* _tmp50_;
			GtkBox* _tmp51_;
			GtkBox* _tmp52_;
			GtkBox* _tmp53_;
			GtkBox* _tmp54_;
			GtkBox* _tmp55_;
			GtkBox* _tmp56_;
			GtkBox* _tmp57_;
			GtkBox* _tmp58_;
#line 88 "../src/Views/StylusView.vala"
			_tmp50_ = self->priv->stylus_box;
#line 88 "../src/Views/StylusView.vala"
			_tmp51_ = wacom_stylus_view_button_setting (self, _ ("Top Button Action"), "secondary-button-action");
#line 88 "../src/Views/StylusView.vala"
			_tmp52_ = _tmp51_;
#line 88 "../src/Views/StylusView.vala"
			gtk_box_append (_tmp50_, (GtkWidget*) _tmp52_);
#line 88 "../src/Views/StylusView.vala"
			_g_object_unref0 (_tmp52_);
#line 89 "../src/Views/StylusView.vala"
			_tmp53_ = self->priv->stylus_box;
#line 89 "../src/Views/StylusView.vala"
			_tmp54_ = wacom_stylus_view_button_setting (self, _ ("Middle Button Action"), "button-action");
#line 89 "../src/Views/StylusView.vala"
			_tmp55_ = _tmp54_;
#line 89 "../src/Views/StylusView.vala"
			gtk_box_append (_tmp53_, (GtkWidget*) _tmp55_);
#line 89 "../src/Views/StylusView.vala"
			_g_object_unref0 (_tmp55_);
#line 90 "../src/Views/StylusView.vala"
			_tmp56_ = self->priv->stylus_box;
#line 90 "../src/Views/StylusView.vala"
			_tmp57_ = wacom_stylus_view_button_setting (self, _ ("Bottom Button Action"), "tertiary-button-action");
#line 90 "../src/Views/StylusView.vala"
			_tmp58_ = _tmp57_;
#line 90 "../src/Views/StylusView.vala"
			gtk_box_append (_tmp56_, (GtkWidget*) _tmp58_);
#line 90 "../src/Views/StylusView.vala"
			_g_object_unref0 (_tmp58_);
#line 91 "../src/Views/StylusView.vala"
			break;
#line 556 "StylusView.c"
		}
		default:
#line 79 "../src/Views/StylusView.vala"
		break;
#line 561 "StylusView.c"
	}
#line 94 "../src/Views/StylusView.vala"
	if (has_pressure_detection) {
#line 565 "StylusView.c"
		GtkBox* _tmp59_;
		GtkBox* _tmp60_;
		GtkBox* _tmp61_;
#line 95 "../src/Views/StylusView.vala"
		_tmp59_ = self->priv->stylus_box;
#line 95 "../src/Views/StylusView.vala"
		_tmp60_ = wacom_stylus_view_pressure_setting (self, _ ("Tip Pressure Feel"), "pressure-curve");
#line 95 "../src/Views/StylusView.vala"
		_tmp61_ = _tmp60_;
#line 95 "../src/Views/StylusView.vala"
		gtk_box_append (_tmp59_, (GtkWidget*) _tmp61_);
#line 95 "../src/Views/StylusView.vala"
		_g_object_unref0 (_tmp61_);
#line 579 "StylusView.c"
	}
#line 98 "../src/Views/StylusView.vala"
	_tmp62_ = test_button;
#line 98 "../src/Views/StylusView.vala"
	g_signal_connect_data (_tmp62_, "clicked", (GCallback) ___lambda7__gtk_button_clicked, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
#line 103 "../src/Views/StylusView.vala"
	_tmp63_ = _data1_->test_dialog;
#line 103 "../src/Views/StylusView.vala"
	g_signal_connect_data ((GtkDialog*) _tmp63_, "response", (GCallback) ___lambda8__gtk_dialog_response, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
#line 34 "../src/Views/StylusView.vala"
	_g_object_unref0 (header_box);
#line 34 "../src/Views/StylusView.vala"
	_g_object_unref0 (test_button);
#line 34 "../src/Views/StylusView.vala"
	_g_object_unref0 (header_label);
#line 34 "../src/Views/StylusView.vala"
	block1_data_unref (_data1_);
#line 34 "../src/Views/StylusView.vala"
	_data1_ = NULL;
#line 599 "StylusView.c"
}

static GtkBox*
wacom_stylus_view_button_setting (WacomStylusView* self,
                                  const gchar* label,
                                  const gchar* schema_key)
{
	GtkComboBoxText* button_combo = NULL;
	GtkComboBoxText* _tmp0_ = NULL;
	GtkLabel* setting_label = NULL;
	GtkWidget* _tmp1_;
	GtkLabel* _tmp2_ = NULL;
	GtkSizeGroup* _tmp3_;
	GtkBox* box = NULL;
	GtkBox* _tmp4_;
	GSettings* _tmp5_;
	GtkBox* result;
#line 106 "../src/Views/StylusView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 106 "../src/Views/StylusView.vala"
	g_return_val_if_fail (label != NULL, NULL);
#line 106 "../src/Views/StylusView.vala"
	g_return_val_if_fail (schema_key != NULL, NULL);
#line 107 "../src/Views/StylusView.vala"
	_tmp0_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
#line 107 "../src/Views/StylusView.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp0_, TRUE);
#line 107 "../src/Views/StylusView.vala"
	g_object_ref_sink (_tmp0_);
#line 107 "../src/Views/StylusView.vala"
	button_combo = _tmp0_;
#line 110 "../src/Views/StylusView.vala"
	gtk_combo_box_text_append (button_combo, "default", _ ("Default"));
#line 111 "../src/Views/StylusView.vala"
	gtk_combo_box_text_append (button_combo, "middle", _ ("Middle Mouse Button Click"));
#line 112 "../src/Views/StylusView.vala"
	gtk_combo_box_text_append (button_combo, "right", _ ("Right Mouse Button Click"));
#line 113 "../src/Views/StylusView.vala"
	gtk_combo_box_text_append (button_combo, "back", _ ("Back"));
#line 114 "../src/Views/StylusView.vala"
	gtk_combo_box_text_append (button_combo, "forward", _ ("Forward"));
#line 116 "../src/Views/StylusView.vala"
	_tmp1_ = _g_object_ref0 ((GtkWidget*) button_combo);
#line 116 "../src/Views/StylusView.vala"
	_tmp2_ = (GtkLabel*) gtk_label_new (label);
#line 116 "../src/Views/StylusView.vala"
	gtk_label_set_mnemonic_widget (_tmp2_, _tmp1_);
#line 116 "../src/Views/StylusView.vala"
	_g_object_unref0 (_tmp1_);
#line 116 "../src/Views/StylusView.vala"
	gtk_label_set_xalign (_tmp2_, (gfloat) 0);
#line 116 "../src/Views/StylusView.vala"
	g_object_ref_sink (_tmp2_);
#line 116 "../src/Views/StylusView.vala"
	setting_label = _tmp2_;
#line 121 "../src/Views/StylusView.vala"
	_tmp3_ = wacom_stylus_view_label_sizegroup;
#line 121 "../src/Views/StylusView.vala"
	gtk_size_group_add_widget (_tmp3_, (GtkWidget*) setting_label);
#line 123 "../src/Views/StylusView.vala"
	_tmp4_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 12);
#line 123 "../src/Views/StylusView.vala"
	g_object_ref_sink (_tmp4_);
#line 123 "../src/Views/StylusView.vala"
	box = _tmp4_;
#line 124 "../src/Views/StylusView.vala"
	gtk_box_append (box, (GtkWidget*) setting_label);
#line 125 "../src/Views/StylusView.vala"
	gtk_box_append (box, (GtkWidget*) button_combo);
#line 127 "../src/Views/StylusView.vala"
	_tmp5_ = self->priv->settings;
#line 127 "../src/Views/StylusView.vala"
	g_settings_bind (_tmp5_, schema_key, (GObject*) button_combo, "active-id", G_SETTINGS_BIND_DEFAULT);
#line 129 "../src/Views/StylusView.vala"
	result = box;
#line 129 "../src/Views/StylusView.vala"
	_g_object_unref0 (setting_label);
#line 129 "../src/Views/StylusView.vala"
	_g_object_unref0 (button_combo);
#line 129 "../src/Views/StylusView.vala"
	return result;
#line 681 "StylusView.c"
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 132 "../src/Views/StylusView.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 132 "../src/Views/StylusView.vala"
	return _data2_;
#line 691 "StylusView.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 132 "../src/Views/StylusView.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 701 "StylusView.c"
		WacomStylusView* self;
#line 132 "../src/Views/StylusView.vala"
		self = _data2_->self;
#line 132 "../src/Views/StylusView.vala"
		_g_object_unref0 (_data2_->scale);
#line 132 "../src/Views/StylusView.vala"
		_g_free0 (_data2_->schema_key);
#line 132 "../src/Views/StylusView.vala"
		_g_object_unref0 (self);
#line 132 "../src/Views/StylusView.vala"
		g_slice_free (Block2Data, _data2_);
#line 713 "StylusView.c"
	}
}

static void
__lambda6_ (Block2Data* _data2_)
{
	WacomStylusView* self;
#line 144 "../src/Views/StylusView.vala"
	self = _data2_->self;
#line 145 "../src/Views/StylusView.vala"
	wacom_stylus_view_on_pressure_value_changed (self, (gint) gtk_range_get_value ((GtkRange*) _data2_->scale), _data2_->schema_key);
#line 725 "StylusView.c"
}

static void
___lambda6__gtk_range_value_changed (GtkRange* _sender,
                                     gpointer self)
{
#line 144 "../src/Views/StylusView.vala"
	__lambda6_ (self);
#line 734 "StylusView.c"
}

static GtkBox*
wacom_stylus_view_pressure_setting (WacomStylusView* self,
                                    const gchar* label,
                                    const gchar* schema_key)
{
	Block2Data* _data2_;
	gchar* _tmp0_;
	GtkScale* _tmp1_ = NULL;
	GtkLabel* setting_label = NULL;
	GtkWidget* _tmp2_;
	GtkLabel* _tmp3_ = NULL;
	GtkSizeGroup* _tmp4_;
	GtkBox* box = NULL;
	GtkBox* _tmp5_;
	GtkBox* result;
#line 132 "../src/Views/StylusView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 132 "../src/Views/StylusView.vala"
	g_return_val_if_fail (label != NULL, NULL);
#line 132 "../src/Views/StylusView.vala"
	g_return_val_if_fail (schema_key != NULL, NULL);
#line 132 "../src/Views/StylusView.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 132 "../src/Views/StylusView.vala"
	_data2_->_ref_count_ = 1;
#line 132 "../src/Views/StylusView.vala"
	_data2_->self = g_object_ref (self);
#line 132 "../src/Views/StylusView.vala"
	_tmp0_ = g_strdup (schema_key);
#line 132 "../src/Views/StylusView.vala"
	_g_free0 (_data2_->schema_key);
#line 132 "../src/Views/StylusView.vala"
	_data2_->schema_key = _tmp0_;
#line 133 "../src/Views/StylusView.vala"
	_tmp1_ = (GtkScale*) gtk_scale_new_with_range (GTK_ORIENTATION_HORIZONTAL, (gdouble) 0, (gdouble) 6, (gdouble) 1);
#line 133 "../src/Views/StylusView.vala"
	gtk_scale_set_draw_value (_tmp1_, FALSE);
#line 133 "../src/Views/StylusView.vala"
	gtk_scale_set_has_origin (_tmp1_, FALSE);
#line 133 "../src/Views/StylusView.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp1_, TRUE);
#line 133 "../src/Views/StylusView.vala"
	gtk_range_set_round_digits ((GtkRange*) _tmp1_, 0);
#line 133 "../src/Views/StylusView.vala"
	g_object_ref_sink (_tmp1_);
#line 133 "../src/Views/StylusView.vala"
	_data2_->scale = _tmp1_;
#line 139 "../src/Views/StylusView.vala"
	gtk_scale_add_mark (_data2_->scale, (gdouble) 0, GTK_POS_BOTTOM, _ ("Soft"));
#line 140 "../src/Views/StylusView.vala"
	gtk_scale_add_mark (_data2_->scale, (gdouble) 6, GTK_POS_BOTTOM, _ ("Firm"));
#line 142 "../src/Views/StylusView.vala"
	wacom_stylus_view_set_pressure_scale_value_from_settings (self, _data2_->scale, _data2_->schema_key);
#line 144 "../src/Views/StylusView.vala"
	g_signal_connect_data ((GtkRange*) _data2_->scale, "value-changed", (GCallback) ___lambda6__gtk_range_value_changed, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 148 "../src/Views/StylusView.vala"
	_tmp2_ = _g_object_ref0 ((GtkWidget*) _data2_->scale);
#line 148 "../src/Views/StylusView.vala"
	_tmp3_ = (GtkLabel*) gtk_label_new (label);
#line 148 "../src/Views/StylusView.vala"
	gtk_label_set_mnemonic_widget (_tmp3_, _tmp2_);
#line 148 "../src/Views/StylusView.vala"
	_g_object_unref0 (_tmp2_);
#line 148 "../src/Views/StylusView.vala"
	gtk_label_set_xalign (_tmp3_, (gfloat) 0);
#line 148 "../src/Views/StylusView.vala"
	g_object_ref_sink (_tmp3_);
#line 148 "../src/Views/StylusView.vala"
	setting_label = _tmp3_;
#line 153 "../src/Views/StylusView.vala"
	_tmp4_ = wacom_stylus_view_label_sizegroup;
#line 153 "../src/Views/StylusView.vala"
	gtk_size_group_add_widget (_tmp4_, (GtkWidget*) setting_label);
#line 155 "../src/Views/StylusView.vala"
	_tmp5_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 12);
#line 155 "../src/Views/StylusView.vala"
	g_object_ref_sink (_tmp5_);
#line 155 "../src/Views/StylusView.vala"
	box = _tmp5_;
#line 156 "../src/Views/StylusView.vala"
	gtk_box_append (box, (GtkWidget*) setting_label);
#line 157 "../src/Views/StylusView.vala"
	gtk_box_append (box, (GtkWidget*) _data2_->scale);
#line 159 "../src/Views/StylusView.vala"
	result = box;
#line 159 "../src/Views/StylusView.vala"
	_g_object_unref0 (setting_label);
#line 159 "../src/Views/StylusView.vala"
	block2_data_unref (_data2_);
#line 159 "../src/Views/StylusView.vala"
	_data2_ = NULL;
#line 159 "../src/Views/StylusView.vala"
	return result;
#line 830 "StylusView.c"
}

static void
wacom_stylus_view_on_pressure_value_changed (WacomStylusView* self,
                                             gint new_value,
                                             const gchar* schema_key)
{
	gboolean _tmp0_ = FALSE;
	GVariant** values = NULL;
	gint _tmp1_;
	GVariant** _tmp2_;
	gint values_length1;
	gint _values_size_;
	GVariant* array = NULL;
	const GVariantType* _tmp9_;
	GVariant** _tmp10_;
	gint _tmp10__length1;
	GVariant* _tmp11_;
	GSettings* _tmp12_;
	GVariant* _tmp13_;
#line 162 "../src/Views/StylusView.vala"
	g_return_if_fail (self != NULL);
#line 162 "../src/Views/StylusView.vala"
	g_return_if_fail (schema_key != NULL);
#line 163 "../src/Views/StylusView.vala"
	if (new_value < 0) {
#line 163 "../src/Views/StylusView.vala"
		_tmp0_ = TRUE;
#line 859 "StylusView.c"
	} else {
#line 163 "../src/Views/StylusView.vala"
		_tmp0_ = new_value > 6;
#line 863 "StylusView.c"
	}
#line 163 "../src/Views/StylusView.vala"
	if (_tmp0_) {
#line 164 "../src/Views/StylusView.vala"
		return;
#line 869 "StylusView.c"
	}
#line 167 "../src/Views/StylusView.vala"
	_tmp1_ = G_N_ELEMENTS (WACOM_STYLUS_VIEW_PRESSURE_CURVES[0]);
#line 167 "../src/Views/StylusView.vala"
	_tmp2_ = g_new0 (GVariant*, _tmp1_ + 1);
#line 167 "../src/Views/StylusView.vala"
	values = _tmp2_;
#line 167 "../src/Views/StylusView.vala"
	values_length1 = _tmp1_;
#line 167 "../src/Views/StylusView.vala"
	_values_size_ = values_length1;
#line 881 "StylusView.c"
	{
		gint i = 0;
#line 170 "../src/Views/StylusView.vala"
		i = 0;
#line 886 "StylusView.c"
		{
			gboolean _tmp3_ = FALSE;
#line 170 "../src/Views/StylusView.vala"
			_tmp3_ = TRUE;
#line 170 "../src/Views/StylusView.vala"
			while (TRUE) {
#line 893 "StylusView.c"
				GVariant** _tmp5_;
				gint _tmp5__length1;
				GVariant** _tmp6_;
				gint _tmp6__length1;
				gint32 _tmp7_;
				GVariant* _tmp8_;
#line 170 "../src/Views/StylusView.vala"
				if (!_tmp3_) {
#line 902 "StylusView.c"
					gint _tmp4_;
#line 170 "../src/Views/StylusView.vala"
					_tmp4_ = i;
#line 170 "../src/Views/StylusView.vala"
					i = _tmp4_ + 1;
#line 908 "StylusView.c"
				}
#line 170 "../src/Views/StylusView.vala"
				_tmp3_ = FALSE;
#line 170 "../src/Views/StylusView.vala"
				_tmp5_ = values;
#line 170 "../src/Views/StylusView.vala"
				_tmp5__length1 = values_length1;
#line 170 "../src/Views/StylusView.vala"
				if (!(i < _tmp5__length1)) {
#line 170 "../src/Views/StylusView.vala"
					break;
#line 920 "StylusView.c"
				}
#line 171 "../src/Views/StylusView.vala"
				_tmp6_ = values;
#line 171 "../src/Views/StylusView.vala"
				_tmp6__length1 = values_length1;
#line 171 "../src/Views/StylusView.vala"
				_tmp7_ = WACOM_STYLUS_VIEW_PRESSURE_CURVES[new_value][i];
#line 171 "../src/Views/StylusView.vala"
				_tmp8_ = g_variant_new_int32 (_tmp7_);
#line 171 "../src/Views/StylusView.vala"
				g_variant_ref_sink (_tmp8_);
#line 171 "../src/Views/StylusView.vala"
				_g_variant_unref0 (_tmp6_[i]);
#line 171 "../src/Views/StylusView.vala"
				_tmp6_[i] = _tmp8_;
#line 936 "StylusView.c"
			}
		}
	}
#line 174 "../src/Views/StylusView.vala"
	_tmp9_ = G_VARIANT_TYPE_INT32;
#line 174 "../src/Views/StylusView.vala"
	_tmp10_ = values;
#line 174 "../src/Views/StylusView.vala"
	_tmp10__length1 = values_length1;
#line 174 "../src/Views/StylusView.vala"
	_tmp11_ = g_variant_new_array (_tmp9_, _tmp10_, _tmp10__length1);
#line 174 "../src/Views/StylusView.vala"
	g_variant_ref_sink (_tmp11_);
#line 174 "../src/Views/StylusView.vala"
	_g_variant_unref0 (array);
#line 174 "../src/Views/StylusView.vala"
	array = _tmp11_;
#line 175 "../src/Views/StylusView.vala"
	_tmp12_ = self->priv->settings;
#line 175 "../src/Views/StylusView.vala"
	_tmp13_ = array;
#line 175 "../src/Views/StylusView.vala"
	g_settings_set_value (_tmp12_, schema_key, _tmp13_);
#line 162 "../src/Views/StylusView.vala"
	_g_variant_unref0 (array);
#line 162 "../src/Views/StylusView.vala"
	values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_variant_unref), NULL);
#line 964 "StylusView.c"
}

static void
wacom_stylus_view_set_pressure_scale_value_from_settings (WacomStylusView* self,
                                                          GtkScale* scale,
                                                          const gchar* schema_key)
{
	GVariant* settings_value = NULL;
	GSettings* _tmp0_;
	GVariant* _tmp1_;
	GVariant* _tmp2_;
	gint _tmp3_;
	gint* values = NULL;
	gint _tmp5_;
	gint* _tmp6_;
	gint values_length1;
	gint _values_size_;
#line 178 "../src/Views/StylusView.vala"
	g_return_if_fail (self != NULL);
#line 178 "../src/Views/StylusView.vala"
	g_return_if_fail (scale != NULL);
#line 178 "../src/Views/StylusView.vala"
	g_return_if_fail (schema_key != NULL);
#line 179 "../src/Views/StylusView.vala"
	_tmp0_ = self->priv->settings;
#line 179 "../src/Views/StylusView.vala"
	_tmp1_ = g_settings_get_value (_tmp0_, schema_key);
#line 179 "../src/Views/StylusView.vala"
	settings_value = _tmp1_;
#line 180 "../src/Views/StylusView.vala"
	_tmp2_ = settings_value;
#line 180 "../src/Views/StylusView.vala"
	_tmp3_ = G_N_ELEMENTS (WACOM_STYLUS_VIEW_PRESSURE_CURVES[0]);
#line 180 "../src/Views/StylusView.vala"
	if (g_variant_n_children (_tmp2_) != ((gsize) _tmp3_)) {
#line 1000 "StylusView.c"
		gint _tmp4_;
#line 181 "../src/Views/StylusView.vala"
		_tmp4_ = G_N_ELEMENTS (WACOM_STYLUS_VIEW_PRESSURE_CURVES[0]);
#line 181 "../src/Views/StylusView.vala"
		g_warning ("StylusView.vala:181: Invalid pressure curve format, expected %d values", _tmp4_);
#line 182 "../src/Views/StylusView.vala"
		_g_variant_unref0 (settings_value);
#line 182 "../src/Views/StylusView.vala"
		return;
#line 1010 "StylusView.c"
	}
#line 185 "../src/Views/StylusView.vala"
	_tmp5_ = G_N_ELEMENTS (WACOM_STYLUS_VIEW_PRESSURE_CURVES[0]);
#line 185 "../src/Views/StylusView.vala"
	_tmp6_ = g_new0 (gint, _tmp5_);
#line 185 "../src/Views/StylusView.vala"
	values = _tmp6_;
#line 185 "../src/Views/StylusView.vala"
	values_length1 = _tmp5_;
#line 185 "../src/Views/StylusView.vala"
	_values_size_ = values_length1;
#line 1022 "StylusView.c"
	{
		gint i = 0;
#line 186 "../src/Views/StylusView.vala"
		i = 0;
#line 1027 "StylusView.c"
		{
			gboolean _tmp7_ = FALSE;
#line 186 "../src/Views/StylusView.vala"
			_tmp7_ = TRUE;
#line 186 "../src/Views/StylusView.vala"
			while (TRUE) {
#line 1034 "StylusView.c"
				gint _tmp9_;
				gint* _tmp10_;
				gint _tmp10__length1;
				GVariant* _tmp11_;
				GVariant* _tmp12_;
				GVariant* _tmp13_;
#line 186 "../src/Views/StylusView.vala"
				if (!_tmp7_) {
#line 1043 "StylusView.c"
					gint _tmp8_;
#line 186 "../src/Views/StylusView.vala"
					_tmp8_ = i;
#line 186 "../src/Views/StylusView.vala"
					i = _tmp8_ + 1;
#line 1049 "StylusView.c"
				}
#line 186 "../src/Views/StylusView.vala"
				_tmp7_ = FALSE;
#line 186 "../src/Views/StylusView.vala"
				_tmp9_ = G_N_ELEMENTS (WACOM_STYLUS_VIEW_PRESSURE_CURVES[0]);
#line 186 "../src/Views/StylusView.vala"
				if (!(i < _tmp9_)) {
#line 186 "../src/Views/StylusView.vala"
					break;
#line 1059 "StylusView.c"
				}
#line 187 "../src/Views/StylusView.vala"
				_tmp10_ = values;
#line 187 "../src/Views/StylusView.vala"
				_tmp10__length1 = values_length1;
#line 187 "../src/Views/StylusView.vala"
				_tmp11_ = settings_value;
#line 187 "../src/Views/StylusView.vala"
				_tmp12_ = g_variant_get_child_value (_tmp11_, (gsize) i);
#line 187 "../src/Views/StylusView.vala"
				_tmp13_ = _tmp12_;
#line 187 "../src/Views/StylusView.vala"
				_tmp10_[i] = (gint) g_variant_get_int32 (_tmp13_);
#line 187 "../src/Views/StylusView.vala"
				_g_variant_unref0 (_tmp13_);
#line 1075 "StylusView.c"
			}
		}
	}
	{
		gint i = 0;
#line 190 "../src/Views/StylusView.vala"
		i = 0;
#line 1083 "StylusView.c"
		{
			gboolean _tmp14_ = FALSE;
#line 190 "../src/Views/StylusView.vala"
			_tmp14_ = TRUE;
#line 190 "../src/Views/StylusView.vala"
			while (TRUE) {
#line 1090 "StylusView.c"
				gint _tmp16_;
				gboolean match = FALSE;
#line 190 "../src/Views/StylusView.vala"
				if (!_tmp14_) {
#line 1095 "StylusView.c"
					gint _tmp15_;
#line 190 "../src/Views/StylusView.vala"
					_tmp15_ = i;
#line 190 "../src/Views/StylusView.vala"
					i = _tmp15_ + 1;
#line 1101 "StylusView.c"
				}
#line 190 "../src/Views/StylusView.vala"
				_tmp14_ = FALSE;
#line 190 "../src/Views/StylusView.vala"
				_tmp16_ = G_N_ELEMENTS (WACOM_STYLUS_VIEW_PRESSURE_CURVES);
#line 190 "../src/Views/StylusView.vala"
				if (!(i < _tmp16_)) {
#line 190 "../src/Views/StylusView.vala"
					break;
#line 1111 "StylusView.c"
				}
#line 191 "../src/Views/StylusView.vala"
				match = TRUE;
#line 1115 "StylusView.c"
				{
					gint j = 0;
#line 192 "../src/Views/StylusView.vala"
					j = 0;
#line 1120 "StylusView.c"
					{
						gboolean _tmp17_ = FALSE;
#line 192 "../src/Views/StylusView.vala"
						_tmp17_ = TRUE;
#line 192 "../src/Views/StylusView.vala"
						while (TRUE) {
#line 1127 "StylusView.c"
							gint _tmp19_;
							gint* _tmp20_;
							gint _tmp20__length1;
							gint _tmp21_;
							gint32 _tmp22_;
#line 192 "../src/Views/StylusView.vala"
							if (!_tmp17_) {
#line 1135 "StylusView.c"
								gint _tmp18_;
#line 192 "../src/Views/StylusView.vala"
								_tmp18_ = j;
#line 192 "../src/Views/StylusView.vala"
								j = _tmp18_ + 1;
#line 1141 "StylusView.c"
							}
#line 192 "../src/Views/StylusView.vala"
							_tmp17_ = FALSE;
#line 192 "../src/Views/StylusView.vala"
							_tmp19_ = G_N_ELEMENTS (WACOM_STYLUS_VIEW_PRESSURE_CURVES[0]);
#line 192 "../src/Views/StylusView.vala"
							if (!(j < _tmp19_)) {
#line 192 "../src/Views/StylusView.vala"
								break;
#line 1151 "StylusView.c"
							}
#line 193 "../src/Views/StylusView.vala"
							_tmp20_ = values;
#line 193 "../src/Views/StylusView.vala"
							_tmp20__length1 = values_length1;
#line 193 "../src/Views/StylusView.vala"
							_tmp21_ = _tmp20_[j];
#line 193 "../src/Views/StylusView.vala"
							_tmp22_ = WACOM_STYLUS_VIEW_PRESSURE_CURVES[i][j];
#line 193 "../src/Views/StylusView.vala"
							if (_tmp21_ != ((gint) _tmp22_)) {
#line 194 "../src/Views/StylusView.vala"
								match = FALSE;
#line 195 "../src/Views/StylusView.vala"
								break;
#line 1167 "StylusView.c"
							}
						}
					}
				}
#line 199 "../src/Views/StylusView.vala"
				if (match) {
#line 200 "../src/Views/StylusView.vala"
					gtk_range_set_value ((GtkRange*) scale, (gdouble) i);
#line 201 "../src/Views/StylusView.vala"
					break;
#line 1178 "StylusView.c"
				}
			}
		}
	}
#line 178 "../src/Views/StylusView.vala"
	values = (g_free (values), NULL);
#line 178 "../src/Views/StylusView.vala"
	_g_variant_unref0 (settings_value);
#line 1187 "StylusView.c"
}

WacomStylusView*
wacom_stylus_view_construct (GType object_type)
{
	WacomStylusView * self = NULL;
#line 6 "../src/Views/StylusView.vala"
	self = (WacomStylusView*) g_object_new (object_type, NULL);
#line 6 "../src/Views/StylusView.vala"
	return self;
#line 1198 "StylusView.c"
}

WacomStylusView*
wacom_stylus_view_new (void)
{
#line 6 "../src/Views/StylusView.vala"
	return wacom_stylus_view_construct (WACOM_TYPE_STYLUS_VIEW);
#line 1206 "StylusView.c"
}

static GObject *
wacom_stylus_view_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	WacomStylusView * self;
	GtkBox* _tmp0_;
	GtkBox* _tmp1_;
#line 28 "../src/Views/StylusView.vala"
	parent_class = G_OBJECT_CLASS (wacom_stylus_view_parent_class);
#line 28 "../src/Views/StylusView.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 28 "../src/Views/StylusView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WACOM_TYPE_STYLUS_VIEW, WacomStylusView);
#line 29 "../src/Views/StylusView.vala"
	_tmp0_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 12);
#line 29 "../src/Views/StylusView.vala"
	g_object_ref_sink (_tmp0_);
#line 29 "../src/Views/StylusView.vala"
	_g_object_unref0 (self->priv->stylus_box);
#line 29 "../src/Views/StylusView.vala"
	self->priv->stylus_box = _tmp0_;
#line 31 "../src/Views/StylusView.vala"
	_tmp1_ = self->priv->stylus_box;
#line 31 "../src/Views/StylusView.vala"
	gtk_box_append ((GtkBox*) self, (GtkWidget*) _tmp1_);
#line 28 "../src/Views/StylusView.vala"
	return obj;
#line 1239 "StylusView.c"
}

static void
wacom_stylus_view_class_init (WacomStylusViewClass * klass,
                              gpointer klass_data)
{
	GtkSizeGroup* _tmp0_;
	WacomDeviceDatabase* _tmp1_;
#line 6 "../src/Views/StylusView.vala"
	wacom_stylus_view_parent_class = g_type_class_peek_parent (klass);
#line 6 "../src/Views/StylusView.vala"
	g_type_class_adjust_private_offset (klass, &WacomStylusView_private_offset);
#line 6 "../src/Views/StylusView.vala"
	G_OBJECT_CLASS (klass)->constructor = wacom_stylus_view_constructor;
#line 6 "../src/Views/StylusView.vala"
	G_OBJECT_CLASS (klass)->finalize = wacom_stylus_view_finalize;
#line 24 "../src/Views/StylusView.vala"
	_tmp0_ = gtk_size_group_new (GTK_SIZE_GROUP_HORIZONTAL);
#line 24 "../src/Views/StylusView.vala"
	_g_object_unref0 (wacom_stylus_view_label_sizegroup);
#line 24 "../src/Views/StylusView.vala"
	wacom_stylus_view_label_sizegroup = _tmp0_;
#line 25 "../src/Views/StylusView.vala"
	_tmp1_ = libwacom_database_new ();
#line 25 "../src/Views/StylusView.vala"
	_libwacom_database_destroy0 (wacom_stylus_view_wacom_db);
#line 25 "../src/Views/StylusView.vala"
	wacom_stylus_view_wacom_db = _tmp1_;
#line 1268 "StylusView.c"
}

static void
wacom_stylus_view_instance_init (WacomStylusView * self,
                                 gpointer klass)
{
#line 6 "../src/Views/StylusView.vala"
	self->priv = wacom_stylus_view_get_instance_private (self);
#line 1277 "StylusView.c"
}

static void
wacom_stylus_view_finalize (GObject * obj)
{
	WacomStylusView * self;
#line 6 "../src/Views/StylusView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WACOM_TYPE_STYLUS_VIEW, WacomStylusView);
#line 20 "../src/Views/StylusView.vala"
	_g_object_unref0 (self->priv->settings);
#line 21 "../src/Views/StylusView.vala"
	_g_object_unref0 (self->priv->stylus_box);
#line 6 "../src/Views/StylusView.vala"
	G_OBJECT_CLASS (wacom_stylus_view_parent_class)->finalize (obj);
#line 1292 "StylusView.c"
}

static GType
wacom_stylus_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WacomStylusViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) wacom_stylus_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WacomStylusView), 0, (GInstanceInitFunc) wacom_stylus_view_instance_init, NULL };
	GType wacom_stylus_view_type_id;
	wacom_stylus_view_type_id = g_type_register_static (gtk_box_get_type (), "WacomStylusView", &g_define_type_info, 0);
	WacomStylusView_private_offset = g_type_add_instance_private (wacom_stylus_view_type_id, sizeof (WacomStylusViewPrivate));
	return wacom_stylus_view_type_id;
}

GType
wacom_stylus_view_get_type (void)
{
	static volatile gsize wacom_stylus_view_type_id__once = 0;
	if (g_once_init_enter (&wacom_stylus_view_type_id__once)) {
		GType wacom_stylus_view_type_id;
		wacom_stylus_view_type_id = wacom_stylus_view_get_type_once ();
		g_once_init_leave (&wacom_stylus_view_type_id__once, wacom_stylus_view_type_id);
	}
	return wacom_stylus_view_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

