/* TabletView.c generated by valac 0.56.17, the Vala compiler
 * generated from TabletView.vala, do not modify */

/*
 * Copyright (c) 2019 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 */

#include "wacom.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>

#define WACOM_TABLET_VIEW_WACOM_TABLET_SCHEMA "org.gnome.desktop.peripherals.tablet"
#define WACOM_TABLET_VIEW_WACOM_SETTINGS_BASE "/org/gnome/desktop/peripherals/tablets/%s/"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	WACOM_TABLET_VIEW_0_PROPERTY,
	WACOM_TABLET_VIEW_DEVICE_KEY_PROPERTY,
	WACOM_TABLET_VIEW_NUM_PROPERTIES
};
static GParamSpec* wacom_tablet_view_properties[WACOM_TABLET_VIEW_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _WacomTabletViewPrivate {
	gchar* _device_key;
	GSettings* settings;
	GtkComboBoxText* tracking_mode_combo;
	GtkSwitch* left_handed_switch;
};

static gint WacomTabletView_private_offset;
static gpointer wacom_tablet_view_parent_class = NULL;

static GObject * wacom_tablet_view_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties);
static void wacom_tablet_view_finalize (GObject * obj);
static GType wacom_tablet_view_get_type_once (void);
static void _vala_wacom_tablet_view_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_wacom_tablet_view_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);

static inline gpointer
wacom_tablet_view_get_instance_private (WacomTabletView* self)
{
	return G_STRUCT_MEMBER_P (self, WacomTabletView_private_offset);
}

WacomTabletView*
wacom_tablet_view_construct (GType object_type)
{
	WacomTabletView * self = NULL;
#line 20 "../src/Views/TabletView.vala"
	self = (WacomTabletView*) g_object_new (object_type, NULL);
#line 20 "../src/Views/TabletView.vala"
	return self;
#line 93 "TabletView.c"
}

WacomTabletView*
wacom_tablet_view_new (void)
{
#line 20 "../src/Views/TabletView.vala"
	return wacom_tablet_view_construct (WACOM_TYPE_TABLET_VIEW);
#line 101 "TabletView.c"
}

const gchar*
wacom_tablet_view_get_device_key (WacomTabletView* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 26 "../src/Views/TabletView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 27 "../src/Views/TabletView.vala"
	_tmp0_ = self->priv->_device_key;
#line 27 "../src/Views/TabletView.vala"
	result = _tmp0_;
#line 27 "../src/Views/TabletView.vala"
	return result;
#line 117 "TabletView.c"
}

void
wacom_tablet_view_set_device_key (WacomTabletView* self,
                                  const gchar* value)
{
	gchar* _tmp0_;
	gchar* path = NULL;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	GSettings* _tmp4_;
	GSettings* _tmp5_;
	GtkComboBoxText* _tmp6_;
	GSettings* _tmp7_;
	GtkSwitch* _tmp8_;
#line 30 "../src/Views/TabletView.vala"
	g_return_if_fail (self != NULL);
#line 31 "../src/Views/TabletView.vala"
	_tmp0_ = g_strdup (value);
#line 31 "../src/Views/TabletView.vala"
	_g_free0 (self->priv->_device_key);
#line 31 "../src/Views/TabletView.vala"
	self->priv->_device_key = _tmp0_;
#line 33 "../src/Views/TabletView.vala"
	_tmp1_ = wacom_tablet_view_get_device_key (self);
#line 33 "../src/Views/TabletView.vala"
	_tmp2_ = _tmp1_;
#line 33 "../src/Views/TabletView.vala"
	_tmp3_ = g_strdup_printf (WACOM_TABLET_VIEW_WACOM_SETTINGS_BASE, _tmp2_);
#line 33 "../src/Views/TabletView.vala"
	path = _tmp3_;
#line 35 "../src/Views/TabletView.vala"
	_tmp4_ = g_settings_new_with_path (WACOM_TABLET_VIEW_WACOM_TABLET_SCHEMA, path);
#line 35 "../src/Views/TabletView.vala"
	_g_object_unref0 (self->priv->settings);
#line 35 "../src/Views/TabletView.vala"
	self->priv->settings = _tmp4_;
#line 36 "../src/Views/TabletView.vala"
	_tmp5_ = self->priv->settings;
#line 36 "../src/Views/TabletView.vala"
	_tmp6_ = self->priv->tracking_mode_combo;
#line 36 "../src/Views/TabletView.vala"
	g_settings_bind (_tmp5_, "mapping", (GObject*) _tmp6_, "active-id", G_SETTINGS_BIND_DEFAULT);
#line 37 "../src/Views/TabletView.vala"
	_tmp7_ = self->priv->settings;
#line 37 "../src/Views/TabletView.vala"
	_tmp8_ = self->priv->left_handed_switch;
#line 37 "../src/Views/TabletView.vala"
	g_settings_bind (_tmp7_, "left-handed", (GObject*) _tmp8_, "active", G_SETTINGS_BIND_DEFAULT);
#line 30 "../src/Views/TabletView.vala"
	_g_free0 (path);
#line 30 "../src/Views/TabletView.vala"
	g_object_notify_by_pspec ((GObject *) self, wacom_tablet_view_properties[WACOM_TABLET_VIEW_DEVICE_KEY_PROPERTY]);
#line 172 "TabletView.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 55 "../src/Views/TabletView.vala"
	return self ? g_object_ref (self) : NULL;
#line 180 "TabletView.c"
}

static GObject *
wacom_tablet_view_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	WacomTabletView * self;
	GtkComboBoxText* _tmp0_;
	GtkComboBoxText* _tmp1_;
	GtkComboBoxText* _tmp2_;
	GtkComboBoxText* _tmp3_;
	GtkLabel* tracking_mode_label = NULL;
	GtkComboBoxText* _tmp4_;
	GtkWidget* _tmp5_;
	GtkLabel* _tmp6_ = NULL;
	GtkSwitch* _tmp7_;
	GtkSwitch* _tmp8_;
	GtkLabel* left_handed_label = NULL;
	GtkSwitch* _tmp9_;
	GtkWidget* _tmp10_;
	GtkLabel* _tmp11_ = NULL;
	GtkLabel* _tmp12_;
	GtkComboBoxText* _tmp13_;
	GtkLabel* _tmp14_;
	GtkSwitch* _tmp15_;
#line 46 "../src/Views/TabletView.vala"
	parent_class = G_OBJECT_CLASS (wacom_tablet_view_parent_class);
#line 46 "../src/Views/TabletView.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 46 "../src/Views/TabletView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WACOM_TYPE_TABLET_VIEW, WacomTabletView);
#line 47 "../src/Views/TabletView.vala"
	gtk_grid_set_row_spacing ((GtkGrid*) self, 12);
#line 48 "../src/Views/TabletView.vala"
	gtk_grid_set_column_spacing ((GtkGrid*) self, 12);
#line 50 "../src/Views/TabletView.vala"
	_tmp0_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
#line 50 "../src/Views/TabletView.vala"
	g_object_ref_sink (_tmp0_);
#line 50 "../src/Views/TabletView.vala"
	_g_object_unref0 (self->priv->tracking_mode_combo);
#line 50 "../src/Views/TabletView.vala"
	self->priv->tracking_mode_combo = _tmp0_;
#line 51 "../src/Views/TabletView.vala"
	_tmp1_ = self->priv->tracking_mode_combo;
#line 51 "../src/Views/TabletView.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp1_, TRUE);
#line 52 "../src/Views/TabletView.vala"
	_tmp2_ = self->priv->tracking_mode_combo;
#line 52 "../src/Views/TabletView.vala"
	gtk_combo_box_text_append (_tmp2_, "absolute", _ ("Tablet (absolute)"));
#line 53 "../src/Views/TabletView.vala"
	_tmp3_ = self->priv->tracking_mode_combo;
#line 53 "../src/Views/TabletView.vala"
	gtk_combo_box_text_append (_tmp3_, "relative", _ ("Touchpad (relative)"));
#line 55 "../src/Views/TabletView.vala"
	_tmp4_ = self->priv->tracking_mode_combo;
#line 55 "../src/Views/TabletView.vala"
	_tmp5_ = _g_object_ref0 ((GtkWidget*) _tmp4_);
#line 55 "../src/Views/TabletView.vala"
	_tmp6_ = (GtkLabel*) gtk_label_new (_ ("Tracking Mode"));
#line 55 "../src/Views/TabletView.vala"
	gtk_label_set_mnemonic_widget (_tmp6_, _tmp5_);
#line 55 "../src/Views/TabletView.vala"
	_g_object_unref0 (_tmp5_);
#line 55 "../src/Views/TabletView.vala"
	gtk_label_set_xalign (_tmp6_, (gfloat) 0);
#line 55 "../src/Views/TabletView.vala"
	g_object_ref_sink (_tmp6_);
#line 55 "../src/Views/TabletView.vala"
	tracking_mode_label = _tmp6_;
#line 60 "../src/Views/TabletView.vala"
	_tmp7_ = (GtkSwitch*) gtk_switch_new ();
#line 60 "../src/Views/TabletView.vala"
	g_object_ref_sink (_tmp7_);
#line 60 "../src/Views/TabletView.vala"
	_g_object_unref0 (self->priv->left_handed_switch);
#line 60 "../src/Views/TabletView.vala"
	self->priv->left_handed_switch = _tmp7_;
#line 61 "../src/Views/TabletView.vala"
	_tmp8_ = self->priv->left_handed_switch;
#line 61 "../src/Views/TabletView.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp8_, GTK_ALIGN_START);
#line 63 "../src/Views/TabletView.vala"
	_tmp9_ = self->priv->left_handed_switch;
#line 63 "../src/Views/TabletView.vala"
	_tmp10_ = _g_object_ref0 ((GtkWidget*) _tmp9_);
#line 63 "../src/Views/TabletView.vala"
	_tmp11_ = (GtkLabel*) gtk_label_new (_ ("Left Hand Orientation"));
#line 63 "../src/Views/TabletView.vala"
	gtk_label_set_mnemonic_widget (_tmp11_, _tmp10_);
#line 63 "../src/Views/TabletView.vala"
	_g_object_unref0 (_tmp10_);
#line 63 "../src/Views/TabletView.vala"
	gtk_label_set_xalign (_tmp11_, (gfloat) 0);
#line 63 "../src/Views/TabletView.vala"
	g_object_ref_sink (_tmp11_);
#line 63 "../src/Views/TabletView.vala"
	left_handed_label = _tmp11_;
#line 68 "../src/Views/TabletView.vala"
	_tmp12_ = tracking_mode_label;
#line 68 "../src/Views/TabletView.vala"
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp12_, 0, 0, 1, 1);
#line 69 "../src/Views/TabletView.vala"
	_tmp13_ = self->priv->tracking_mode_combo;
#line 69 "../src/Views/TabletView.vala"
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp13_, 1, 0, 1, 1);
#line 70 "../src/Views/TabletView.vala"
	_tmp14_ = left_handed_label;
#line 70 "../src/Views/TabletView.vala"
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp14_, 0, 1, 1, 1);
#line 71 "../src/Views/TabletView.vala"
	_tmp15_ = self->priv->left_handed_switch;
#line 71 "../src/Views/TabletView.vala"
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp15_, 1, 1, 1, 1);
#line 46 "../src/Views/TabletView.vala"
	_g_object_unref0 (left_handed_label);
#line 46 "../src/Views/TabletView.vala"
	_g_object_unref0 (tracking_mode_label);
#line 46 "../src/Views/TabletView.vala"
	return obj;
#line 305 "TabletView.c"
}

static void
wacom_tablet_view_class_init (WacomTabletViewClass * klass,
                              gpointer klass_data)
{
#line 20 "../src/Views/TabletView.vala"
	wacom_tablet_view_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/Views/TabletView.vala"
	g_type_class_adjust_private_offset (klass, &WacomTabletView_private_offset);
#line 20 "../src/Views/TabletView.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_wacom_tablet_view_get_property;
#line 20 "../src/Views/TabletView.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_wacom_tablet_view_set_property;
#line 20 "../src/Views/TabletView.vala"
	G_OBJECT_CLASS (klass)->constructor = wacom_tablet_view_constructor;
#line 20 "../src/Views/TabletView.vala"
	G_OBJECT_CLASS (klass)->finalize = wacom_tablet_view_finalize;
#line 20 "../src/Views/TabletView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WACOM_TABLET_VIEW_DEVICE_KEY_PROPERTY, wacom_tablet_view_properties[WACOM_TABLET_VIEW_DEVICE_KEY_PROPERTY] = g_param_spec_string ("device-key", "device-key", "device-key", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 326 "TabletView.c"
}

static void
wacom_tablet_view_instance_init (WacomTabletView * self,
                                 gpointer klass)
{
#line 20 "../src/Views/TabletView.vala"
	self->priv = wacom_tablet_view_get_instance_private (self);
#line 335 "TabletView.c"
}

static void
wacom_tablet_view_finalize (GObject * obj)
{
	WacomTabletView * self;
#line 20 "../src/Views/TabletView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WACOM_TYPE_TABLET_VIEW, WacomTabletView);
#line 24 "../src/Views/TabletView.vala"
	_g_free0 (self->priv->_device_key);
#line 41 "../src/Views/TabletView.vala"
	_g_object_unref0 (self->priv->settings);
#line 43 "../src/Views/TabletView.vala"
	_g_object_unref0 (self->priv->tracking_mode_combo);
#line 44 "../src/Views/TabletView.vala"
	_g_object_unref0 (self->priv->left_handed_switch);
#line 20 "../src/Views/TabletView.vala"
	G_OBJECT_CLASS (wacom_tablet_view_parent_class)->finalize (obj);
#line 354 "TabletView.c"
}

static GType
wacom_tablet_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WacomTabletViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) wacom_tablet_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WacomTabletView), 0, (GInstanceInitFunc) wacom_tablet_view_instance_init, NULL };
	GType wacom_tablet_view_type_id;
	wacom_tablet_view_type_id = g_type_register_static (gtk_grid_get_type (), "WacomTabletView", &g_define_type_info, 0);
	WacomTabletView_private_offset = g_type_add_instance_private (wacom_tablet_view_type_id, sizeof (WacomTabletViewPrivate));
	return wacom_tablet_view_type_id;
}

GType
wacom_tablet_view_get_type (void)
{
	static volatile gsize wacom_tablet_view_type_id__once = 0;
	if (g_once_init_enter (&wacom_tablet_view_type_id__once)) {
		GType wacom_tablet_view_type_id;
		wacom_tablet_view_type_id = wacom_tablet_view_get_type_once ();
		g_once_init_leave (&wacom_tablet_view_type_id__once, wacom_tablet_view_type_id);
	}
	return wacom_tablet_view_type_id__once;
}

static void
_vala_wacom_tablet_view_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	WacomTabletView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WACOM_TYPE_TABLET_VIEW, WacomTabletView);
#line 20 "../src/Views/TabletView.vala"
	switch (property_id) {
#line 20 "../src/Views/TabletView.vala"
		case WACOM_TABLET_VIEW_DEVICE_KEY_PROPERTY:
#line 20 "../src/Views/TabletView.vala"
		g_value_set_string (value, wacom_tablet_view_get_device_key (self));
#line 20 "../src/Views/TabletView.vala"
		break;
#line 395 "TabletView.c"
		default:
#line 20 "../src/Views/TabletView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/Views/TabletView.vala"
		break;
#line 401 "TabletView.c"
	}
}

static void
_vala_wacom_tablet_view_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	WacomTabletView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WACOM_TYPE_TABLET_VIEW, WacomTabletView);
#line 20 "../src/Views/TabletView.vala"
	switch (property_id) {
#line 20 "../src/Views/TabletView.vala"
		case WACOM_TABLET_VIEW_DEVICE_KEY_PROPERTY:
#line 20 "../src/Views/TabletView.vala"
		wacom_tablet_view_set_device_key (self, g_value_get_string (value));
#line 20 "../src/Views/TabletView.vala"
		break;
#line 421 "TabletView.c"
		default:
#line 20 "../src/Views/TabletView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/Views/TabletView.vala"
		break;
#line 427 "TabletView.c"
	}
}

